<?php
/**
 * Plugin cibloc
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/meta');


/**
 * Fonction d'installation
 *
 * @param unknown_type $nom_meta_base_version
 * @param unknown_type $version_cible
 */
function cibloc_upgrade($nom_meta_base_version,$version_cible){
        $current_version = '0.0';
    
	if ( (!isset($GLOBALS['meta'][$nom_meta_base_version]) )
			|| (($current_version = $GLOBALS['meta'][$nom_meta_base_version])!=$version_cible)){
                $maj = false;
		if (version_compare($current_version,'2.0','<')){
			include_spip('base/cibloc_tables');			
			include_spip('base/create');
			include_spip('base/abstract_sql');
			creer_base();
                        $maj = true;
                } elseif (version_compare($current_version,'2.0.1','<')){
        		sql_alter('TABLE spip_cibloc_objets CHANGE id id varchar(50) NOT NULL');
		}
                
		effacer_meta($nom_meta_base_version);
		ecrire_meta($nom_meta_base_version,$current_version=$version_cible,'non');
		spip_log("cibloc : installation version ".$version_cible);
                if ($maj){
                        cibloc_purge();

                        // subtilite de SPIP 3.0 et 3.1
                        if (spip_version()>=3.0 AND spip_version()<3.2) {
                            include_spip('inc/invalideur');
                            purger_repertoire(_DIR_VAR . 'cache-css');
                        }
                }
	}
}

/**
 * Fonction de desinstallation
 *
 * @param unknown_type $nom_meta_base_version
 */
function cibloc_vider_tables($nom_meta_base_version) {
        cibloc_purge();
        effacer_meta($nom_meta_base_version);
}

/**
 * Fonction de purge
 */
function cibloc_purge() {
        include_spip('inc/cibloc_commun');
        include_spip('inc/filtres');

        // Subtilite de SPIP 3.0 et 3.1 :
        // Porte plume n'utilise pas la fonction produire pour ses fichiers js et css
        // Dans ce cas, il faut les supprimer dans tmp/cache/... 
        if (spip_version()>=3.0 AND spip_version()<3.2) {
        	include_spip('public/cacher');
        	include_spip('public/assembler');
                $contexte = array("lang" => $GLOBALS['spip_lang']);
                $contexte_implicite = calculer_contexte_implicite();
                
                $contexte_implicite["cache"] = "porte_plume_start.js";
                $page = array("contexte_implicite" => $contexte_implicite);                
                cibloc_supprimer_un_fichier_du_cache($contexte, $page);

                $contexte_implicite["cache"] = "barre_outils_icones.css";
                $page = array("contexte_implicite" => $contexte_implicite);                
                cibloc_supprimer_un_fichier_du_cache($contexte, $page);
        }
        
        cibloc_purger_cache_css();
        
        cibloc_purger_definition_cache();
        
        if (spip_version()>=3.2) {
            cibloc_purger_cache_js();
        } else {
            // subtilite de SPIP 3.0 et 3.1
            include_spip('inc/invalideur');
            purger_repertoire(_DIR_VAR . 'cache-js');
        }
}

function cibloc_supprimer_un_fichier_du_cache($contexte, $page){
    $return = true;
    
    if (spip_version()>=3.1) {
        $nom_cache = generer_nom_fichier_cache($contexte, $page);
        $d = substr($nom_cache, 0, 2);
        $u = substr($nom_cache, 2, 2);
        $return = supprimer_fichier(_DIR_CACHE . "$d/$u.cache");
    } else {
        $chemin_cache = generer_nom_fichier_cache($contexte, $page);
        $return = supprimer_fichier(_DIR_CACHE . $chemin_cache);
    }
    
    return $return;
}

?>