<?php
/**
 * Plugin cid : Fonctions diverses
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('action/editer_article');
include_spip('action/editer_objet');
include_spip('action/editer_logo');

function action_cid_vider_dist() {
        $articles = array();
        $documents = array();

	$securiser_action = charger_fonction('securiser_action', 'inc');
	$id_rubrique = $securiser_action();

	if ($id_rubrique = intval($id_rubrique)) {
                include_spip('inc/cid_inc_commun');
                // Si on a le droit
                if (cid_droit_suppr_facile_rubrique($id_rubrique)){

                        // Memoriser pour la trace
                        if (defined('_DIR_PLUGIN_CITRACE')){
                            $result = sql_select('id_article', 'spip_articles', 'id_rubrique='.$id_rubrique);
                            while ($row = sql_fetch($result))
                                    $articles[] = $row['id_article'];
                            
                            $result = sql_select('id_document', 'spip_documents_liens', "id_objet=".$id_rubrique." AND objet='rubrique'");
                            while ($row = sql_fetch($result))
                                    $documents[] = $row['id_document'];
                        }
                        
                        // mettre les articles a la poubelle (y compris les articles archives)
//                        sql_updateq('spip_articles', array('statut'=>'poubelle'), "id_rubrique=$id_rubrique");
                        $result = sql_select('id_article', 'spip_articles', 'id_rubrique='.$id_rubrique);
                        while ($row = sql_fetch($result)){
                            article_instituer($row['id_article'], array('statut'=>'poubelle'), false);
                        }
                        
                        
                        // mettre le statut refuse aux breves
                       	if (defined('_DIR_PLUGIN_BREVES') 
                                OR ($GLOBALS['spip_version_branche']<3 AND $GLOBALS['meta']['activer_breves']=='oui{')){
//                            sql_updateq('spip_breves', array('statut'=>'refuse'), "id_rubrique=$id_rubrique");
                            $result = sql_select('id_breve', 'spip_breves', 'id_rubrique='.$id_rubrique);
                            while ($row = sql_fetch($result)){
                                objet_instituer('breve', $row['id_breve'], array('statut'=>'refuse'));
                            }
                        }
                        
                        // mettre le statut refuse aux sites references
                       	if (defined('_DIR_PLUGIN_SITES') 
                                OR ($GLOBALS['spip_version_branche']<3 AND $GLOBALS['meta']['activer_sites']=='oui')){
//                            sql_updateq('spip_syndic', array('statut'=>'refuse'), "id_rubrique=$id_rubrique");
                            $result = sql_select('id_syndic', 'spip_syndic', 'id_rubrique='.$id_rubrique);
                            while ($row = sql_fetch($result)){
                                objet_instituer('syndic', $row['id_syndic'], array('statut'=>'refuse'));
                            }
                        }
                        
                        // detacher les documents de la rubrique
               		sql_delete("spip_documents_liens", "id_objet=".$id_rubrique." AND objet='rubrique'");

                        // supprimer le logo de la rubrique
                        cid_supprimer_logo('rubrique',$id_rubrique);

                        // invalider les caches de cette rubrique
                        include_spip('inc/invalideur');
                        suivre_invalideur("id='rubrique/$id_rubrique'");

                        // tracer
                        if (defined('_DIR_PLUGIN_CITRACE')){
                                if ($citrace = charger_fonction('citrace', 'inc')) {
                                        include_spip('inc/texte');
					$row = sql_fetsel('titre', 'spip_rubriques', 'id_rubrique='.$id_rubrique);
                                        $titre_rubrique = interdire_scripts(supprimer_numero($row['titre']));
                                        $message = '('.$titre_rubrique.')';							
                                        $citrace('rubrique', $id_rubrique, 'vider rubrique', $message, $id_rubrique);
                                        
                                        foreach ($articles as $id_article){
                                            $row = sql_fetsel('titre', 'spip_articles', 'id_article='.$id_article);
                                            $article_msg = '('.interdire_scripts(supprimer_numero($row['titre'])).')'." - id_rubrique:".$id_rubrique.' - vider la rubrique' ;
                                            $citrace('article', $id_article, 'poubelle article', $article_msg, $id_rubrique);
                                        }
                                        
                                        foreach ($documents as $id_document){
                                            $row = sql_fetsel('fichier', 'spip_documents', 'id_document='.$id_document);
                                            $commentaire = '('.$row['fichier'].')';
                                            $citrace('document', $id_document, 'delier document', $commentaire, $id_rubrique);
                                        }
                                }
                        }
		}
	}

	return true;
}


function cid_supprimer_logo($objet,$id_objet){
        logo_supprimer($objet, $id_objet, 'on');
        logo_supprimer($objet, $id_objet, 'off');
}

?>