<?php
/**
 * Plugin Publication multi-sites avec filtrage par rubrique
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;


/**
 * Purge complete par exemple en cas de changement de version
 */
function cims_purge() {

	include_spip('inc/invalideur');

	spip_log("Purger");
/*
	supprime_invalideurs();
	spip_unlink(_CACHE_RUBRIQUES);
	purger_repertoire(_DIR_CACHE);
*/
	purger_repertoire(_DIR_SKELS);

}


/**
 * Affecter aux rubriques existantes le site figurant dans cimonoversmultisites
 */
function cims_monoversmultisites() {
	$tableau_config = cims_lire_config();

	if (isset($tableau_config['cimonoversmultisites'])) {
		if ($tableau_config['cimonoversmultisites']=='oui') {
			if (isset($tableau_config['cisite'])) {
				$ci_site = $tableau_config['cisite'];
				if (!$ci_site=="") {
					$exist = false;

					// verifier si le site n'est pas deja affecte a au moins une rubrique
					$result = sql_select("id_rubrique", "spip_cims_multisites", "multisite='$ci_site'","","");
					while ($row = @sql_fetch($result)) {
						$exist = true;
						break;
					}

					// alimenter spip_cims_multisites
					if (!$exist) {
						$result = sql_select("id_rubrique", "spip_rubriques", "","id_rubrique","");
						while ($row = @sql_fetch($result)) {
							$id_rubrique = $row['id_rubrique'];
							sql_insertq('spip_cims_multisites', array('id_rubrique' => $id_rubrique, 'multisite' => $ci_site));
						}
					}
				}
			}
		}
	}
	return true;	
}


/**
 * Migrer le bandeau de chaque site
 *
 */
function cims_migrer_bandeau() {
	
	$tableau_config = cims_lire_config();
	$rang = 0;

	if (isset($tableau_config['cilistedessites'])) {
		if (is_array($tableau_config['cilistedessites'])) {
			foreach ($tableau_config['cilistedessites'] as $site) {
				$rang++;
				$origine = _DIR_IMG . $site . '/perso_bandeau.jpg';
				$destination = _DIR_IMG . 'siteon-'.$rang.'.jpg';
				if (file_exists($origine) AND !file_exists($destination)) {
					@rename($origine, $destination);
				}				
			}
		}
	}

}


?>