<?php
/**
 * Plugin Publication multi-sites avec filtrage par rubrique
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('base/abstract_sql');


/**
 * Selectionne toutes les rubriques qui correspondent au site en cours
 */
function cims_tableau_rubriques_du_site($publique=true, $id_auteur=NULL) {
	static $tableau_rubriques = array();

	if (!$tableau_rubriques) {
		
		// liste des rubriques du site
		$tableau_rubriques = array(0);

		$ci_site = cims_site_en_cours();
		$result = sql_select("id_rubrique", "spip_cims_multisites", "multisite='$ci_site'","id_rubrique","");
		while ($row = @sql_fetch($result)) {
			$tableau_rubriques[] = $row['id_rubrique'];
		}
	}

    return $tableau_rubriques;
}


/**
 * Selectionne toutes les sites qui correspondent a la rubrique
 */
function cims_tableau_sites_de_la_rubrique($id_rubrique) {
	$tableau_sites = array();

	if ($id_rubrique = intval($id_rubrique)){
		$result = sql_select("multisite", "spip_cims_multisites", "id_rubrique=".$id_rubrique,"multisite","");
		while ($row = @sql_fetch($result))
			$tableau_sites[] = $row['multisite'];
	}

    return $tableau_sites;
}

?>