<?php
/**
 * Plugin Configurateur de squelettes
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/config');
include_spip('inc/ciparam_inc_logos');
include_spip('inc/plugin');
include_spip('inc/ciparam_inc_commun');
include_spip('inc/ciparam_inc_meta');


function configuration_ciparam_squelettes_dist(){
	global $spip_lang_left;
	
	$ci_motcle_accueil = entites_html(ciparam_lire_meta("ci_motcle_accueil"));	
	$ci_nom_bandeau = entites_html(ciparam_lire_meta("ci_nom_bandeau"));	
	$ci_abonnement_xiti = entites_html(trim(ciparam_lire_meta("ci_abonnement_xiti")));	
	$ci_xiti_rss = entites_html(trim(ciparam_lire_meta("ci_xiti_rss")));	
	$ci_xiti_email = entites_html(trim(ciparam_lire_meta("ci_xiti_email")));	
	$ci_nbactu = entites_html(ciparam_lire_meta("ci_nbactu"));
	$ci_menu_niveau = entites_html(ciparam_lire_meta("ci_menu_niveau"));	
	$ci_haut = entites_html(ciparam_lire_meta("ci_haut"));
	$ci_piwik_url = entites_html(trim(ciparam_lire_meta("ci_piwik_url")));	
	$ci_piwik_id = entites_html(trim(ciparam_lire_meta("ci_piwik_id")));	
	
	$action = generer_url_ecrire('ciparam_config');


	$class3 = '';
        $res = '';
        $class3 = ' text';
        $res .= '<div class="formulaire_spip">';
        $res .= '<h3 class="titrem">'._T('ciparam:titre').'</h3>';
	
	$res .= "<form action='$action' method='post'><div>".form_hidden($action)
	. "<input type='hidden' name='changer_config' value='oui' /></div>";

	$res .= "\n<table>";
	
    // Mots dans les META de la page d'accueil
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='ci_motcle_accueil'>"._T('ciparam:texte_motcle_accueil')."</label><br />"
	. " <input type='text' name='ci_motcle_accueil' id='ci_motcle_accueil' value=\"$ci_motcle_accueil\" size='40' class='formo$class3' /><br />"
	. "</td></tr>";


	// Nom du site dans le bandeau
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='ci_nom_bandeau'>"._T('ciparam:texte_nom_bandeau')."</label><br />"
	. " <input type='text' name='ci_nom_bandeau' id='ci_nom_bandeau' value=\"$ci_nom_bandeau\" size='40' class='formo$class3' /><br />"
	. "</td></tr>";

    // Nombre d'actu
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='ci_nbactu'>"._T('ciparam:texte_nbactu')."</label><br />"
	. " <input type='text' name='ci_nbactu' id='ci_nbactu' value=\"$ci_nbactu\" size='40' class='formo$class3' /><br />"
	. "</td></tr>";

    // nombre de niveaux dans le plan    
        $res .= ciparam_choix_plan_niveau();
        
	$res .= "\n</table>";

    // Marqueurs pour les statistiques (Xiti, Piwik)
    	if (spip_version()<3)
            $res .= debut_cadre_relief("", true, "", _T('ciparam:marqueurs'));
        else    
            $res .= '<h3 class="titrem">'._T('ciparam:marqueurs').'</h3>';
        
        
	$res .= "\n<table>";
        
    // Xiti
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='ci_abonnement_xiti'>"._T('ciparam:texte_abonnement_xiti')."</label><br />";
		// s'il existe un fichier de parametrage xiti avec un contenu diff�rent de la valeur par defaut, alors lecture seule	
		if (ciparam_lire_config_fichier('cixiti')!="" AND !preg_match(",_images,",ciparam_lire_config_fichier('cixiti'))) {
			$res .= ciparam_lire_config_fichier("cixiti")."<br />";
		} else {
			$res .= "<input type='text' name='ci_abonnement_xiti' id='ci_abonnement_xiti' value=\"$ci_abonnement_xiti\" size='40' class='formo$class3' /><br />";
		}	
		$res .= "</td></tr>";
	
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='ci_xiti_rss'>"._T('ciparam:texte_xiti_rss')."</label><br />";
		// s'il existe un fichier de parametrage xiti_rss avec un contenu diff�rent de la valeur par defaut, alors lecture seule	
		if (defined('_CI_XITI_RSS')) {
			$res .= _CI_XITI_RSS."<br />";
		} else {
			$res .= "<input type='text' name='ci_xiti_rss' id='ci_xiti_rss' value=\"$ci_xiti_rss\" size='40' class='formo$class3' /><br />";
		}	
		$res .= "</td></tr>";

	if (defined('_DIR_PLUGIN_CINOTIF')){
		$res .= "\n<tr><td class='verdana2'>"
		. "<label for='ci_xiti_email'>"._T('ciparam:texte_xiti_email')."</label><br />";
			// s'il existe un fichier de parametrage xiti_email avec un contenu diff�rent de la valeur par defaut, alors lecture seule	
		if (defined('_CI_XITI_EMAIL')) {
			$res .= _CI_XITI_EMAIL."<br />";
		} else {
			$res .= "<input type='text' name='ci_xiti_email' id='ci_xiti_email' value=\"$ci_xiti_email\" size='40' class='formo$class3' /><br />";
		}	
		$res .= "</td></tr>";
	}

        
    // Piwik
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='ci_piwik_url'>"._T('ciparam:texte_piwik_url')."</label><br />";
		// s'il existe un fichier de parametrage piwik avec un contenu different de la valeur par defaut, alors lecture seule	
		if (defined('_CIPARAM_PIWIK_URL') AND _CIPARAM_PIWIK_URL) {
			$res .= entites_html(_CIPARAM_PIWIK_URL)."<br />";
		} else {
			$res .= "<input type='text' name='ci_piwik_url' id='ci_piwik_url' value=\"$ci_piwik_url\" size='40' class='formo$class3' /><br />";
		}	
		$res .= "</td></tr>";
        
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='ci_piwik_id'>"._T('ciparam:texte_piwik_id')."</label><br />";
		// s'il existe un fichier de parametrage piwik avec un contenu different de la valeur par defaut, alors lecture seule	
                $disabled = "";
                if (defined('_CI_SEN') AND _CI_SEN=='oui'){
                    if (!autoriser('webmestre')){
                        $disabled = "disabled='disabled'";
                    }
                }
                
                if (defined('_CIPARAM_PIWIK_ID') AND intval(_CIPARAM_PIWIK_ID)>0) {
                        $res .= intval(_CIPARAM_PIWIK_ID)."<br />";
                } else {
                        $res .= "<input type='text' name='ci_piwik_id' id='ci_piwik_id' value=\"$ci_piwik_id\" size='40' class='formo$class3' ".$disabled." /><br />";
                }	
		$res .= "</td></tr>";
                
                
	$res .= "\n</table>\n";
	
	if (spip_version()<3)
            $res .= fin_cadre_relief(true);              
	
    // Nombre de niveaux de menu
	$res .= ciparam_choix_menu_niveau();


    // Haut de page (largeur de menu)
	$res .= ciparam_choix_haut();

	
    // Masquer certains elements
	$res .= ciparam_choix_masquer();


    // Types de colonnes
    if(ciparam_chemin_param_xml("navigations-rubriques")
    	OR ciparam_chemin_param_xml("navigations-articles")
    	OR ciparam_chemin_param_xml("extras-rubriques")
    	OR ciparam_chemin_param_xml("extras-articles")) {

        if(ciparam_charger_param_xml("navigations-rubriques")
            OR ciparam_charger_param_xml("navigations-articles")
            OR ciparam_charger_param_xml("extras-rubriques")
            OR ciparam_charger_param_xml("extras-articles")) {
        
                if (spip_version()<3)
                    $res .= debut_cadre_relief("", true, "", _T('ciparam:texte_colonne'));
                else
                    $res .= '<br/><h3 class="titrem">'._T('ciparam:texte_colonne').'</h3>';

                $res .= ciparam_choix_extra_navigation('rubrique','navigation')."<br />\n";
                $res .= "<br />\n".ciparam_choix_extra_navigation('rubrique','extra')."<br />\n";
                $res .= "<br />\n".ciparam_choix_extra_navigation('article','navigation')."<br />\n";
                $res .= "<br />\n".ciparam_choix_extra_navigation('article','extra')."<br />\n";

                if (spip_version()<3)
                    $res .= fin_cadre_relief(true);              
            }
        }

	// Sauts de lignes consecutifs
	$res .= ciparam_choix_sauts_lignes();
	
	$res .= "<br /><p class='boutons'><span class='image_loading'>&nbsp;</span><input type='submit' class='submit' value='"._T('bouton_enregistrer')."' /></p>";
	$res .= "</form>";
	$res .= '</div>';
        
	return $res;
}


function ciparam_choix_menu_niveau() {
	$texte = "";
	$valeur_niveau = "";
	$valeur_type = "";
	$valeur_type_par_constante = false;
	
	$niveaux = ciparam_charger_param_xml("menu-niveaux");
	$valeur_niveau = ciparam_lire_meta("ci_menu_niveau");	

	$types = ciparam_charger_param_xml("menu-types");        
   	$valeur_type = ciparam_lire_meta("ci_menu_type");
	if (!$valeur_type) $valeur_type = "smartmenu";

        // Parametrage par constante dans un fichier d'options
	if (defined("_CIPARAM_MENU_TYPE") AND in_array(_CIPARAM_MENU_TYPE, array("smartmenu","megamenu","superfish"))){
		$valeur_type = _CIPARAM_MENU_TYPE;
        	$valeur_type_par_constante = true;
        }
        
	if ($niveaux OR $types) {
                if (spip_version()<3) {
                    $texte .= debut_cadre_relief("", true, "", _T('ciparam:info_menu_niveau'));
                } else {
                    $texte .= '<br/><h3 class="titrem">'._T('ciparam:info_menu_niveau').'</h3>';
                }
                
        	if ($niveaux) {
                        $texte .= "<label for='ci_menu_niveau'>"._T('ciparam:texte_menu_niveau')."</label><br />"
                    . "\n<select name='ci_menu_niveau' id='ci_menu_niveau' class='formo'>\n";

                        if (!$valeur_niveau) 
                                $selected = "selected='selected'";

                        foreach ($niveaux as $niveau) {
                            if ($valeur_niveau AND $valeur_niveau==$niveau['nom']) 
                                    $selected = "selected='selected'";
                            else
                                    $selected = "";

                            $nom = $niveau['nom'];
                            $description = $niveau['description'];
                            $texte .= "<option value='".$nom."' $selected>".$description."</option>\n";
                        }
                        $texte .="</select><br />\n";
                }

        	if ($types) {
                    if ($valeur_type_par_constante){
                        foreach ($types as $type) {
                            if ($valeur_type AND $valeur_type==$type['nom']) 
                                    $texte .= '<div>'._T('ciparam:texte_menu_type').' : '.$type['description'].'</div>';
                        }
                    } else {
                        $texte .= "<br /><label for='ci_menu_type'>"._T('ciparam:texte_menu_type')."</label><br />"
                    . "\n<select name='ci_menu_type' id='ci_menu_type' class='formo'>\n";

                        if (!$valeur_type) 
                                $selected = "selected='selected'";

                        foreach ($types as $type) {
                            if ($valeur_type AND $valeur_type==$type['nom']) 
                                    $selected = "selected='selected'";
                            else
                                    $selected = "";

                            $nom = $type['nom'];
                            $description = $type['description'];
                            $texte .= "<option value='".$nom."' $selected>".$description."</option>\n";
                        }
                        $texte .="</select><br />\n";
                    }
                }
                
                if (spip_version()<3)
                    $texte .= fin_cadre_relief(true);              
	}
	
	return $texte;  
}	


function ciparam_choix_haut() {
	$texte = "";
	$valeur = "";
        $description = "";
        $editable = true;
        
        // desactivation par constante dans un fichier d'options
	if (defined("_CIPARAM_CHOIX_HAUT_RESERVE_WEBMESTRE") AND strtoupper(_CIPARAM_CHOIX_HAUT_RESERVE_WEBMESTRE)=="OUI"){
                $editable = false;
        	if ($GLOBALS['visiteur_session']['statut']=='0minirezo' AND $GLOBALS['visiteur_session']['webmestre']=='oui') {
                    $editable = true;
                }
        }
        
	
	$valeur = ciparam_lire_meta("ci_haut");	
	$hauts = ciparam_charger_param_xml("hauts");

	if ($hauts) {
            if (spip_version()<3)
                $texte .= debut_cadre_relief("", true, "", _T('ciparam:info_choix_haut'));
            else
                $texte .= '<br/><h3 class="titrem">'._T('ciparam:info_choix_haut').'</h3>';

            
            if ($editable){

                $texte .= "<label for='ci_haut'>"._T('ciparam:texte_haut')."</label><br />"
                . "\n<select name='ci_haut' id='ci_haut' class='formo'>\n";

                if (!$valeur) 
                        $selected = "selected='selected'";

                $texte .= "<option value='' ".$selected."></option>\n";

                foreach ($hauts as $haut) {
                    if ($valeur AND $valeur==$haut['nom']) 
                            $selected = "selected='selected'";
                    else
                            $selected = "";

                    $nom = $haut['nom'];
                    $description = $haut['description'];
                    $texte .= "<option value='".$nom."' $selected>".$description."</option>\n";
                }
                $texte .="</select><br />\n";

            } else {
                foreach ($hauts as $haut) {
                    if ($valeur AND $valeur==$haut['nom']){
                        $description = $haut['description'];
                    }
                }
                $texte .= $description."<br />";
            }
            
            if (spip_version()<3)
                $texte .= fin_cadre_relief(true);              
	}
	
	return $texte;  
}	

function ciparam_choix_masquer() {
	$texte = "";
	$masquers = ciparam_charger_param_xml("masquer");

	if ($masquers) {
		$valeurs = ciparam_lire_meta("ci_masquer");
		if (!$valeurs)
			$valeurs = array();

                if (spip_version()<3)
                    $texte .= debut_cadre_relief("", true, "", _T('ciparam:info_choix_masquer'));
                else
                    $texte .= '<br/><h3 class="titrem">'._T('ciparam:info_choix_masquer').'</h3>';
		
		foreach ($masquers as $masquer) {
			$id = 'ci_masquer_' . $masquer['nom'];
			$vu = in_array($masquer['nom'],$valeurs);
			$texte .= "<input type='checkbox' name='ci_masquer[]' value='".$masquer['nom']."' id='$id'"
				. ($vu ? " checked='checked'" : '')
				. " /> <label for='$id'>"
				. ($vu ? "<b>".$masquer['description']."</b>" : $masquer['description'])
				.  "</label><br />";
		}
	
                if (spip_version()<3)
                    $texte .= fin_cadre_relief(true);              
	}	

	return $texte;
}	


// exemple : $type_colonne = extra
//			 $objet = article
function ciparam_choix_extra_navigation($objet,$type_colonne) {
	$texte = "";
	$valeur = "";
        $selected = "";
	
	if ($objet AND $type_colonne) {
		$valeur = ciparam_lire_meta("ci_".$type_colonne."_".$objet);			
		$colonnes = ciparam_charger_param_xml($type_colonne."s-".$objet."s");
    	$colonnes = ciparam_order_array($colonnes,'description');

		if ($colonnes) {
			$champ = "ci_".$type_colonne."_".$objet;
			
			$texte .= "<label for='$champ'>"._T('ciparam:info_'.$type_colonne."_".$objet)."</label><br />";
		    if (ciparam_lire_config_fichier("ci".$type_colonne.$objet)!="") {
		    	$texte .=ciparam_lire_config_fichier("ci".$type_colonne.$objet);
		    } else {		
				$texte .= "\n<select name='".$champ."' id='".$champ."' class='formo'>\n";
				
		    	if (!$valeur) 
		    		$selected = "selected='selected'";

	    		$texte .= "<option value='' ".$selected."></option>\n";
			
			    foreach ($colonnes as $colonne) {
			    	if ($valeur AND $valeur==$colonne['nom']) 
			    		$selected = "selected='selected'";
			    	else
				    	$selected = "";
	
			    	$nom = $colonne['nom'];
			    	$description = $colonne['description'];
		    		$texte .= "<option value='".$nom."' $selected>".$description."</option>\n";
			    }
			    $texte .="</select>\n";
		    }
		}
	}
	
	return $texte;  
}	

// parametrage par fichier
function ciparam_lire_config_fichier($nom) {

	$return = '';
	$fichier = '_config_'.$nom.'.php';
	if (in_array($nom,array('cigaucherubrique','cigauchearticle')))	
		$fichier = '_config_css.php';
	
	$f = _DIR_ETC . $fichier;

	if (@file_exists($f)) {
		include_once($f);
		if (isset($GLOBALS['ciconfig'][$nom]))
			$return = $GLOBALS['ciconfig'][$nom];
	}

	return $return;
}

function ciparam_choix_sauts_lignes() {
        $texte = '';
        $ok = true;
        
        // desactivation par constante dans un fichier d'options
	if (defined("_CIPARAM_CHOIX_SAUTS_LIGNES") AND strtoupper(_CIPARAM_CHOIX_SAUTS_LIGNES)=="NON"){
                $ok = false;
        }
    
        if ($ok){
            $nom = 'ci_sauts_lignes';
            $valeurs = array('oui' => _T('item_oui'),'non' => _T('item_non'));
            if (!$valeur_actuelle = ciparam_lire_meta("ci_sauts_lignes"))
                    $valeur_actuelle = 'non';

            if (spip_version()<3)
                $texte .= debut_cadre_relief("", true, "", _T('ciparam:sauts_lignes'));
            else
                $texte .= '<br/><h3 class="titrem">'._T('ciparam:sauts_lignes').'</h3>';

            $choix = array();
            foreach ($valeurs as $valeur => $titre) {
                    $choix[] = ciparam_bouton_radio($nom, $valeur, $titre, $valeur == $valeur_actuelle);
            }
            $texte .= "\n".implode("<br />", $choix)."<br />";
            
            if (spip_version()<3)
                $texte .= fin_cadre_relief(true);              
        }

	return $texte;	
}

function ciparam_bouton_radio($nom, $valeur, $titre, $actif = false, $disabled = false) {
	static $id_label = 0;
	
	if ($disabled) $option = " disabled='disabled'";
	else $option = "";
    
	$texte = "<input type='radio' name='$nom' value='$valeur' id='label_".$nom."_".$id_label."'$option";
	if ($actif) {
		$texte .= ' checked="checked"';
		$titre = '<b>'.$titre.'</b>';
	}
	$texte .= " /> <label for='label_".$nom."_".$id_label."'>$titre</label>\n";
	$id_label++;
	return $texte;
}


function ciparam_choix_plan_niveau() {
	$texte = "";
	$valeur_niveau = entites_html(ciparam_lire_meta("ci_plan_niveau"));
	$valeur_niveau_par_constante = false;
	$class3 = ' text';
            
	if (!$valeur_niveau) $valeur_niveau = 99;

        // Parametrage par constante dans un fichier d'options
	if (defined("_CIPARAM_PLAN_NIVEAU") AND intval(_CIPARAM_PLAN_NIVEAU)>0 AND intval(_CIPARAM_PLAN_NIVEAU)<100){
		$valeur_niveau = intval(_CIPARAM_PLAN_NIVEAU);
        	$valeur_niveau_par_constante = true;
        }
        
	$texte .= "\n<tr><td class='verdana2'>";

        if ($valeur_niveau_par_constante){
            $texte .= '<div>'._T('ciparam:texte_plan_niveau').' : '.$valeur_niveau.'</div>';
        } else {
            $texte .= "<label for='ci_plan_niveau'>"._T('ciparam:texte_plan_niveau')."</label><br />"
            . " <input type='text' name='ci_plan_niveau' id='ci_plan_niveau' value=\"$valeur_niveau\" size='40' class='formo$class3' />";
        }

	$texte .= "</td></tr>";
	
	return $texte;  
}	

?>