<?php
/**
 * Plugin Configurateur de squelettes
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/ciparam_inc_commun');
include_spip('inc/presentation');


function exec_ciparam_raccourci_liens_dist()
{
	if (!autoriser('configurer', 'configuration')) {
		include_spip('inc/minipres');
		echo minipres();
	} else {
                $objet = _request('objet');
                $ciraccourci = _request('raccourci');
                $texte = "";
                $nom = "";
                $description = "";
	
		$commencer_page = charger_fonction('commencer_page', 'inc');
		echo $commencer_page(_T('ciparam:titre_raccourci_article'), "configuration", "configuration");
		echo "<br />\n";
                
		if ($objet=='articles')
			echo gros_titre(_T('ciparam:titre_raccourci_article'),'', false);
		elseif ($objet=='rubriques')
			echo gros_titre(_T('ciparam:titre_raccourci_rubrique'),'', false);
		elseif ($objet=='syndic')
			echo gros_titre(_T('ciparam:titre_raccourci_syndic'),'', false);
		
		echo debut_gauche('', true);
		$ciparam_navigation = charger_fonction('ciparam_navigation', 'configuration');
	  	echo $ciparam_navigation();
	
		echo creer_colonne_droite('', true);
		echo debut_droite('', true);

                if ($objet=='articles' OR $objet=='rubriques'  OR $objet=='syndic') {

                        $table = "spip_ci_raccourcis_".$objet;
                        $raccourcis = ciparam_charger_param_xml("raccourcis-".$objet);
                        $raccourcis = ciparam_order_array($raccourcis,'description');

                        if ($raccourcis) {
                            foreach ($raccourcis as $raccourci) {
                                if ($raccourci['nom']==$ciraccourci) { 
                                        $nom = $raccourci['nom'];
                                        $description = $raccourci['description'];
                                        break;
                                }
                            }

                            if ($nom) {
                                $contexte = array(
                                        'raccourci'=>$nom,
                                        'titre'=>$description,
                                        'objet'=> $objet,
                                        'ci_pagination'=> 1000,
                                        'ci_debut_objet' => _request('debut_objet'),
                                        'config_fonc'=>''
                                );

                                echo recuperer_fond("prive/editer/ciparam_raccourci_liens", $contexte);
                            }
                        }
                }
                
		echo  "<br />\n";
		echo fin_gauche(), fin_page();
	}

}

function ciparam_icone_verticale($lien, $texte, $fond, $fonction="", $class="", $javascript=""){
	return icone_base($lien,$texte,$fond,$fonction,"verticale $class",$javascript);
}

?>