<?php
/**
 * Plugin Configurateur de squelettes
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */
include_spip('inc/ciparam_inc_commun');

function formulaires_ciparam_choix_article_charger($type,$id_article){

	$valeurs = array();
        $id_article = intval($id_article);
	$table = table_objet_sql($type);
	$id_table_objet = id_table_objet($type);
	$valeurs[$id_table_objet] = $id_article;

	if ($id_article<1)
		return false;
        
	if (!autoriser('modifier', 'article', $id_article))
		return false;

	$valeurs['_hidden'] = "<input type='hidden' name='$id_table_objet' value='$id_article' />";
        
	// forme
	$valeurs['_choix_forme_article'] = ciparam_choix_forme($table,$id_table_objet,$id_article,"ciforme");
	if ($valeurs['_choix_forme_article'])
		$valeurs['masquer_choix_forme_article'] = "non";
	else	
		$valeurs['masquer_choix_forme_article'] = "oui";
	
        // raccourcis
	$valeurs['_liste_raccourci_article'] = ciparam_liste_raccourci($table,$id_table_objet,$id_article,"raccourci");
	$valeurs['_choix_raccourci_article'] = ciparam_choix_raccourci($table,$id_table_objet,$id_article,"raccourci");
	if ($valeurs['_choix_raccourci_article'])
		$valeurs['masquer_choix_raccourci_article'] = "non";
	else	
		$valeurs['masquer_choix_raccourci_article'] = "oui";

	return $valeurs;
}


function formulaires_ciparam_choix_article_verifier($type,$id_article){
	$erreurs = array();
	return $erreurs;	
}


function formulaires_ciparam_choix_article_traiter($type,$id_article){
	$valeurs = array();
	$table_objet_sql = table_objet_sql($type);
	$id_table_objet = id_table_objet($type);
        $invalideurs = false;
       
        // memoriser les anciennes valeurs
        $old_valeurs = array();
	$row = sql_fetsel("*", "spip_articles", "id_article=".$id_article,"","");	
	if ($row)
            $old_valeurs['ciforme'] = $row['ciforme'];
        
        // memoriser les anciens raccourcis
        $old_raccourcis = array();
        $result = sql_select("raccourci", "spip_ci_raccourcis_articles", "id_article=$id_article");
        while ($row = sql_fetch($result))
            $old_raccourcis[] = $row['raccourci'];

        
        // forme
        $ciforme = _request('ciforme');
        if ($ciforme AND (!isset($old_valeurs['ciforme']) OR $ciforme!=$old_valeurs['ciforme']))
            ciparam_maj_forme($type,"spip_articles",$id_table_objet,$id_article,'ciforme',$ciforme);
	
        // raccourcis
		$supprimer = _request('supprimer_lien');
		if ($supprimer){
			foreach($supprimer as $k=>$v) {
				if (preg_match(",^\w+-[\w*]+-[\w*]+-[\w*]+,",$k)){
					$lien = explode("-",$k);
					list($objet_source,$ids,$objet_lie,$idl) = $lien;
					if ($type AND $id_article AND $objet_lie=='raccourci' AND $raccourci=$idl) {
					  // desassocier un des raccourcis
						sql_delete("spip_ci_raccourcis_articles", "id_article=$id_article AND raccourci='$raccourci'");
					}
				}
			}
			// Invalider les caches	
                        include_spip('inc/invalideur');
                        suivre_invalideur("id='article/$id_article'");
		}
	
        $raccourci = _request('raccourci');
        if ($raccourci AND (!$old_raccourcis OR !in_array($raccourci,$old_raccourcis)))
            ciparam_ajout_raccourci($type,"spip_ci_raccourcis_articles",$id_table_objet,$id_article,'raccourci',$raccourci);
       
        
	return array('message_ok'=>'','editable'=>true);
}

?>