<?php
/**
 * Plugin Previsualisation etendue
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

/**
 * Mecanisme de previsualisation propre au plugin
 * qui permet de beneficier du cache de premier niveau de SPIP.
 * Si l'auteur est authentifie et que l'on est en mode previsualisation
 * et que l'autorisation de previsualiser est cochee dans la configuration de SPIP
 * on pose un cookie
 * on met le var_mode "cipreview" au lieu du var_mode "preview",
 * on pose un marqueur de cache et on ne force pas le recalcul (recompilation du squelette)
 * car ajout d'une fonction dans la clause where de certaines boucles via pipeline  
 */

if (isset($GLOBALS['visiteur_session']['statut'])) {
	if (!test_espace_prive()) {
		$cipage = _request('page');
		// au passage, compatibilite avec le plugin cisf
		if(!$cipage OR strlen($cipage)<5 OR substr($cipage,0,5)!='cisf_') {
			if (isset($_GET['cipreview']) AND $_GET['cipreview']=='non') {
				$_GET['var_mode']='';
		
				// Une ligne pour SPIP 3
				define('_VAR_PREVIEW',false);
		
				if (isset($_COOKIE['cipr_preview'])) {
					include_spip('inc/cookie');
					// suppression du cookie
					spip_setcookie('cipr_preview', '', time() - 3600);			
				}	
				
			} elseif ( (isset($_GET['var_mode']) AND $_GET['var_mode']=='preview') 
                                OR (isset($_GET['var_mode']) AND $_GET['var_mode']=='cipreview') 
                                OR isset($_COOKIE['cipr_preview'])) {
				// Autorisation de previsualiser
				if (!empty($GLOBALS['meta']['preview']) AND strpos($GLOBALS['meta']['preview'], ",". $GLOBALS['visiteur_session']['statut'] .",")!==false) {
					if (!isset($_COOKIE['cipr_preview'])) {
						include_spip('inc/cookie');
						spip_setcookie('cipr_preview', 'oui');
					}
		
					// 3 lignes pour SPIP 3
					if (!defined('_VAR_PREVIEW')) define('_VAR_PREVIEW',true);
					if (!defined('_VAR_MODE')) define('_VAR_MODE','calcul');
					if (!defined('_VAR_NOCACHE')) define('_VAR_NOCACHE',true);

                                        // compatibilité avec SPIP 4
                                        if (!function_exists("autoriser")){
                                            include_spip("inc/autoriser");
                                        }

					if (isset($_GET['var_mode']) AND $_GET['var_mode']=='preview')
						$_GET['var_mode']='cipreview';
		
					$GLOBALS['var_nocache'] = true;
		
					if (!isset($GLOBALS['marqueur'])) $GLOBALS['marqueur'] = '';
					$GLOBALS['marqueur'] .= 'cipr';
				}
			}
		}
	}
}

?>