<?php
/**
 * Plugin CISPAM
 * Copyright (c) Christophe IMBERTI
 * Licence GPL
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

define('_cispam_RACCOURCI_MODELE', 
	 '(<([a-z_-]{3,})' # <modele
	.'\s*([0-9]+)\s*' # id
	.'([|](?:<[^<>]*>|[^>])*?)?' # |arguments (y compris des tags <...>)
	.'\s*/?'.'>)' # fin du modele >
       );

define('_cispam_RACCOURCI_CODE', '(<(code|quote|math)>(.*?)</(code|quote|math)>)');

define('_cispam_RACCOURCI_LIEN', "/\[([^][]*?([[]\w*[]][^][]*)*)->(>?)([^]]*)\]/msS");

function cispam_texte_sans_html($texte, $action=false){

	// pour ceux qui ne respectent pas les consignes dans le fichier de parametrage
	if ($action=='supprimer' OR $action=='echapper') {
		       
		if (!empty($texte) AND strpos($texte,"<")!==false) {
			$z_matches = array();
			$c_matches = array();

			// proteger les raccourcis de CODE
			if (preg_match_all(_cispam_RACCOURCI_CODE, $texte, $c_matches, PREG_SET_ORDER)) {
				$c = 1;
				foreach ($c_matches as $code_match)
					$texte = str_replace($code_match[0],'cccc'.$c++.'_',$texte);
			}
			
			// proteger les modeles de SPIP
			if (preg_match_all(_cispam_RACCOURCI_MODELE, $texte, $z_matches, PREG_SET_ORDER)) {
				$z = 1;
				foreach ($z_matches as $match){
					if (!in_array(strtolower($match[0]),array('<table>')))
						$texte = str_replace($match[0],'zzzz'.$z++.'_',$texte);
				}
			}

			// proteger certains raccourcis de SPIP et certaines balises HTML (qui ne sont pas dangereuses) 
			$search = array('<br>','<br/>','<br />','<q>','</q>','<ins>','</ins>','<del>','</del>',
			'<html>','</html>','<cadre>','</cadre>','<poesie>','</poesie>','<poetry>','</poetry>',
			'< ',' >','<-','->','<|','|>');
			$replace = array('uuuu0','uuuu1','uuuu2','uuuu3','uuuu4','uuuu5','uuuu6','uuuu7','uuuu8',
			'tttt0','tttt1','tttt2','tttt3','yyyy0','yyyy1','yyyy2','yyyy3',
			'vvvv0','vvvv1','vvvv2','vvvv3','vvvv4','vvvv5');
			$texte = str_ireplace($search,$replace,$texte);
			
			include_spip("inc/texte");
			$texte = interdire_scripts($texte);
			
			// nettoyer le code HTML
			if ($action=='supprimer')
				$texte = supprimer_tags($texte);
			elseif ($action=='echapper')
				$texte = echapper_tags($texte);
	
			// deproteger certains raccourcis de SPIP et certaines balises HTML (qui ne sont pas dangereuses) 	
			$texte = str_replace($replace,$search,$texte);

			
			// remettre les raccourcis de CODE
			if ($c_matches) {
				reset($c_matches);
				$c = 1;
				foreach ($c_matches as $code_match)
					$texte = str_replace('cccc'.$c++.'_',$code_match[0],$texte);
			}
			
			// remettre les modeles de SPIP
			if ($z_matches) {
				reset($z_matches);
				$z = 1;
				foreach ($z_matches as $match)
					$texte = str_replace('zzzz'.$z++.'_',$match[0],$texte);
			}
			
		}
	}

	return $texte;	
}

function cispam_forum_sans_html($texte, $action=false){
	
	// pour ceux qui ne respectent pas les consignes dans le fichier de parametrage
	if ($action=='supprimer' OR $action=='echapper') {
		       
		if (!empty($texte) AND strpos($texte,"<")!==false) {
			$c_matches = array();
			
			// proteger les raccourcis de CODE
			if (preg_match_all(_cispam_RACCOURCI_CODE, $texte, $c_matches, PREG_SET_ORDER)) {
				$c = 1;
				foreach ($c_matches as $code_match)
					$texte = str_replace($code_match[0],'cccc'.$c++.'_',$texte);
			}
			
			// proteger certaines balises et certains raccourcis
			$search = array('<br>','<br/>','<br />','<q>','</q>','<ins>','</ins>','<del>','</del>',
			'<html>','</html>','<poesie>','</poesie>','<poetry>','</poetry>',
			'< ',' >','<-','->','<|','|>');
			$replace = array('uuuu0','uuuu1','uuuu2','uuuu3','uuuu4','uuuu5','uuuu6','uuuu7','uuuu8',
			'tttt0','tttt1','yyyy0','yyyy1','yyyy2','yyyy3',
			'vvvv0','vvvv1','vvvv2','vvvv3','vvvv4','vvvv5');
			$texte = str_ireplace($search,$replace,$texte);
			
			// enlever les raccourcis SPIP [xxx->url]
			if (preg_match_all(_cispam_RACCOURCI_LIEN, $texte, $regs, PREG_SET_ORDER)) {
				foreach ($regs as $k => $reg) {					
					$texte = str_replace($reg[0], $reg[1].' ('.$reg[count($reg)-1].')',$texte);
				}
			}

			// enlever les href proprement
			if (preg_match_all(",<a(.*?)href=\"(.*?)\"(.*?)>(.*?)</a>,i", $texte, $reg2s, PREG_SET_ORDER)) {
				foreach ($reg2s as $k => $reg) {					
					$texte = str_replace($reg[0], $reg[count($reg)-1].' ('.$reg[2].')',$texte);
				}
			}

			// nettoyer le code HTML
			if ($action=='supprimer')
				$texte = supprimer_tags($texte);
			elseif ($action=='echapper')
				$texte = echapper_tags($texte);
	
			// deproteger certaines balises et certains raccourcis	
			$texte = str_replace($replace,$search,$texte);
			
			// remettre les raccourcis de CODE
			if ($c_matches) {
				reset($c_matches);
				$c = 1;
				foreach ($c_matches as $code_match)
					$texte = str_replace('cccc'.$c++.'_',$code_match[0],$texte);
			}			
		}
	}

	return $texte;	
}

function cispam_pipeline_est_utilise($pipeline) {
	static $return = array();

	if (!isset($return[$pipeline])){	
		$cipipeline = true;
		if (@is_readable($charger = _CACHE_PIPELINES)){
			include_once($charger);
			if (!function_exists('execute_pipeline_'.$pipeline))
				$cipipeline = false;
		}
		$return[$pipeline] = $cipipeline;
	}
	
	return $return[$pipeline];
}

/**
 * Lecture des parametres de configuration du plugin
 * S'il existe, le parametrage par fichier est prioritaire
 *
 * @param : aucun
 * @return : tableau de config
 */
function cispam_lire_meta() {
        static $done = false;
        static $config = array();

        if (!$done){
                // parametrage par fichier
                $f = _DIR_ETC . '_config_cispam.php';
                if (@file_exists($f)){
                        include_once($f);
                }
                
                // valeur par defaut de certaines constantes
                
                // Pour ne pas enregistrer les commentaires marqués comme 'spam' (comme dans la version 2.6 de CISPAM)
                if (!defined('_CISPAM_NE_PAS_ENREGISTRER_LES_SPAMS')){
                    define('_CISPAM_NE_PAS_ENREGISTRER_LES_SPAMS','oui');
                }
                
                // Statut à affecter à un commentaire qui est dans une autre langue.
                if (!defined('_CISPAM_STATUT_COMMENTAIRE_AUTRE_LANGUE')){
                    define('_CISPAM_STATUT_COMMENTAIRE_AUTRE_LANGUE','prop');
                }
                
                // Nombre de liens, dans le texte d'un commentaire,
                // au-delà desquels on lui affecte le statut 'prop' (cf. plugin NOSPAM).
                if (!defined('_CISPAM_COMMENTAIRE_AVEC_LIENS_PREMIER_SEUIL')){
                    define('_CISPAM_COMMENTAIRE_AVEC_LIENS_PREMIER_SEUIL',1);
                }
                
                // Nombre de liens, dans le texte d'un commentaire,
                // au-delà desquels on lui affecte le statut 'spam' (cf. plugin NOSPAM).
                if (!defined('_CISPAM_COMMENTAIRE_AVEC_LIENS_SECOND_SEUIL')){
                    define('_CISPAM_COMMENTAIRE_AVEC_LIENS_SECOND_SEUIL',5);
                }
                
                // Si les spams ne sont pas enregistrés, la recherche de liens spammés perd son intérêt
                if (!defined('_CISPAM_DESACTIVER_RECHERCHE_LIENS_SPAMMES')){
                    define('_CISPAM_DESACTIVER_RECHERCHE_LIENS_SPAMMES','oui');
                }

                // Si SPIP n'est pas autorisé à interroger l'adresse du service qui retourne une liste d'IP indésirables,
                // ou bien si le service retourne souvent un message d'erreur,  
                // il est impératif de désactiver l'interrogation du service, afin d'éviter des appels inutiles.
                if (!defined('_CISPAM_DESACTIVER_SERVICE_IP_LISTE')){
                    define('_CISPAM_DESACTIVER_SERVICE_IP_LISTE', 'oui');
                }
                
                // memoriser
                if (isset($GLOBALS['ciconfig'])){
                    $config = $GLOBALS['ciconfig'];
                }
                $done = true;		
        }

        return $config;
}        

/**
 * Lecture des parametres de configuration du plugin
 * et alimentation de variables globales.
 * Compatibilité avec des constantes 
 */
function cispam_config($param) {
	$return = false;
	if ($param) {
              	$tableau_config = cispam_lire_meta();

		if (isset($tableau_config[$param])){
			$return = $tableau_config[$param];
                } else {
                        $constante = strtoupper($param);
                        if (substr($constante,0,1)!='_'){
                            $constante = '_'.$constante;
                        }
                        if (defined($constante)){
        			$return = constant($constante);
                        }
                }
	}
	
    return $return;
}

function cispam_verifier_caracteres_speciaux($t,$caracteres_autorises=array()) {
    $verif = true;

    if ($t) {
            // supprimer les accents
            include_spip('inc/charsets');
            $tsa = translitteration($t);
            
            $tscs = str_replace($caracteres_autorises,'',$tsa);		
            if ($tscs AND !ctype_alnum($tscs)) {
                    $verif = false;
            }
    }

    return $verif;
}

function cispam_presence_mot_interdit($texte) {
    $patterns = array();

    if  (defined('_CISPAM_LISTE_PERSONNALISEE_MOTS_INTERDITS') AND _CISPAM_LISTE_PERSONNALISEE_MOTS_INTERDITS){
        $patterns[] = _CISPAM_LISTE_PERSONNALISEE_MOTS_INTERDITS;
    } else {
        $patterns[] = 'my web|homepage|escorts| escort | sex |Call Girl|\.nu|\.in| viagra|v1agr@|vi@gra|v\|agRa|V I A G R A|purchase amazing|buy amazing|luxurybrandsale|lotto|pharmacy';
    }

    $texte = ( function_exists( 'iconv' ) ? iconv( 'utf-8', 'utf-8//TRANSLIT', $texte ) : $texte );

    if (!empty( $texte )) {
        foreach ( $patterns as $regexp ) {
            // limiter aux a-zA-Z0-9, aux pipe, espaces, tirets, points, antislash, arobase
            $caracteres_autorises_regexp = array("|"," ",'-','.','\\','@');
            if (cispam_verifier_caracteres_speciaux($regexp,$caracteres_autorises_regexp)){
                if ( preg_match( '/' . $regexp . '/isu', $texte ) ) {
                        return true;
                }
            }
        }
    }
    return false;
}

?>