<?php

/*-----------------------------------------------------------------
// Fonctions pour etre compatible avec les acces restreint
------------------------------------------------------------------*/

// Signaletique acces restreints
function cisquel_logo_ari($id_rubrique) {
	$return = "";

	$f = cisquel_fonction_rubrique_restreinte();
	if ($f!="non") {
		if ($f($id_rubrique)) {
			$return = "<div class='ar'>"._T('cisquel:eq_ar')."</div>";
		}
	}

	$fec = cisquel_fonction_rubrique_ec();
	if ($fec!="non") {
		if ($fec($id_rubrique))
			$return = '<div class="ari">'._T('cisquel:eq_ari').'</div>';
	}

	return $return;
}

function cisquel_logoseul_ari($id_rubrique) {
	$return = "";

	$f = cisquel_fonction_rubrique_restreinte();
	if ($f!="non") {
		if ($f($id_rubrique)) {
			$return = '<img src="'.find_in_path('_images/ar.gif').'" title="'._T('cisquel:eq_ar').'" alt="'._T('cisquel:eq_ar').'" />';			
		}
	}

	$fec = cisquel_fonction_rubrique_ec();
	if ($fec!="non") {
		if ($fec($id_rubrique))
			$return = '<img src="'.find_in_path('_images/ari.gif').'" title="'._T('cisquel:eq_ari').'" alt="'._T('cisquel:eq_ari').'" />';			
	}

	return $return;
}


// Rubrique EC
function cisquel_rubrique_ec($id_rubrique) {
	$return = "non";

	$fec = cisquel_fonction_rubrique_ec();
	if ($fec!="non") {
		if ($fec($id_rubrique))
			$return = "oui";
	}

	return $return;
}



function cisquel_fonction_rubrique_restreinte() {
	static $return;
	
	if (!$return) {
		if (function_exists('ciar_rub_ar'))
			$return = "ciar_rub_ar";
		else
			$return = "non";
	}

	return $return;
}

function cisquel_fonction_rubrique_ec() {
	static $return;
	
	if (!$return) {
		if (function_exists('ciar_rub_ec'))
			$return = "ciar_rub_ec";
		else
			$return = "non";
	}

	return $return;
}


// cisquel_post_autobr : transforme les sauts de ligne en _
// en tenant compte de certains cas particuliers
function cisquel_post_autobr($texte, $delim="\n_ ") {
	return ciparam_post_autobr($texte, $delim);
}

/*-----------------------------------------------------------------
// Fonctions pour les recherches
------------------------------------------------------------------*/

function cisquel_filtrer_recherche($recherche, $verif_alpha=false) {
	$safe = '';
	$verif = true;

        
	// recherche avant traitement
	if ($t = _request('recherche'))	{
		$t = trim($t);
	// recherche apres traitement
	} else {
                if (empty($recherche)){
                    $t = '';
                } else {
                    $t = trim($recherche);
                    include_spip('inc/filtres');	
                    $t = filtrer_entites($t);
                }
	}

	if ($t) {
		// supprimer les accents
		include_spip('inc/charsets');
		$tsa = translitteration($t);
	
		// interdire les caracteres dangereux
		// limiter aux a-zA-Z0-9, aux espaces, underscores, apostrophe, quote, double quote, tirets, points, slash
		$tableau = array(" ","_","'",'"','-','.','/');
		$tscs = str_replace($tableau,'',$tsa);		
		if (!ctype_alnum($tscs)) {
			$verif = false;

			// passer le cas echeant en iso pour avoir la meme longueur avec ou sans accent en utf-8	
			if ($GLOBALS['meta']['charset'] != 'iso-8859-1')
				$tiso = iconv(strtoupper($GLOBALS['meta']['charset']), "ISO-8859-1", $t);
			else
				$tiso = $t;

			// enlever les caracteres speciaux
			$longueur = strlen($tsa);
		    for ($i = 0; $i < $longueur; $i++){
		    	if (ctype_alnum($tsa[$i]) OR in_array($tsa[$i], $tableau))
		    		$safe .= $tiso[$i];
		    	else
		        	$safe .= ' ';
		    }
			// repasser le cas echeant dans le charset du site
			if ($GLOBALS['meta']['charset'] != 'iso-8859-1')
				$safe = iconv("ISO-8859-1", strtoupper($GLOBALS['meta']['charset']), $safe);
		    
		} else {
			$safe = $t;
		}

	    // supprimer les double quote (ne sert pas pour la recherche et evite le hack avec '")
            $safe = str_replace('"','',$safe);		
            
	    // supprimer les espaces doubles
	    $safe = trim(preg_replace ( '~\s{2,}~' , ' ' , $safe )); 
	}

    if ($verif_alpha)
    	return $verif;
    
   	return $safe;
}

function cisquel_recherche_autorise($recherche) {
	static $resultat = array();

	if (isset($GLOBALS['cisquel_recherche_sans_filtre']) AND $GLOBALS['cisquel_recherche_sans_filtre']=='oui') {
		$return = 'oui';
	} else {
		if (isset($resultat[$recherche])) {
			$return = $resultat[$recherche];
		} else {
			if (cisquel_filtrer_recherche($recherche, true))
				$return = 'oui';
			else
				$return = 'non';
				
			$resultat[$recherche] = $return;
		}
	}
				
	return $return;	
}


function cisquel_accesinterdit($autorise='oui') {
	if ($autorise=='non') {
		include_spip('inc/headers');
		redirige_par_entete(generer_url_public('recherche_interdit'));
	}
	return '';
}

function cisquel_date_vers_age($date) {
	$date_en = '';
	$return = '';

	// verifier
	$date_en = cisquel_verifier_et_convertir_date($date);
	
	// calcul de l'age en jours
	if ($date_en) {
		$ref_time = time();
		$decal = date("U",$ref_time) - date("U", strtotime($date_en));
		$return = intval($decal/(3600*24));		
	}
	
	return $return;
}

function cisquel_age_vers_date($age) {
	$return = '';

	// calcul de l'age en jours
	if ($age = intval($age)) {
		$ref_time = time();
		$timestamp = date("U",$ref_time) - intval($age*3600*24);
		$return = date("Y-m-d",$timestamp);		
	}
	
	return $return;
}

function cisquel_verifier_date($a) {
	$return = '';

   	if (isset($a) AND $a!="") {
	    list($dd,$mm,$yy) = explode("/",$a);
	    if ($dd!="" && $mm!="" && $yy!="") {
		    if (is_numeric($yy) && is_numeric($mm) && is_numeric($dd)) {
		            if (checkdate($mm,$dd,$yy))
						$return = $dd."/".$mm."/".$yy;
		    }
	    } 
   	}

   	return $return;
}

function cisquel_verifier_et_convertir_date($a) {
	$return = false;

   	if (isset($a) AND $a!="") {
	    list($dd,$mm,$yy) = explode("/",$a);
	    if ($dd!="" && $mm!="" && $yy!="") {
		    if (is_numeric($yy) && is_numeric($mm) && is_numeric($dd)) {
		            if (checkdate($mm,$dd,$yy))
						$return = $yy."-".$mm."-".$dd;
		    }
	    } 
   	}

   	return $return;
}

function ci_rub_multirubricage($id_rubrique,$env_id_rubrique){
	$return = $id_rubrique;
	
	if ($env_id_rubrique) {
		$env_id_rubrique = intval($env_id_rubrique);
		if ($env_id_rubrique>0){
			$in = sql_in('ciforme',array('_multirubricage',
										'_multirubricagetrirubrique',
										'_2colonnes',
										'_3colonnes',
										'_avecactualite',
										'_calendrier',
										'_espacededie',
										'_etablissements',
										'_etablissements2',
										'_tableau'));
			
			if (sql_countsel("spip_rubriques", "id_rubrique=".$env_id_rubrique." AND ".$in)>0)
				$return = $env_id_rubrique;
		}
	}

	return $return;
}

function cisquel_temps_telechargement($taille) {
	$return = "";
	
	$taille = intval($taille);
	if ($taille>5242880) {
		// passer en Kb
		$taille = ($taille * 8) / 1000;
		$return = _T('cisquel:temps_telechargement').' : ';
		$return .=  cisquel_convertir_secondes($taille/(512)).' (512 K), ';
		$return .=  cisquel_convertir_secondes($taille/(1024)).' (1024 K), ';
		$return .=  cisquel_convertir_secondes($taille/(2048)).' (2 M), ';
		$return .=  cisquel_convertir_secondes($taille/(5120)).' (5 M).';
	}
	
	return $return;		
}

function cisquel_convertir_secondes($total) {
	$return = "";
	$heure = intval($total / 3600);
	$total = $total - ($heure * 3600);
	$minute = intval($total / 60);
	$total = $total - ($minute * 60);
	$seconde = intval($total);

	if ($heure!=0)
		$return = $heure." h";
		
	if ($minute!=0 OR ($heure!=0 AND $seconde!=0)) {
		if ($return) $return .= " ";
		$return .= $minute." min";
	}
	
	if ($seconde!=0) {
		if ($return) $return .= " ";
		$return .= $seconde." s";
	}

	return $return;	
}

function cisquel_convertir_minutes($total) {
	$return = "";
	$heure = intval($total / 3600);
	$total = $total - ($heure * 3600);
	$minute = round($total / 60);
        
	if ($heure!=0)
		$return = $heure." h";
		
	if ($minute!=0 OR $heure!=0) {
		if ($return) $return .= " ";
		$return .= $minute." min";
	}
	
	return $return;	
}

function cisquel_url_texte_comarquage($url) {
        if (empty($url)){
            return '';
        }
        // supprimer les retours a la ligne
        $url = trim(str_replace(array("\r\n","\r","\n"),"",$url));
	// supprimer au passage les &nbsp;
        $url = str_replace("&nbsp;?","?",$url);
	// appliquer texte_script
	$url = texte_script($url);

	return $url;
}

function cisquel_url_date_comarquage($url) {
	return str_replace("texte_article","date_article",cisquel_url_texte_comarquage($url));	
}

function cisquel_url_article_comarquage($url) {
	return str_replace("texte_article","article",cisquel_url_texte_comarquage($url));	
}

function cisquel_date_multirubricage($id_rubrique) {
        static $resultat = array();
	$id_rubrique = intval($id_rubrique);
	$date_article_multirubricage = '';
	$date_article = '';
	$return = '';
	
	if ($id_rubrique) {
                if (isset($resultat[$id_rubrique])) {
                        $return = $resultat[$id_rubrique];
                } else {
                        // mots du multirubricage
                        $id_mots = array();
                        $result = sql_select("id_mot", "spip_mots", "type='_multirubricage'");
                        while ($row = sql_fetch($result))
                                $id_mots[] = $row['id_mot'];

                        if ($id_mots) {
                                // mots multirubricage de cette rubrique
                                $id_mots_rubrique = array();
                                $in_mots = sql_in('id_mot',$id_mots); 
                                $result = sql_select("id_mot", "spip_mots_liens", "objet='rubrique' AND id_objet=".$id_rubrique." AND ".$in_mots,"","id_mot");

                                while ($row = sql_fetch($result))
                                        $id_mots_rubrique[] = $row['id_mot'];


                                if ($id_mots_rubrique){
                                    // date de publication la plus recente des articles avec l'un des mots de multirubricage de la rubrique
                                    $in_mots_rubrique = sql_in('lien.id_mot',$id_mots_rubrique); 
                                    $result = sql_select("art.date", "spip_articles AS art, spip_mots_liens AS lien", "lien.objet='article' AND art.id_article=lien.id_objet AND ".$in_mots_rubrique." AND art.statut='publie'","","art.date DESC",1);

                                    while ($row = sql_fetch($result)){
                                            $date_article_multirubricage = $row['date'];
                                    }
                                }
                        }

                        // date de publication la plus recente des articles de la rubrique
                        $result = sql_select("date", "spip_articles", "id_rubrique=".$id_rubrique." AND statut='publie'", "", "date DESC",1);

                        while ($row = sql_fetch($result))
                                $date_article = $row['date'];

                        if ($date_article_multirubricage){
                                if ($date_article){
                                        if (strtotime($date_article) >= strtotime($date_article_multirubricage)){
                                                $return = $date_article;
                                        } else {
                                                $return = $date_article_multirubricage;
                                        }
                                } else {
                                        $return = $date_article_multirubricage;
                                }
                        } else {
                                if ($date_article){
                                        $return = $date_article;
                                } else {
                                        // rubrique publiee directement sans articles propres ni articles issus du multirubricage
                                        // si elle a le statut publie, on prend la seule date dont on dispose, la date de maj
                                        $row = sql_fetsel("maj", "spip_rubriques", "id_rubrique=".intval($id_rubrique)." AND statut='publie'");
                                        if ($row){
                                                $return = $row['maj'];
                                        }
                                }
                        }
			$resultat[$id_rubrique] = $return;
                }
	}
	
	return $return;
}

function cisquel_moins_de_3_jours($date_article){

        $return = 'non';

    return $return;
}


function cisquel_title_pagination($env=array(), $pas=10) {
    $pas = intval($pas);
    if ($pas<1)
        $pas = 10;
    
    // indispensable (necessite un #ENV sans filtre)
    $p = unserialize($env);
    
    $page = 1;
    foreach ($p as $cle=>$valeur) {
        if (substr($cle,0,6)=="debut_"){
            if (intval($valeur)>0)
                $page = 1 + (intval($valeur)/$pas);

            break;
        }
    }
    
    $return = "("._T('cisquel:eq_page')." : ".strval($page).")";
    
    return $return;
}

function cisquel_slash_final($texte){
    if (empty($texte)){
        return '';
    }
    $texte = trim($texte);
    if (substr($texte,-1)== "/")
        return  $texte;
    else
        return  $texte."/";
}

function cisquel_sans_doublequote($texte){
    if (empty($texte)){
        return '';
    }
    return str_replace('"','',$texte);
}

/*-----------------------------------------------------------------
// Balise pour le doctype
------------------------------------------------------------------*/

function balise_CISQUEL_DOCTYPE_dist($p) {
	$p->code = "cisquel_doctype()";
//	$p->statut = 'html';
	return $p;
}

function cisquel_doctype() {
	$lang = $GLOBALS['spip_lang'];
	$dir = ($GLOBALS['spip_lang_rtl'] ? 'rtl' : 'ltr');
        
        // Reservation avec l'insertion de classes conditionnelles
        // (cf. www.paulirish.com/2008/conditional-stylesheets-vs-css-hacks-answer-neither/)
        // Reservation avec la classe no-js si on veut des styles specifiques lorsque javascript est desactive
	return '<!DOCTYPE html>
<!--[if lt IE 7]><html lang="'.$lang.'" dir="'.$dir.'" class="no-js ie ie6 lt-ie9 lt-ie8 lt-ie7"><![endif]-->
<!--[if IE 7]><html lang="'.$lang.'" dir="'.$dir.'" class="no-js ie ie7 lt-ie9 lt-ie8 lt-ie7"><![endif]-->
<!--[if IE 8]><html lang="'.$lang.'" dir="'.$dir.'" class="no-js ie ie8 lt-ie9 lt-ie8"><![endif]-->
<!--[if IE 9]><html lang="'.$lang.'" dir="'.$dir.'" class="no-js ie ie9 lt-ie9"><![endif]-->
<!--[if (gt IE 9)|!(IE)]><!--><html lang="'.$lang.'" dir="'.$dir.'" class="no-js"><!--<![endif]-->';
        
}


/* -----------------------------------------------------------------------------
  Ajout accessibilite
-------------------------------------------------------------------------------- */

// accessibilite : si des erreurs mais pas de message general l'ajouter
// (selon core.spip.net/issues/3315 SPIP 3.0 ne beneficiera pas du report de la revision 21729 de SPIP 3.1,
// que j'ai demande, car il ne font pas de report des chaines de langue de la 3.1 vers la 3.0)
function cisquel_message_erreur($env=array()){
    $return = '';
    
    if (spip_version()<3.1){
        // indispensable (necessite un #ENV sans filtre)
        $p = unserialize($env);

        if (isset($p['message_erreur']) AND $p['message_erreur']!=''){
            $return = $p['message_erreur'];
        } elseif (isset($p['erreurs']) AND count($p['erreurs'])){
            // SPIP passe la previsu d'un commentaire via les erreurs 
            if (count($p['erreurs'])>1 OR !isset($p['erreurs']['previsu']))
                $return = singulier_ou_pluriel(count($p['erreurs']),'cisquel:avis_1_erreur_saisie','cisquel:avis_nb_erreurs_saisie');
        }
    }
    return $return;
}

// accessibilite : eviter qu'un <h3> suive un <h1> sans passer par un <h2>
function cisquel_presence_h3($texte){
    $return = '';
    if (empty($texte)){
        return '';
    }
    // intertitre
    if (strpos($texte,'{{{')!==false)
        $return = 'oui';
    // h3 directement renseigne dans le texte
    elseif (stripos($texte,'</h3>')!==false)
        $return = 'oui';
    
    return $return;
}

function cisquel_flash_entities($texte){
    if (empty($texte)){
        return '';
    }
    return str_replace("&amp;", "%26", $texte);
}

function cisquel_video_script($arg='', $num_skin=0){
    static $done = false;
    static $firstarg = 0;
    $return = '';
    $cilang = 'fr';
    if (in_array($GLOBALS['spip_lang'],array('en','es','de')))
            $cilang = $GLOBALS['spip_lang'];
    
    $concat = "lib/videojs/video_concat_".$cilang.".min.js";
    if ($arg=='hls')
        $concat = "lib/videojs/hls_concat_".$cilang.".min.js";
    elseif ($arg=='dash')
        $concat = "lib/videojs/dash_concat_".$cilang.".min.js";
    
    $videojspath = find_in_path($concat);
    $videojsswf = find_in_path("lib/videojs/video-js.swf");
    $videojscss = find_in_path("lib/videojs/video-js.min.css"); 
    $videojsskin = cisquel_chemin_video_skin($num_skin);

    if (!$done OR $firstarg==$arg){
        $done = true;
        $firstarg = $arg;
        $return = '<script>
<!--
var videojspath="'.$videojspath.'",
        videojsswf="'.$videojsswf.'",
        videojscss="'.$videojscss.'", 
        videojsskin="'.$videojsskin.'";

var videojsloader;
(function(){
	var L=videojsloader;
	if (typeof L == "undefined"){ videojsloader = L = {gs:null,css:{},cssload:null}; }    
        L.cssload = function (f){
                if (typeof L.css[f]=="undefined"){
                        L.css[f] = true;
                        var stylesheet = document.createElement("link");
                        stylesheet.href = f;
                        stylesheet.rel = "stylesheet";
                        stylesheet.type = "text/css";
                        document.getElementsByTagName("head")[0].appendChild(stylesheet);
                }
        }
	if (!L.gs){
		if (typeof videojscss !== "undefined"){	L.cssload(videojscss); }
		if (typeof videojsskin !== "undefined"){ L.cssload(videojsskin); }
                jQuery.ajaxSetup({ cache: true });
                if (typeof videojspath !== "undefined"){	
                    L.gs = jQuery.getScript(videojspath,function(){
                            L.gs = true;
                            if (typeof videojsswf !== "undefined"){ videojs.options.flash.swf = videojsswf; }
                            
                            var ciListeVideo, ciVideoId, ciAtt, ciListeAudio;
                            ciListeVideo = document.getElementsByTagName("video");
                            for(var i = 0, max = ciListeVideo.length; i < max; i++){

// document.createAttribute will be deprecated in DOM4
//                                ciAtt = document.createAttribute("controls");
//                                ciListeVideo[i].setAttributeNode(ciAtt);
                                ciListeVideo[i].setAttribute("controls","");
                                
                                ciVideoId = ciListeVideo[i].id;
                                if (ciVideoId){                                
                                    videojs(ciVideoId).one("play", function(e) {
                                    
                                        var eventLabel, eventSection, parsedOptions;
                                        eventLabel = "";
                                        eventSection = "";
                                        if (this.options_["data-setup"]) {
                                          parsedOptions = JSON.parse(this.options_["data-setup"]);
                                          if (parsedOptions.ciEventPage) {
                                            eventLabel = parsedOptions.ciEventPage;
                                          }
                                          if (parsedOptions.ciEventSection) {
                                            eventSection = parsedOptions.ciEventSection;
                                          }
                                        }
                                        if (typeof ciTrackVideo !== "undefined" && typeof ciTrackVideo === "function"){
                                          ciTrackVideo("C",eventSection,eventLabel,"T");
                                        }
                                        if (typeof ciXitiTrackVideo !== "undefined" && typeof ciXitiTrackVideo === "function"){
                                          ciXitiTrackVideo("C",eventSection,eventLabel,"T");
                                        }
                                        if (typeof ciPiwikTrackVideo !== "undefined" && typeof ciPiwikTrackVideo === "function"){
                                          ciPiwikTrackVideo("C",eventSection,eventLabel,"T");
                                        }
                                    });
                                }
                            }
                            
                            ciListeAudio = document.getElementsByTagName("audio");
                            for(var i = 0, max = ciListeAudio.length; i < max; i++){
// document.createAttribute will be deprecated in DOM4
//                                ciAtt = document.createAttribute("controls");
//                                ciListeAudio[i].setAttributeNode(ciAtt);
                                ciListeAudio[i].setAttribute("controls","");
                            }
                    });
                }
                jQuery.ajaxSetup({ cache: false });
	}
})();
-->
</script>';
    }
    
    return $return;
}

function cisquel_chemin_video_skin($num_skin=0){
    $skin = "_css/videojs-skin";
    $extension = ".css";
    $numero = "1";
    
    if (intval($num_skin)>0)
        $numero = intval($num_skin);
    
    if (defined('_CISQUEL_VIDEO_NUM_SKIN')) {
            if (intval(_CISQUEL_VIDEO_NUM_SKIN)>1)
                    $numero = strval(intval(_CISQUEL_VIDEO_NUM_SKIN));
    }	
    
    $chemin = find_in_path($skin.$numero.$extension);
    if (!$chemin)
        $chemin = '';
    
    return $chemin;
}

function cisquel_enlever_protocole($url){
    if (empty($url)){
        return '';
    }
    // enlever le protocole
    if (substr($url, 0, 7)=='http://')
        $url = substr($url, 7);
    elseif (substr($url, 0, 8)=='https://')
        $url = substr($url, 8);
    return $url;
}

function cisquel_dailymotion_fichier($url){
    $return = '';
    if (empty($url)){
        return '';
    }
  
    $url = cisquel_enlever_protocole(trim($url));

    // verifier l'URL
    if (substr($url, 0, 26)=='www.dailymotion.com/video/') {
        $url = substr($url, 26);

        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-');
        $tscs = str_replace($tableau,'',$url);
        if (ctype_alnum($tscs)) {
          $return = $url;
        }
    }
    // verifier l'URL
    elseif (substr($url, 0, 7)=='dai.ly/') {
        $url = substr($url, 7);

        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-');
        $tscs = str_replace($tableau,'',$url);
        if (ctype_alnum($tscs)) {
          $return = $url;
        }
    }  
  
  return $return;
}

function cisquel_deduction_titre($fichier){
  $return = '';
  
  if ($fichier){
        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-');
        $tscs = str_replace($tableau,'',$fichier);
        if (ctype_alnum($tscs)) {
            $return = str_replace($tableau,' ',substr($fichier,8));
  	}
  }
  
  return $return;
}


function cisquel_youtube_fichier($url){
    $return = '';
    if (empty($url)){
        return '';
    }

    $url = cisquel_enlever_protocole(trim($url));

    // verifier l'URL
    if (substr($url, 0, 24)=='www.youtube.com/watch?v=') {
        $url = substr($url, 24);

        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-');
        $tscs = str_replace($tableau,'',$url);
        if (ctype_alnum($tscs)) {
          $return = $url;
        }
    }  

    return $return;
}

function cisquel_page_non_trouvee($id_article='', $id_rubrique='', $id_document=''){
    $return = false;
    
    // cas particulier
    if (!$id_article AND !$id_rubrique AND !$id_document){
        $return = true;
    }
    
    // cas general
    if (!$return){
        $id_article = intval($id_article);
        $id_rubrique = intval($id_rubrique);
        $id_document = intval($id_document);

        if ($id_article>=1){
            $return = !cisquel_objet_en_base('article',$id_article,'publie');
        } else if ($id_rubrique>=1){
            $return = !cisquel_objet_en_base('rubrique',$id_rubrique,'publie');
        } else if ($id_document>=1){
            $return = !cisquel_objet_en_base('document',$id_document,'publie');
        }
    }
    
    // compatibilite avec CIMS
    if (!$return){
	if (defined('_DIR_PLUGIN_CIMS') AND defined('_CIMS_ACTIF')){
            if ($id_article>=1){
                $id_rubrique = sql_getfetsel('id_rubrique', 'spip_articles', "id_article=$id_article");
            }
            if ($id_rubrique>=1){
                include_spip('cims_fonctions');
                $ci_site = cims_site_en_cours();
                $tableau_sites_rubrique = cims_tableau_sites_de_la_rubrique($id_rubrique);
                if (!in_array($ci_site,$tableau_sites_rubrique)){
                    $return = true;
                }
            }
        }
    }
    
    // renvoyer directement la page 404 si pas authentifie
    if ($return){
        if (!isset($GLOBALS['visiteur_session']['id_auteur']) OR !$GLOBALS['visiteur_session']['id_auteur']){
            cisquel_redirige_404();            
        }
    }
    
    return $return;
}

function cisquel_redirige_404(){
	
    // Vider tous les tampons
    $level = @ob_get_level();
    while ($level--)
            @ob_end_clean();

    include_spip('inc/headers');
    http_status(404);
    echo recuperer_fond("404");

    exit;
}

function cisquel_objet_en_base($objet='',$id_objet=0, $statut=''){
    $return = false;
    
    if ($objet AND ctype_alpha($objet)){
        $where = "id_".$objet."=".intval($id_objet);
        if ($statut AND ctype_alpha($statut)){
            $where .= " AND statut='".$statut."'";
        }
        if (sql_countsel("spip_".$objet."s", $where)>0){
            $return = true;
        }
    }
    
    return $return;
}

function cisquel_redirige_page_protegee($url_retour=''){
    
    // renvoyer directement la page 403protege si pas authentifie
    if (!isset($GLOBALS['visiteur_session']['id_auteur']) OR !$GLOBALS['visiteur_session']['id_auteur']){
        // Vider tous les tampons
        $level = @ob_get_level();
        while ($level--)
                @ob_end_clean();

        include_spip('inc/headers');
        http_status(403);
        echo recuperer_fond("403protege",array("url_retour" => $url_retour));

        exit;
    }
    
    return true;
}

function cisquel_tarteaucitron_actif($arg=''){
    $return = 'non';

    if (defined('_CI_TARTEAUCITRON') AND _CI_TARTEAUCITRON=='oui'){
          $return = 'oui';
    }

    return $return;
}

function cisquel_tarteaucitron_script($service){
    $return = '';
    static $done = false;
  
    if (!$done){
        $done = true;
        if (defined('_CI_TARTEAUCITRON') AND _CI_TARTEAUCITRON=='oui'){
              if ($service AND ctype_alpha($service)){
                  $return = "<script type='text/javascript'> (tarteaucitron.job = tarteaucitron.job || []).push('".$service."'); </script>";
              }
        }
    }
    return $return;
}

function cisquel_recherche_charger($arg=''){
    $return = '<p style="display: none;"><label for="type_nbt">'._T('antispam_champ_vide').'</label>
	<input type="text" class="text" name="type_nbt" id="type_nbt" value="" size="10" />
    </p>';
    
    return $return;
}

?>