<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2016                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/


if (!defined('_ECRIRE_INC_VERSION')) return;

// Inserer la feuille de style selon les normes, dans le <head>
// puis les boutons
// Feuilles de style admin : d'abord la CSS officielle, puis la perso


// Compatibilite : on utilise stripos/strripos() qui n'existent pas en php4
if (!function_exists('strripos')) {
// http://doc.spip.org/@strripos
	function strripos($botte, $aiguille) {
		if (preg_match('@^(.*)' . preg_quote($aiguille, '@') . '@is',
		$botte, $regs)) { 
			return strlen($regs[1]);
		}
		return false;
	}
}
if (!function_exists('stripos')) {
// http://doc.spip.org/@stripos
	function stripos($botte, $aiguille) {
		if (preg_match('@^(.*)' . preg_quote($aiguille, '@') . '@isU',
		$botte, $regs)) { 
			return strlen($regs[1]);
		}
		return false;
	}
}

// http://doc.spip.org/@affiche_boutons_admin
function affiche_boutons_admin($contenu) {
    
    if (isset($_COOKIE['spip_session'])){
        include_spip('inc/filtres');

	// Inserer le css specifique d'admin
	if ($f = find_in_path('_css/style_barre_admin.css')){
            // pour contourner un bug corrige par SPIP 3.1.4
            // ne pas mettre d'URL absolue
            // $css = "<link rel='stylesheet' href='" . url_absolue(direction_css($f)) . "' type='text/css' />\n";
            $css = "<link rel='stylesheet' href='" . $f . "' type='text/css' />\n";

            ($pos = stripos($contenu, '</head>'))
                || ($pos = stripos($contenu, '<body>'))
                || ($pos = 0);
            $contenu = substr_replace($contenu, $css, $pos, 0);
        }

	// Inserer la balise #FORMULAIRE_ADMIN, en float
	$boutons_admin = inclure_balise_dynamique(
		balise_FORMULAIRE_ADMIN_dyn('cisquel-admin-bloc'),
	false);

	if ($pos = stripos($contenu, '<div id="cisquel-barre-admin">')){
                $pos += 30;
        } elseif ($pos = stripos($contenu, '<body')) {
                $pos_fin = strpos($contenu, '>' , $pos);
                if ($pos_fin!==false){
                        $pos = $pos_fin + 1;
                } else {
                        $pos += 6;
                }
                $boutons_admin = '<div id="cisquel-barre-admin">' . $boutons_admin . '</div>';
        }
        
	$contenu = substr_replace($contenu, $boutons_admin, $pos, 0);
    }
    return $contenu;
}

?>
