<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/headers');
include_spip('inc/filtres');
include_spip('inc/ciwidget_inc_meta');
include_spip('inc/ciwidget_inc_style');
include_spip('ciwidget_fonctions');


function action_ciwidget_export_config($arg=null){
    
    if (autoriser('configurer')) {
        
	if (is_null($arg)){
		$securiser_action = charger_fonction('securiser_action','inc');
		$arg = $securiser_action();
	}
        
        ciwidget_export_fichier($arg);
                
	// forcer l'envoi du buffer par tous les moyens !
	while (@ob_get_level()) {
		@ob_flush();
		@flush();
		@ob_end_flush();
	}
    } else {
            spip_log("action_ciwidget_export_fichier interdit",_LOG_INFO_IMPORTANTE);
    }
        
}

function ciwidget_export_fichier($arg=''){
    
    $valeurs_possibles = ciwidget_tableau_id_widgets_avec_valeur_defaut();
    $tableau_des_elements_par_widget = ciwidget_tableau_des_elements_par_widget();
    $valeurs_possibles[] = 'commun';
    $tableau_a_exporter = array();
    $tableau_idstyles_widgets = array();
    
    $fin = substr($arg,-9);
    if ($fin=="-type_php"){
        $type = "php";
    } else {
        $type = "txt";
    }
    
    $debut_arg = substr($arg,0,-9);

    if ($debut_arg){
        $tableau = explode("-",$debut_arg);

        foreach ($tableau AS $valeur){
            if (in_array($valeur,$valeurs_possibles)){
                $tableau_a_exporter[$valeur] = ciwidget_lire_meta_widget($valeur);
                
                if (isset($tableau_des_elements_par_widget[$valeur])){
                  foreach ($tableau_des_elements_par_widget[$valeur] AS $cle2=>$valeur2){
                        $tableau_idstyles_widgets[] = 'ciwidget_'.$valeur.'_'.$valeur2;
                  }
                }
            }
        }
        
        // Exporter uniquement les styles des widgets sélectionnés
        $tableau_des_styles = ciwidget_tableau_styles_selection($tableau_idstyles_widgets);
        

        if ($type=="php"){
            $content_type = 'text/x-php';
            $fichier_nom = "_config_ciwidget.php";
            
            $fichier = "<?php"
                    .PHP_EOL. "/*"
                    .PHP_EOL. "* Ce fichier ".$fichier_nom." doit être situé dans le dossier /config/ de SPIP"
                    .PHP_EOL. "* (ou bien dans le dossier du widget /ciwidget/ sachant que si le fichier est présent dans les deux dossiers, celui présent dans /config/ est prioritaire)."
                    .PHP_EOL. "* Une autre solution consiste à copier le contenu du fichier ".$fichier_nom." dans le fichier /config/mes_options.php de SPIP."
                    .PHP_EOL. "*/";
            
            $fichier .= PHP_EOL. "define('_CIWIDGET_CONFIG', '".base64_encode(serialize($tableau_a_exporter))."');";
            
            $fichier .= PHP_EOL. "define('_CIWIDGET_STYLES', '".base64_encode(serialize($tableau_des_styles))."');";
                
            if (in_array('couleur',$tableau)){
                $fichier .= PHP_EOL. "define('_CIWIDGET_PALETTE', '".base64_encode(serialize(array(array('nom'=>'palette','valeur'=>ciwidget_palette()))))."');";
                $fichier .= PHP_EOL. "define('_CIWIDGET_COULEUR', '".base64_encode(serialize(array(array('nom'=>'couleur','valeur'=>serialize(ciwidget_tableau_couleurs())))))."');";
            }

            if (in_array('rgpd',$tableau)){
                $fichier .= PHP_EOL. "define('_CIWIDGET_RGPD', '".base64_encode(serialize(ciwidget_lire_meta_widget('rgpd')))."');";
            }
            
            $fichier .= PHP_EOL. "?>";

            header("Content-type: ".$content_type);
            header("Content-Disposition: attachment; filename=\"$fichier_nom\";");			
            header("Expires: 0");
            header("Last-Modified: " .gmdate("D, d M Y H:i:s"). " GMT");
            header("Cache-Control: no-store, no-cache, must-revalidate");
            header("Pragma: no-cache");
            echo $fichier;
            
        } else {    
            $content_type = 'text/plain';
            $fichier_nom = "ciwidget_config.txt";
            $suffixe = 'czo0OiJzdHlsZSI7czo1OiJ2YWxldXIiO3M6MjIyOiJhOjEx';
            $separateur = ';';

            $fichier = $suffixe;

            foreach ($tableau AS $valeur){
                if (in_array($valeur,$valeurs_possibles)){
                    $fichier .= $separateur. $valeur. "|" . base64_encode(serialize(ciwidget_lire_meta_widget($valeur)));
                }
            }

            $fichier .= $separateur. "styles|" .base64_encode(serialize($tableau_des_styles));

            if (in_array('couleur',$tableau)){
                $fichier .= $separateur. "palette|" . base64_encode(serialize(array(array('nom'=>'palette','valeur'=>ciwidget_palette()))));
                $fichier .= $separateur. "couleur|" . base64_encode(serialize(array(array('nom'=>'couleur','valeur'=>serialize(ciwidget_tableau_couleurs())))));
            }
            
            if (in_array('rgpd',$tableau)){
                $fichier .= $separateur. "rgpd|" . base64_encode(serialize(ciwidget_lire_meta_widget('rgpd')));
            }
            
            header("Content-type: ".$content_type);
            header("Content-Disposition: attachment; filename=\"$fichier_nom\";");			
            header("Expires: 0");
            header("Last-Modified: " .gmdate("D, d M Y H:i:s"). " GMT");
            header("Cache-Control: no-store, no-cache, must-revalidate");
            header("Pragma: no-cache");
            echo $fichier;
        }
    }
}

?>