<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


function ciwidget_declarer_tables_interfaces($interface){
	
	$interface['table_des_tables']['ciwidget']='ciwidget';
	
	return $interface;
}

function ciwidget_declarer_tables_objets_sql($tables) {
	$tables['spip_ciwidget'] = array(
		'type' => 'ciwidget',
		'table_objet_surnoms' => array(),
		'type_surnoms' => array(),
		'url_voir' => '',
		'url_edit' => '',
		'page' => '',
		'texte_retour' => '',
		'texte_objets' => '(ne pas utiliser)',
		'texte_objet' => '',
		'texte_modifier' => '',
		'info_aucun_objet' => '',
		'info_1_objet' => '',
		'info_nb_objets' => '',
		'titre' => 'titre',
		'date' => 'date',
		'principale' => 'oui',
		'field' => array(
                        "id_widget" => "bigint(21) NOT NULL",
                        "type_widget" => "VARCHAR(25) DEFAULT '' NOT NULL",
                        "objet" => "VARCHAR (25) DEFAULT '' NOT NULL",
                        "id_objet" => "bigint(21) DEFAULT '0' NOT NULL",
                        "titre" => "text DEFAULT '' NOT NULL",
                        "descriptif" => "text DEFAULT '' NOT NULL",
                        "contenu" => "mediumtext NOT NULL DEFAULT ''",
                        "donnees" => "longtext NOT NULL DEFAULT ''",
                        "cache" => "longtext NOT NULL DEFAULT ''",
                        "vu" => "ENUM('non', 'oui') DEFAULT 'non' NOT NULL",
                        "rang_lien" => "int(4) DEFAULT '0' NOT NULL",
                        "maj" => "TIMESTAMP"
		),
		'key' => array(
                        "PRIMARY KEY"	=> "id_widget",
                        "KEY type_widget" => "type_widget",
                        "KEY id_objet" => "id_objet",
                        "KEY objet" => "objet"
		),
		'join' => array(
			'id_widget' => 'id_widget',
			"id_objet" => "id_objet",
			"objet" => "objet"
		),
		'statut' => array(),
		'tables_jointures' => array(),
		'rechercher_champs' => array(
			'titre' => 2,
			'descriptif' => 2,
			'donnees' => 2
		),
		'champs_editables' => array(
			'titre',
			'descriptif',
			'objet',
			'id_objet',
			'contenu',
			'vu',
			'rang_lien'
		),
		'champs_versionnes' => array(
		),
		'modeles' => array(),
	);

	// recherche jointe sur les widget pour les articles
	$tables['spip_articles']['rechercher_jointures']['ciwidget'] = ['titre' => 2, 'descriptif' => 2, 'donnees' => 2];
        
	return $tables;
}

function ciwidget_declarer_tables_auxiliaires($tables_auxiliaires){

	// table de stockage de donnees temporaires
	$spip_ciwidget_tmp = array(
                "id_widget_tmp" => "bigint(21) NOT NULL AUTO_INCREMENT",
                "maj_tmp" => "TIMESTAMP",
                "date_creation_tmp" => "datetime DEFAULT '0000-00-00 00:00:00' NOT NULL",
                "options" => "text DEFAULT '' NOT NULL",
		'id_auteur' => "bigint(21) DEFAULT '0' NOT NULL",
                "id_widget" => "bigint(21) NOT NULL",
                "type_widget" => "VARCHAR(25) DEFAULT '' NOT NULL",
                "objet" => "VARCHAR (25) DEFAULT '' NOT NULL",
                "id_objet" => "bigint(21) DEFAULT '0' NOT NULL",
                "titre" => "text DEFAULT '' NOT NULL",
                "descriptif" => "text DEFAULT '' NOT NULL",
                "contenu" => "mediumtext NOT NULL DEFAULT ''",
                "donnees" => "longtext NOT NULL DEFAULT ''",
                "cache" => "longtext NOT NULL DEFAULT ''",
                "vu" => "ENUM('non', 'oui') DEFAULT 'non' NOT NULL",
                "rang_lien" => "int(4) DEFAULT '0' NOT NULL",
                "maj" => "datetime DEFAULT '0000-00-00 00:00:00' NOT NULL");
	
	$spip_ciwidget_tmp_key = array(
		"PRIMARY KEY id_widget_tmp" => "id_widget_tmp",
		"KEY id_widget"	=> "id_widget");

	$tables_auxiliaires['spip_ciwidget_tmp'] = array(
		'field' => &$spip_ciwidget_tmp,
		'key' => &$spip_ciwidget_tmp_key);
		
	return $tables_auxiliaires;
}

?>