<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_tmp');
include_spip('inc/ciwidget_graphique');
include_spip('inc/filtres_boites');

function formulaires_ciwidget_graphique3_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
	if (!$id_widget_tmp){
		return false;
        }

        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'graphique');
        
        // securite
	if (!isset($valeurs['objet']) OR !isset($valeurs['id_objet']) OR !isset($valeurs['id_auteur']) 
                OR !autoriser('modifier',$valeurs['objet'],$valeurs['id_objet'])
                OR $valeurs['id_auteur']!=$GLOBALS['visiteur_session']['id_auteur']){
		return false;
        }
        
        $champs_prerequis = array(
            'type',
            'titre'
            );
        foreach ($champs_prerequis AS $champ){
            if (!isset($valeurs[$champ]) OR !$valeurs[$champ]){
                return false;
            }
        }
        
        $contenus = ciwidget_form3_champs();
        foreach ($contenus AS $contenu){
            if (!isset($valeurs[$contenu]) OR !$valeurs[$contenu]){
                $valeurs[$contenu] = ciwidget_lire_meta_cle('graphique',$contenu);
            }
        }
        
        $valeurs['retour_objet'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp,$objet,$id_objet,$valeurs);
        $valeurs['ci_action'] = self('&', true);
        
	return $valeurs;
}

function formulaires_ciwidget_graphique3_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        $erreurs = array();
        $suivant = _request('suivant');
           
        $serie_colonne = _request('serie_colonne');
        if (!in_array($serie_colonne, array('oui','non'))){
                $erreurs['serie_colonne'] = _T('ciwidget:valeur_incorrecte');
        }

        $data = ciwidget_graphique_extraire_data(_request('donnees'));
        if (substr($data,0,11)=='[["","","",' OR substr($data,0,11)=="[['','','',"){
            if ($suivant){
                $erreurs['donnees'] = _T('info_obligatoire');
            }
        } elseif (!ciwidget_verifier_data_sans_virgule($data)){
            $erreurs['donnees'] = _T('ciwidget:virgule_interdite');
        } elseif (!ciwidget_verifier_caracteres_speciaux_data($data)){
            $erreurs['donnees'] = _T('ciwidget:caracteres_autorises_data');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_graphique3_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        refuser_traiter_formulaire_ajax();    
    
        $type_widget = 'graphique';
        $c = array();
        $c['donnees'] = ciwidget_graphique_extraire_data(_request('donnees'));

        $contenu_nouveau = array();
        $contenus = ciwidget_form3_champs();
        foreach ($contenus AS $contenu){
            $contenu_nouveau[$contenu] = _request($contenu);
            if (!isset($contenu_nouveau[$contenu]) OR $contenu_nouveau[$contenu]==NULL){
                $contenu_nouveau[$contenu] = 'non';
            }
        }
        
        $contenu_nouveau['colonnes'] = ciwidget_graphique_extraire_colonnes(_request('donnees'));
        
        $id_widget_tmp = ciwidget_maj_tmp($id_widget,$id_widget_tmp,$c,$contenu_nouveau);

        $res = ciwidget_retour_formulaire_etape($objet,$id_objet,$id_widget,$id_widget_tmp,$type_widget,ciwidget_numform());

	return $res;
}

function ciwidget_form3_champs(){
    return array(
        'serie_colonne',
        'entete_colonne',
        'entete_ligne'
        );
}

?>