<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');

function formulaires_ciwidget_linkedin_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $valeurs = array('titre'=>'','largeur'=>ciwidget_lire_meta_cle('linkedin','largeur_defaut'));
        
        $id_widget = intval($id_widget);
	if ($id_widget>0) {
		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='linkedin'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
	}
        
        if (ciwidget_lire_meta_cle('linkedin','largeur_non_modifiable')=='oui'){
            $valeurs['ci_largeur_non_modifiable'] = 'oui';
            $valeurs['largeur'] = ciwidget_lire_meta_cle('linkedin','largeur_defaut');
        }
        
        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

	return $valeurs;
}

function formulaires_ciwidget_linkedin_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();
        
	$titre = _request('titre');	
	if (!$titre){
		$erreurs['titre'] = _T('info_obligatoire');
        }
        
	$code = _request('code');	
	if (!$code){
		$erreurs['code'] = _T('info_obligatoire');
        } elseif (!ci_linkedin_verifier_id($code)) {
		$erreurs['code'] = _T('ciwidget:valeur_incorrecte');
        }
        
	if (ciwidget_erreur_largeur(_request('largeur'))){
            $erreurs['largeur'] = ciwidget_erreur_largeur(_request('largeur'));
        }

        if (_request('largeur') AND !ctype_digit(_request('largeur'))){
		$erreurs['largeur'] = _T('ciwidget:valeur_incorrecte');
        }
        
        if (_request('augmenter_hauteur') AND !ctype_digit(_request('augmenter_hauteur'))){
		$erreurs['augmenter_hauteur'] = _T('ciwidget:valeur_incorrecte');
        }

        if (_request('augmenter_hauteur') AND intval(_request('augmenter_hauteur'))>1000){
		$erreurs['augmenter_hauteur'] = _T('ciwidget:valeur_incorrecte');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_linkedin_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);

        $c = array();
	foreach (array('titre') as $champ){
		$c[$champ] = _request($champ);
        }
        
        $code = _request('code');
        $largeur = ciwidget_verif_largeur_sinon_defaut(_request('largeur'), ciwidget_lire_meta_cle('linkedin','largeur_defaut'));
        if (_request('augmenter_hauteur')){
            $augmenter_hauteur = intval(_request('augmenter_hauteur'));
        } else {
            $augmenter_hauteur = '';
        }
        
        $type_widget = 'linkedin';
        $c['contenu'] = serialize(array('code'=>$code, 'largeur'=>$largeur, 'augmenter_hauteur'=>$augmenter_hauteur));
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter et lier
            $id_widget = sql_insertq('spip_ciwidget', $c);
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

// src="https://www.linkedin.com/embed/feed/update/urn:li:share:6713706854393880576
function ci_linkedin_verifier_id($code){
    $return = false;
    $code = str_replace("?compact=1","",$code);
    $debut = strpos($code,'src="https://www.linkedin.com/embed/feed/update/');
    
    if ($debut>0){
        $extrait = substr($code,$debut+43);
        $fin = strpos($extrait,'"');
        if ($fin>0){
            $extrait2 = substr($extrait, 0, $fin);
            $pos = strrpos ($extrait2,':');
            $nombre = substr($extrait2, $pos+1);
            if (ctype_digit($nombre)){
                $return = true;
            }
        }
    }    
    
    return $return;
}

?>