<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

include_spip('inc/ciwidget_tmp');
include_spip('inc/widget_commun');

function ciwidget_graphique_tmp_data($id_widget_tmp){
    return ciwidget_graphique_tableau_json_optimise($id_widget_tmp,false,true);
}

function ciwidget_graphique_data($id_widget){
    return ciwidget_graphique_tableau_json_optimise($id_widget,false,false);
}

function ciwidget_graphique_tmp_tableau($id_widget_tmp){
    return ciwidget_graphique_tableau_json_optimise($id_widget_tmp,false,true,false);
}

function ciwidget_graphique_extraire_data($donnees){
        $return = '';

        if (isset($donnees) AND $donnees){
            $debut = strpos($donnees,'"data":');
            if ($debut>0){
                $fin = strpos($donnees,']]',$debut);
            }
            $donnees = substr($donnees,$debut,$fin+2-$debut);
            $return = substr($donnees,7);
        }
        
        return $return;
}

function ciwidget_graphique_colonnes($id_widget_tmp){
        $colonnes = '';
        $id_widget = 0;
        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'graphique');
        
        if (isset($valeurs['colonnes']) AND $valeurs['colonnes']){
            $colonnes = $valeurs['colonnes'];
            
            // enlever les "name" car dans certains cas cela gêne jexcel
            $pattern = '/"name":"\d+"/i';
            $colonnes = preg_replace($pattern, '', $colonnes);  
            $pattern = '/"name":\d+/i';
            $colonnes = preg_replace($pattern, '', $colonnes);  
            
            $colonnes = str_replace('"align":"center"', ',', $colonnes);            
            $colonnes = str_replace(array(',,,',',,',',}'), array(',',',','}'), $colonnes);            
        }
        
        if (!$colonnes){
            if (_request('donnees')){
                $colonnes = ciwidget_graphique_extraire_colonnes(_request('donnees'));
            } else {
                for ($i = 0; $i < 14; $i++){
                    $colonnes .= "{type:'text',width:50},";
                }
                $colonnes = "[".substr($colonnes,0,-1)."]";
            }
        }
        
        return $colonnes;
}

function ciwidget_graphique_extraire_colonnes($donnees){
        $return = '';
        
        if (isset($donnees) AND $donnees){
            $debut = strpos($donnees,'"columns":');
            if ($debut>0){
                $fin = strpos($donnees,'}]',$debut);
            }
            $colonnes = substr($donnees,$debut,$fin+2-$debut);
            $return = substr($colonnes,10);
            $search = array('"source":[]',
                '"options":[]',
                '"editor":null',
                '"allowEmpty":false',
                '"title":""');
            $return = str_replace($search,'',$return);
            for ($i = 1; $i <= 5; $i++){
                $return = str_replace(',,',',',$return);
            }
            $return = str_replace(',}','}',$return);
        }
        
        return $return;
}

function ciwidget_verifier_data_sans_virgule($t) {
	$verif = true;
        
	if ($t) {
            // supprimer les separateurs de ligne
            $t = str_replace('],[','',$t);
            
            // supprimer les separateurs de cellule
            $tsa = str_replace('","','',$t);
            if (strlen($tsa)==strlen($t)){
                $tsa = str_replace("','","",$t);
            }
            if (!strpos($tsa,",")===false){
                $verif = false;
            }
        }
        
    	return $verif;        
}

function ciwidget_graphique_tableau_traduction($arg=''){
    
    if ($GLOBALS['meta']['langue_site']!='fr'){
        return '';
        
    } else {
    
    return "text:{
            noRecordsFound: 'Aucun enregistrement trouvé',
            showingPage: 'Page {0} sur {1}',
            show: 'Afficher ',
            search: 'Rechercher',
            entries: ' lignes',
            columnName: 'Nom de la colonne',
            insertANewColumnBefore: 'Insérer une colonne avant',
            insertANewColumnAfter: 'Insérer une colonne après',
            deleteSelectedColumns: 'Supprimer les colonnes sélectionnées',
            renameThisColumn: 'Renommer la colonne',
            orderAscending: 'Tri croissant',
            orderDescending: 'Tri décroissant',
            insertANewRowBefore: 'Insérer une ligne avant',
            insertANewRowAfter: 'Insérer une ligne après',
            deleteSelectedRows: 'Supprimer les lignes sélectionnées',
            editComments: 'Modifier le commentaire',
            addComments: 'Ajouter un commentaire',
            comments: 'Commentaire',
            clearComments: 'Supprimer le commentaire',
            copy: 'Copier...',
            paste: 'Coller...',
            saveAs: 'Enregistrer sous...',
            about: 'A propos',
            areYouSureToDeleteTheSelectedRows: 'Voulez-vous vraiment supprimer les lignes sélectionnées ?',
            areYouSureToDeleteTheSelectedColumns: 'Voulez-vous vraiment supprimer les colonnes sélectionnées ?',
            thisActionWillDestroyAnyExistingMergedCellsAreYouSure: 'Cette action supprimera toutes les cellules fusionnées existantes. Êtes-vous sûr de vouloir les supprimer ?',
            thisActionWillClearYourSearchResultsAreYouSure: 'Cette action effacera les résultats de la recherche. Êtes-vous sûr de vouloir les supprimer ?',
            thereIsAConflictWithAnotherMergedCell: 'Il y a un conflit avec une autre cellule fusionnée',
            invalidMergeProperties: 'Propriétés de fusion non valides',
            cellAlreadyMerged: 'Cellule déjà fusionnée',
            noCellsSelected: 'Aucune cellule sélectionnée'
        },";
    }
}

function ciwidget_graphique_config_par_defaut(){
    $return = array();
    $valeurs_par_defaut = ciwidget_lire_meta_widget('graphique');

    foreach ($valeurs_par_defaut AS $cle=>$valeur){
            $return[$cle] = $valeur;
    }
    
    return $return;
}

function ciwidget_graphique_config_json($id_widget,$tmp=false){

    if ($tmp){
        $valeurs = ciwidget_valeurs_tmp(0,$id_widget,'graphique');
        $ci_yAxes_unite = "ci_yAxes_unite";
        $ci_arrondi = "ci_arrondi";
    } else {
        $valeurs = ciwidget_valeurs_lues_en_base($id_widget,'graphique');
        $ci_yAxes_unite = "ci_".$id_widget."_yAxes_unite";
        $ci_arrondi = "ci_".$id_widget."_arrondi";
    }
    
    if(intval(_request('prerenseigner')>0) AND test_espace_prive()){
        $ci_yAxes_unite = "ci_yAxes_unite";
        $ci_arrondi = "ci_arrondi";
    }
    
    // valeurs par defaut
    $valeurs_par_defaut = ciwidget_graphique_config_par_defaut();
    foreach ($valeurs_par_defaut AS $cle=>$valeur){
        if (!isset($valeurs[$cle])){
            $valeurs[$cle] = $valeur;
        }
    }

    // convertir les booleens en texte
    foreach ($valeurs AS $cle=>$valeur){
        if ($valeurs[$cle]===true){
            $valeurs[$cle] = 'true';
        } elseif ($valeurs[$cle]===false){
            $valeurs[$cle] = 'false';
        }
    }

    // verifier avant d'inserer dans le javascript
    // et traiter les cas particuliers
    
    if (isset($valeurs['type']) AND $valeurs['type']){    
        $type = 'type: "'.$valeurs['type'].'",';
    } else {
        $type = 'type: "",';
    }
    
    $aspectRatio = '';
    if (isset($valeurs['aspect_ratio'])){
        $ci_aspect_ratio = ciwidget_aspect_ratio($valeurs['aspect_ratio'],'graphique');
        if ($ci_aspect_ratio>0){
            $aspectRatio = 'aspectRatio: '.strval($ci_aspect_ratio).',';
        }
    }

    if ($tmp OR (intval(_request('prerenseigner')>0) AND test_espace_prive())){
        $maintainAspectRatio = 'maintainAspectRatio: false,';
    } else {
        $maintainAspectRatio = 'maintainAspectRatio: true,';
    }

    if (isset($valeurs['titre']) AND $valeurs['titre']){    
        $titre = 'text: "'.$valeurs['titre'].'",';
    } else {
        $titre = 'text: "",';
    }

    $rotation = '';
    $circumference = '';
    if (in_array($valeurs['type'],array('pie','doughnut'))){
        $rotation = 'rotation: '.strval((((intval($valeurs['rotation'])/360) * 2) - 0.5) * pi())  . ',';
        $circumference = 'circumference: '.strval(intval($valeurs['circumference']) * pi()) . ',';
    }    
    
    if (isset($valeurs['legend_display']) AND $valeurs['legend_display']){    
        $legend_display = 'display: '.$valeurs['legend_display'].',';
    } else {
        $legend_display = '';
    }

    if (isset($valeurs['legend_position']) AND $valeurs['legend_position']){    
        $legend_position = 'position: "'.$valeurs['legend_position'].'",';
    } else {
        $legend_position = '';
    }
    
    if (isset($valeurs['legend_align']) AND $valeurs['legend_align']){    
        $legend_align = 'align: "'.$valeurs['legend_align'].'",';
    } else {
        $legend_align = '';
    }

    if (isset($valeurs['legend_reverse']) AND $valeurs['legend_reverse']){    
        $legend_reverse = 'reverse: '.$valeurs['legend_reverse'].',';
    } else {
        $legend_reverse = '';
    }

    $legend_callback = '';
    if (!isset($valeurs['legend_position']) OR $valeurs['legend_position']=='bottom'){
        if ($valeurs['type']=='line'){
            $legend_display = 'display: false,';
            $legend_fontsize = ciwidget_lire_meta_cle('graphique','legend_fontsize');

            if ($tmp OR (intval(_request('prerenseigner')>0) AND test_espace_prive())){
                $nom_tableau_options = 'tableau_options_des_series';
            } else {
                $nom_tableau_options = 'ci_'.$id_widget.'_tableau_options_des_series';
            }
    
            $legend_callback = '
                legendCallback: function(chart) {
                  var ci_tableau_couleurs_des_series = '.$nom_tableau_options.'[\'couleurs\'];
                  var ci_tableau_points_des_series = '.$nom_tableau_options.'[\'points\'];
                  var ci_tableau_radius_des_series = '.$nom_tableau_options.'[\'radius\'];
                  var ci_tableau_showline_des_series = '.$nom_tableau_options.'[\'showline\'];
                  var text = [];
                  var ci_moitie = Math.round(chart.data.datasets.length / 2) - 1;
                  var ci_style_span_commun = "display: inline-block; width: 30px; height: 6px; margin-right: 5px; flex: none;";
                  var ci_style_span2_commun = "display: inline-block; position: absolute; top: -2px; left: 0px;";
                  var ci_style_span2_dimensions = "";
                  var ci_style_span = "";
                  var ci_style_span2 = "";
                  var ci_background = "";
                  var ci_point_content = "";
                  var ci_radius = 0;
                  var ci_left = 0;
                  var ci_color = "color:'.ciwidget_lire_meta_cle("graphique","defaultfontcolor").';";
                  var ci_font = "font-family:'.str_replace("'","",ciwidget_fontfamily_to_js(ciwidget_lire_meta_cle('graphique','legend_fontfamily'))).';font-size:'.$legend_fontsize.'px;line-height:'.$legend_fontsize.'px;";

                  text.push(\'<div style="display: flex; margin: 0 0 1rem 4rem; padding: 0px;\' + ci_font + ci_color + \'">\');
                  text.push(\'<ul style="flex:1; margin: 0 1rem 0 0;">\');

                  for (var i = 0; i < chart.data.datasets.length; i++) {
                    text.push(\'<li style="align-items: center; cursor: pointer; display: flex; flex-direction: row; margin: 0 0 5px 0;">\');
                    ci_radius = 2 * ci_tableau_radius_des_series[i];
                    ci_style_span2_dimensions = "width: " + ci_radius + "px; height: " + ci_radius + "px;";
                    ci_style_span = "position: relative;";
                    ci_style_span2 = "";
                    ci_background = "background: " + ciwidget_hex2rgb(ci_tableau_couleurs_des_series[i]) + " none repeat scroll 0% 0%;";
                    ci_point_content = "";
                    if (ci_tableau_showline_des_series[i]!="non") {
                        ci_style_span = ci_style_span + ci_background;
                    }
                    if (ci_tableau_points_des_series[i]=="circle") {
                        ci_style_span2 = ci_style_span2_commun + ci_style_span2_dimensions + ci_background + "border-radius: 50%;";
                    } else if (ci_tableau_points_des_series[i]=="rect") {
                        ci_style_span2 = ci_style_span2_commun + ci_style_span2_dimensions + ci_background;
                    } else if (ci_tableau_points_des_series[i]=="rectRounded") {
                        ci_style_span2 = ci_style_span2_commun + ci_style_span2_dimensions + ci_background  + "border-radius: 40%;";
                    } else if (ci_tableau_points_des_series[i]=="rectRot") {
                        ci_style_span2 = ci_style_span2_commun + ci_style_span2_dimensions + ci_background + "transform: rotate(45deg) translateX(2px);";
                    } else if (ci_tableau_points_des_series[i]=="triangle") {
                        ci_style_span2 = "display: inline-block; width: 0; height: 0; position: absolute; top: -2px; left: 0px; border-left: " + ci_radius + "px solid transparent; border-right: " + ci_radius + "px solid transparent; border-bottom: " + ci_radius + "px solid " + ciwidget_hex2rgb(ci_tableau_couleurs_des_series[i]);
                    } else if (ci_tableau_points_des_series[i]=="cross") {
                        ci_style_span2 = ci_style_span2_commun + ci_style_span2_dimensions + "font-size:20px; color:" + ciwidget_hex2rgb(ci_tableau_couleurs_des_series[i]) + ";";
                        ci_point_content = "+";
                    } else if (ci_tableau_points_des_series[i]=="crossRot") {
                        ci_style_span2 = ci_style_span2_commun + ci_style_span2_dimensions + "font-size:18px; color:" + ciwidget_hex2rgb(ci_tableau_couleurs_des_series[i]) + ";";
                        ci_point_content = "x";
                    } else if (ci_tableau_points_des_series[i]=="star") {
                        ci_style_span2 = ci_style_span2_commun + ci_style_span2_dimensions + "font-size:20px; color:" + ciwidget_hex2rgb(ci_tableau_couleurs_des_series[i]) + ";";
                        ci_point_content = "&#128956;";
                    } else if (ci_tableau_points_des_series[i]=="line") {
                        ci_style_span2 = ci_style_span2_commun + ci_background + "width: 10px; height: 4px;";
                    } else if (ci_tableau_points_des_series[i]=="dash") {
                        ci_style_span2 = ci_style_span2_commun + ci_background + "width: 6px; height: 3px;";
                    }



                    text.push(\'<span style="\' + ci_style_span_commun + ci_style_span + \'"><span style="\' + ci_style_span2 + \'">\' + ci_point_content + \'</span></span>\');

                    if (chart.data.datasets[i].label) {
                      text.push(\'<p style="\' + ci_font + ci_color + \'margin: 0px; padding: 0px; text-align:left;">\' + chart.data.datasets[i].label + \'</p>\');
                    }

                    text.push(\'</li>\');

                    if (i == ci_moitie){
                        text.push(\'</ul>\');
                        text.push(\'<ul style="flex: 1;">\');
                    }
                  }

                  text.push(\'</ul>\');
                  text.push(\'</div>\');
                  return text.join(\'\');
                },            
            ';
        } elseif (!in_array($valeurs['type'],array('line','pie','doughnut')) ){
            $legend_display = 'display: false,';
            $legend_fontsize = ciwidget_lire_meta_cle('graphique','legend_fontsize');

            if ($tmp OR (intval(_request('prerenseigner')>0) AND test_espace_prive())){
                $nom_tableau_options = 'tableau_options_des_series';
            } else {
                $nom_tableau_options = 'ci_'.$id_widget.'_tableau_options_des_series';
            }
            $legend_callback = '
                legendCallback: function(chart) {
                  var ci_tableau_couleurs_des_series = '.$nom_tableau_options.'[\'couleurs\'];
                  var text = [];
                  var ci_moyenne_mobile = false;
                  var ci_lenght = chart.data.datasets.length;
                  var ci_moitie = 0;
                  var ci_style_span_commun = "display: inline-block; width: 30px; height: 6px; margin-right: 5px; flex: none;";
                  var ci_style_span = "";
                  var ci_background = "";
                  var ci_color = "color:'.ciwidget_lire_meta_cle("graphique","defaultfontcolor").';";
                  var ci_font = "font-family:'.str_replace("'","",ciwidget_fontfamily_to_js(ciwidget_lire_meta_cle('graphique','legend_fontfamily'))).';font-size:'.$legend_fontsize.'px;line-height:'.$legend_fontsize.'px;";

                  for (var i = 0; i < chart.data.datasets.length; i++) {
                    if (chart.data.datasets[i].label=="moyenne_mobile") {
                        ci_lenght = ci_lenght - 1;
                    }
                  }
                  ci_moitie = Math.round(ci_lenght / 2) - 1;
                    
                  text.push(\'<div style="display: flex; margin: 0 0 1rem 4rem; padding: 0px;\' + ci_font + ci_color + \'">\');
                  text.push(\'<ul style="flex:1; margin: 0 1rem 0 0;">\');

                  for (var i = 0; i < chart.data.datasets.length; i++) {
                    if (chart.data.datasets[i].label!="moyenne_mobile") {

                        text.push(\'<li style="align-items: center; cursor: pointer; display: flex; flex-direction: row; margin: 0 0 5px 0;">\');
                        ci_style_span = "position: relative;";
                        ci_background = "background: " + ciwidget_hex2rgb(ci_tableau_couleurs_des_series[i]) + " none repeat scroll 0% 0%;";
                        ci_style_span = ci_style_span + ci_background;

                        text.push(\'<span style="\' + ci_style_span_commun + ci_style_span + \'"></span>\');

                        if (chart.data.datasets[i].label) {
                          text.push(\'<p style="\' + ci_font + ci_color + \'margin: 0px; padding: 0px; text-align:left;">\' + chart.data.datasets[i].label + \'</p>\');
                        }

                        text.push(\'</li>\');
                    }
                    
                    if (i == ci_moitie){
                        text.push(\'</ul>\');
                        text.push(\'<ul style="flex: 1;">\');
                    }
                    
                  }

                  text.push(\'</ul>\');
                  text.push(\'</div>\');
                  return text.join(\'\');
                },            
            ';
        }
    }


    
    if (isset($valeurs['moyenne_active']) AND $valeurs['moyenne_active']=='oui'){    
        $legend_filter = 'filter: function(legendItem, data) { return legendItem.text == null || !legendItem.text.includes("moyenne_mobile"); },';
    } else {
        $legend_filter = '';
    }
    
    if (isset($valeurs['axe_suggestedMin']) AND $valeurs['axe_suggestedMin']!=''){    
        $axe_suggestedMin = 'suggestedMin: '.$valeurs['axe_suggestedMin'].',';
    } else {
        $axe_suggestedMin = '';
    }
    
    if (isset($valeurs['axe_suggestedMax']) AND $valeurs['axe_suggestedMax']){    
        $axe_suggestedMax = 'suggestedMax: '.$valeurs['axe_suggestedMax'].',';
    } else {
        $axe_suggestedMax = '';
    }

    if (isset($valeurs['axe_maxTicksLimit']) AND $valeurs['axe_maxTicksLimit']){    
        $axe_maxTicksLimit = 'maxTicksLimit: '.$valeurs['axe_maxTicksLimit'].',';
    } else {
        $axe_maxTicksLimit = '';
    }
    
    if (isset($valeurs['axe_ticks_display']) AND $valeurs['axe_ticks_display']){    
        $axe_ticks_display = 'display: '.$valeurs['axe_ticks_display'].',';
    } else {
        $axe_ticks_display = '';
    }
    
    if (isset($valeurs['yAxes_stacked']) AND $valeurs['yAxes_stacked']){    
        $stacked = 'stacked: '.$valeurs['yAxes_stacked'].',';
    } else {
        $stacked = '';
    }

    if (in_array($valeurs['type'],array('bar','horizontalBar'))){    
        $bar_category_Percentage = 'datasets:{';
        $bar_category_Percentage .= $valeurs['type'].':{';
        if (isset($valeurs['categoryPercentage']) AND $valeurs['categoryPercentage']){ 
            $bar_category_Percentage .= 'categoryPercentage: '.(intval($valeurs['categoryPercentage'])/100).',';
        }

        if (isset($valeurs['barPercentage']) AND $valeurs['barPercentage']){
            $bar_category_Percentage .= 'barPercentage: '.((100-intval($valeurs['barPercentage']))/100).',';
        }
        $bar_category_Percentage .= '}';
        $bar_category_Percentage .= '},';
    } else {
        $bar_category_Percentage = '';
    }
    
    if (isset($valeurs['xAxes_labelString']) AND $valeurs['xAxes_labelString']){    
        $xAxes_labelString = 'labelString: "'.$valeurs['xAxes_labelString'].'"';
    } else {
        $xAxes_labelString = '';
    }

    if (isset($valeurs['xAxes_gridLines_display']) AND $valeurs['xAxes_gridLines_display']){    
        $xAxes_gridLines_display = 'display: '.$valeurs['xAxes_gridLines_display'].',';
    } else {
        $xAxes_gridLines_display = '';
    }

    if (isset($valeurs['xAxes_gridLines_color']) AND $valeurs['xAxes_gridLines_color']){    
        $xAxes_gridLines_color = 'color: "'.$valeurs['xAxes_gridLines_color'].'",';
    } else {
        $xAxes_gridLines_color = 'color : JSON.parse(\'"rgba(0,0,0,0.3)"\')';
    }

    if (isset($valeurs['xAxes_suggestedMin']) AND $valeurs['xAxes_suggestedMin']!=''){    
        $xAxes_suggestedMin = 'suggestedMin: '.$valeurs['xAxes_suggestedMin'].',';
    } else {
        $xAxes_suggestedMin = '';
    }
    
    if (isset($valeurs['xAxes_suggestedMax']) AND $valeurs['xAxes_suggestedMax']){    
        $xAxes_suggestedMax = 'suggestedMax: '.$valeurs['xAxes_suggestedMax'].',';
    } else {
        $xAxes_suggestedMax = '';
    }

    $xAxes_beginAtZero = '';
/*    
    if ($xAxes_suggestedMin){
        $xAxes_beginAtZero = '';
    } else {    
        $xAxes_beginAtZero = 'beginAtZero: true,';
    }
*/    
    if (isset($valeurs['xAxes_maxTicksLimit']) AND $valeurs['xAxes_maxTicksLimit']){    
//        $xAxes_maxTicksLimit = 'maxTicksLimit: '.$valeurs['xAxes_maxTicksLimit'].',';
        $xAxes_maxTicksLimit = 'maxTicksLimit: '.$valeurs['xAxes_maxTicksLimit'].',';
    } else {
        $xAxes_maxTicksLimit = '';
    }

    if (isset($valeurs['xAxes_rotation']) AND $valeurs['xAxes_rotation']=='true'){    
        $xAxe_maxRotation = 'maxRotation: 90,';
    } else {
        $xAxe_maxRotation = 'maxRotation: 0,';
    }
    
    if (isset($valeurs['yAxes_labelString']) AND $valeurs['yAxes_labelString']){  
        $tableau_yAxes_labelString = array_map('trim',explode(PHP_EOL,$valeurs['yAxes_labelString']));
        if (count($tableau_yAxes_labelString)>1){
            $yAxes_labelString = 'labelString: ["'.implode('","',$tableau_yAxes_labelString).'"]';
        } else {
            $yAxes_labelString = 'labelString: "'.$valeurs['yAxes_labelString'].'"';
        }
    } else {
        $yAxes_labelString = '';
    }

    if (isset($valeurs['yAxes_gridLines_display']) AND $valeurs['yAxes_gridLines_display']){    
        $yAxes_gridLines_display = 'display: '.$valeurs['yAxes_gridLines_display'].',';
    } else {
        $yAxes_gridLines_display = '';
    }
    
    if (isset($valeurs['yAxes_gridLines_color']) AND $valeurs['yAxes_gridLines_color']){    
        $yAxes_gridLines_color = 'color: "'.$valeurs['yAxes_gridLines_color'].'",';
    } else {
        $yAxes_gridLines_color = 'color : JSON.parse(\'"rgba(0,0,0,0.3)"\')';
    }
    
    if (isset($valeurs['yAxes_suggestedMin']) AND $valeurs['yAxes_suggestedMin']!=''){    
        $yAxes_suggestedMin = 'suggestedMin: '.$valeurs['yAxes_suggestedMin'].',';
    } else {
        $yAxes_suggestedMin = '';
    }
    
    if (isset($valeurs['yAxes_suggestedMax']) AND $valeurs['yAxes_suggestedMax']){    
        $yAxes_suggestedMax = 'suggestedMax: '.$valeurs['yAxes_suggestedMax'].',';
    } else {
        $yAxes_suggestedMax = '';
    }

    $yAxes_beginAtZero = 'beginAtZero: false,';
    
    if (isset($valeurs['yAxes_maxTicksLimit']) AND $valeurs['yAxes_maxTicksLimit']){    
        $yAxes_maxTicksLimit = 'maxTicksLimit: '.$valeurs['yAxes_maxTicksLimit'].',';
    } else {
        $yAxes_maxTicksLimit = '';
    }

    
    if (isset($valeurs['type']) AND in_array($valeurs['type'],array('line'))){
        $lineTension = 'tension: 0.4,';
        if (isset($valeurs['lineborderwidth']) AND intval($valeurs['lineborderwidth'])){
            $lineborderwidth = 'borderWidth: '.intval($valeurs['lineborderwidth']).',';
        } elseif (isset($valeurs['lineborderwidth_defaut']) AND intval($valeurs['lineborderwidth_defaut'])){
            $lineborderwidth = 'borderWidth: '.intval($valeurs['lineborderwidth_defaut']).',';
        }
    } else {
        $lineTension = 'tension: 0,';
        $lineborderwidth = 'borderWidth: 1,';
    }

    if (isset($valeurs['point_style']) AND $valeurs['point_style']){    
        $point_style = 'pointStyle: "'.$valeurs['point_style'].'",';
    } else {
        $point_style = '';
    }

    if (isset($valeurs['point_radius'])){    
        $point_radius = 'radius: '.$valeurs['point_radius'].',';
        $hover_radius = 'hoverRadius: '.$valeurs['point_radius'].',';
    } else {
        $point_radius = '';
        $hover_radius = '';
    }

    if (isset($valeurs['type']) AND in_array($valeurs['type'],array('horizontalBar'))){
        $tooltipItemLabel = 'tooltipItem.xLabel';
    } else {
        $tooltipItemLabel = 'tooltipItem.yLabel';
    }
    
   
$monGraphique_options = '{
    '.$type.'
    options: {
        '.$bar_category_Percentage.'    
    
        plugins: {

            datalabels: {
                display: false,
                clamp: true,
                position: "center",
                color: "#888",
                offset: 4,
                font: {
                    family: "\'Arial\', \'Helvetica\', \'sans-serif\'",
                    size: 12,
                    style: "normal"
                }
            }
        },

        responsive: true,
        '.$maintainAspectRatio.'
        '.$aspectRatio.'

        animation: false,
        '.$circumference.'
        '.$rotation.'

        title: {
                display: false,
                '.$titre.'
                position: "top",
                fontFamily: "'.ciwidget_fontfamily_to_js(ciwidget_lire_meta_cle('graphique','title_fontfamily')).'",
                fontSize: '.ciwidget_lire_meta_cle('graphique','title_fontsize').',
                fontStyle: "'.ciwidget_lire_meta_cle('graphique','title_fontweight').'",
                fontColor: "'.ciwidget_lire_meta_cle('graphique','defaultfontcolor').'",
                padding: 10
        },
        legend: {
                '.$legend_display.' 
                '.$legend_position.' 
                '.$legend_align.' 
                '.$legend_reverse.' 
                labels: {
                        '.$legend_filter.' 
                        fontFamily: "'.ciwidget_fontfamily_to_js(ciwidget_lire_meta_cle('graphique','legend_fontfamily')).'",
                        fontSize: '.ciwidget_lire_meta_cle('graphique','legend_fontsize').',
                        fontStyle: "'.ciwidget_lire_meta_cle('graphique','legend_fontweight').'",
                        fontColor: "'.ciwidget_lire_meta_cle('graphique','defaultfontcolor').'",
                        padding: 10,
                        boxWidth: 10
                }
        },
        '.$legend_callback.'    
        
';

if (isset($valeurs['type']) AND in_array($valeurs['type'],array('pie','doughnut'))){
    $monGraphique_options .= '
        tooltips: {
            titleFontSize: '.ciwidget_lire_meta_cle('graphique','tooltips_titlefontsize').',
            bodyFontSize: '.ciwidget_lire_meta_cle('graphique','tooltips_bodyfontsize').',
            position: "nearest",
            callbacks: {
                title: function(tooltipItem, data) {
                  return data["labels"][tooltipItem[0]["index"]];
                },                
                label: function(tooltipItem, data) {
                    var label = data.datasets[tooltipItem.datasetIndex].label || "";

                    if (label) {
                        label += " : ";
                    }
                    label += Math.round(data.datasets[tooltipItem.datasetIndex].data[tooltipItem.index] * '.$ci_arrondi.') / '.$ci_arrondi.';
                    label = ciwidget_multilignes(ciwidget_separer_millier(label) + " " + '.$ci_yAxes_unite.');
                    return label;
                }
            }               
        },

';
}

if (isset($valeurs['type']) AND in_array($valeurs['type'],array('radar'))){
    $monGraphique_options .= '
        scale: {
            ticks: {
                '.$axe_ticks_display.'
                '.$axe_suggestedMin.'
                '.$axe_suggestedMax.'
                '.$axe_maxTicksLimit.'
            },
            pointLabels: {
                fontSize: '.ciwidget_lire_meta_cle('graphique','xaxeslabel_fontsize').',
                fontStyle: "'.ciwidget_lire_meta_cle('graphique','defautfontweight').'",
                fontFamily: "\'Arial\', \'Helvetica\', \'sans-serif\'"
            }
        },
        tooltips: {
            titleFontSize: '.ciwidget_lire_meta_cle('graphique','tooltips_titlefontsize').',
            bodyFontSize: '.ciwidget_lire_meta_cle('graphique','tooltips_bodyfontsize').',
            callbacks: {
                title: function(tooltipItem, data) {
                  return data["labels"][tooltipItem[0]["index"]];
                },                
                label: function(tooltipItem, data) {
                    var label = data.datasets[tooltipItem.datasetIndex].label || "";
                    if (label=="moyenne_mobile"){
                        label = "";
                    } else {
                        if (label) {
                            label += " : ";
                        }
                        if ('.$tooltipItemLabel.'){
                            label += Math.round('.$tooltipItemLabel.' * '.$ci_arrondi.') / '.$ci_arrondi.';
                            label = ciwidget_multilignes(ciwidget_separer_millier(label) + " " + '.$ci_yAxes_unite.');
                        } else {
                            label = "";
                        }
                    }   
                    return label;
                }
            }               
        },
';    
}

if (isset($valeurs['type']) AND !in_array($valeurs['type'],array('pie','doughnut','radar'))){
    
    $major = '';
    if ($valeurs['type']=='line'){
        if (isset($valeurs['ci_xaxes_showlastlabel']) AND isset($valeurs['ci_xaxes_lastlabelfontsize']) AND $valeurs['ci_xaxes_showlastlabel']=='true'){
            $major = 'major: {enabled: true,fontSize:'.$valeurs['ci_xaxes_lastlabelfontsize'].'},';            
        }
    }
    $monGraphique_options .= '
        tooltips: {
            titleFontSize: '.ciwidget_lire_meta_cle('graphique','tooltips_titlefontsize').',
            bodyFontSize: '.ciwidget_lire_meta_cle('graphique','tooltips_bodyfontsize').',
            mode: "index",
            intersect: false,
            position: "nearest",
            callbacks: {
                label: function(tooltipItem, data) {
                    var label = data.datasets[tooltipItem.datasetIndex].label || "";
                    if (label=="moyenne_mobile"){
                        label = "";
                    } else {
                        if (label) {
                            label += " : ";
                        }
                        if ('.$tooltipItemLabel.'){
                            label += Math.round('.$tooltipItemLabel.' * '.$ci_arrondi.') / '.$ci_arrondi.';
                            label = ciwidget_multilignes(ciwidget_separer_millier(label) + " " + '.$ci_yAxes_unite.');
                        } else {
                            label = "";
                        }
                    }   
                    return label;
                }
            }               
        },
        
        hover: {
            mode: "index",
            intersect: false
        },
        
        scales: {
            xAxes: [
                    {
                    display: true,
                    id: "xaxis0",
                    position: "bottom",
                    '.$stacked.'
                    scaleLabel: {
                            display: true,
                            fontSize: '.ciwidget_lire_meta_cle('graphique','xaxeslabel_fontsize').',
                            fontStyle: "'.ciwidget_lire_meta_cle('graphique','defautfontweight').'",
                            fontFamily: "\'Arial\', \'Helvetica\', \'sans-serif\'",
                            '.$xAxes_labelString.'
                    },
                    gridLines: {
                            '.$xAxes_gridLines_display.'
                            '.$xAxes_gridLines_color.'
                    },
                    ticks: {
                        fontSize: '.ciwidget_lire_meta_cle('graphique','xaxesticks_fontsize').',
                        fontStyle: "'.ciwidget_lire_meta_cle('graphique','defautfontweight').'",
                        '.$major.'
                        '.$xAxes_suggestedMin.'
                        '.$xAxes_suggestedMax.'
                        '.$xAxes_beginAtZero.'
                        autoSkip: true,
                        '.$xAxes_maxTicksLimit.'
                        '.$xAxe_maxRotation.'    
                        minRotation: 0
                    },
                },
            ],

            yAxes: [
                    {
                    display: true,
                    id: "yaxis0",
                    position: "left",
                    '.$stacked.'
                    scaleLabel: {
                            display: true,
                            fontSize: '.ciwidget_lire_meta_cle('graphique','yaxeslabel_fontsize').',
                            fontStyle: "'.ciwidget_lire_meta_cle('graphique','defautfontweight').'",
                            fontFamily: "\'Arial\', \'Helvetica\', \'sans-serif\'",
                            '.$yAxes_labelString.'
                    },
                    gridLines: {
                            '.$yAxes_gridLines_display.'
                            '.$yAxes_gridLines_color.'
                    },
                    ticks: {
                        fontSize: '.ciwidget_lire_meta_cle('graphique','yaxesticks_fontsize').',
                        fontStyle: "'.ciwidget_lire_meta_cle('graphique','defautfontweight').'",
                        callback: function(value, index, values) { 
                            return ciwidget_separer_millier(value); 
                        },
                        '.$yAxes_suggestedMin.'
                        '.$yAxes_suggestedMax.'
                        '.$yAxes_beginAtZero.'
                        '.$yAxes_maxTicksLimit.'
                        autoSkip: true
                    }
                },
            ],
        },

';
}

/*
                },
                point: {
                        '.$point_style.'
                        '.$point_radius.'
                        '.$hover_radius.'
                        borderWidth: 1

 */

$monGraphique_options .= '
        elements: {

                line: {
                        '.$lineborderwidth.'
                        '.$lineTension.'
                        cubicInterpolationMode: "default"
                }
        },
        layout: {
                padding:{
                        left: 10,
                        right: 10,
                        top: 10,
                        bottom: 10
                }
        }
    },
    data: {}
};
';

    return $monGraphique_options;
}

function ciwidget_graphique_tableau_nom_options_series(){
    return array('couleurs','points','radius','showline','lineborderwidth','lineborderdash');
}

function ciwidget_graphique_options_series_javascript($id_widget,$type_widget=''){
    if ($type_widget=='line'){
        $tableau_nom_options_series = ciwidget_graphique_tableau_nom_options_series();
    } else {
        $tableau_nom_options_series = array('couleurs');        
    }
    $newTab = "ci_".$id_widget."_tableau_options_des_series";
    
    $return = "var ".$newTab." = new Array();".PHP_EOL;

    foreach ($tableau_nom_options_series AS $nom_option){
        $return .= $newTab."['".$nom_option."'] = ".ciwidget_graphique_options_series_json($id_widget,$nom_option).";".PHP_EOL;
    }
    
    return $return;
}

function ciwidget_graphique_tmp_options_series_javascript($id_widget,$type_widget=''){
    if ($type_widget=='line'){
        $tableau_nom_options_series = ciwidget_graphique_tableau_nom_options_series();
    } else {
        $tableau_nom_options_series = array('couleurs');        
    }
    $newTab = "tableau_options_des_series";
    
    $return = "var ".$newTab." = new Array();".PHP_EOL;

    foreach ($tableau_nom_options_series AS $nom_option){
        $return .= $newTab."['".$nom_option."'] = ".ciwidget_graphique_tmp_options_series_json($id_widget,$nom_option).";".PHP_EOL;
    }
    
    return $return;
}

function ciwidget_graphique_options_series_json($id_widget,$nom_option){
    $return = '';
    $tableau_nom_options_series = ciwidget_graphique_tableau_nom_options_series();
    
    if (in_array($nom_option,$tableau_nom_options_series)){
        $f = 'ciwidget_graphique_'.$nom_option.'_series';
        $serie_options = $f($id_widget,false,true); // tmp=false et callback=true

        foreach ($serie_options AS $nom=>$valeur){
            $return .= '"'.$valeur.'",';
        }

        if ($return){
            $return = substr($return,0,-1);
        }
        $return = '['.$return.']';
    }
    
    return $return;
}

function ciwidget_graphique_option_series($id_widget,$nom_option,$nom_defaut,$nom_serie,$tmp=false){
    $option_series = array();
    $data = '';
    $serie_colonne = true;
    $entete_colonne = false;
    $entete_ligne = false;
    $nombre = 0;
    $nombre_colonnes = 0;
    $nombre_lignes = 0;
    $valeur_par_defaut = '';
    
    $tableau_nom_options_series = ciwidget_graphique_tableau_nom_options_series();
    
    if (in_array($nom_option,$tableau_nom_options_series) AND $nom_option!='couleurs'){
        
        $valeurs_defaut = ciwidget_lire_meta_widget('graphique');

        if (isset($valeurs_defaut[$nom_defaut])){
            $valeur_par_defaut = $valeurs_defaut[$nom_defaut];
        }
        
        if ($tmp){
            $valeurs = ciwidget_valeurs_tmp(0,$id_widget,'graphique');
        } else {
            $valeurs = ciwidget_valeurs_lues_en_base($id_widget,'graphique');
        }

        // compatibilite ascendante
        if ($nom_option=='radius' AND isset($valeurs['point_radius'])){
            if (isset($valeurs_defaut['point_radius']) AND intval($valeurs_defaut['point_radius'])>0){
                $valeur_par_defaut = strval(100 * ( intval($valeurs['point_radius']) / intval($valeurs_defaut['point_radius'])));
            }
        }
        
        if (isset($valeurs['donnees']) AND $valeurs['donnees']){
            $data = $valeurs['donnees'];
        }
        if (isset($valeurs['serie_colonne']) AND $valeurs['serie_colonne']!='oui'){
            $serie_colonne = false;
        }
        if (isset($valeurs['entete_colonne']) AND $valeurs['entete_colonne']=='oui'){    
            $entete_colonne = true;
        }
        if (isset($valeurs['entete_ligne']) AND $valeurs['entete_ligne']=='oui'){    
            $entete_ligne = true;
        }
        
        if (in_array($valeurs['type'],array('pie','doughnut'))){
                $pos = strpos($data,'],[');
                $extrait = substr($data,0,$pos);
                $extrait = str_replace(',""','',$extrait);
                $nombre_colonnes = substr_count($extrait,',');
                if (!$entete_ligne){
                    $nombre_colonnes = $nombre_colonnes + 1;
                }
                
                $extrait = str_replace('],[""','',$data);
                $nombre_lignes = substr_count($extrait,'"],');
                if (!$entete_colonne){
                    $nombre_lignes = $nombre_lignes + 1;
                }
                $nombre = max($nombre_colonnes,$nombre_lignes);
                
        } else {
            if ($serie_colonne){
                $pos = strpos($data,'],[');
                $extrait = substr($data,0,$pos);
                $extrait = str_replace(',""','',$extrait);
                $nombre = substr_count($extrait,',');
                if (!$entete_ligne){
                    $nombre = $nombre + 1;
                }
            } else {
                $extrait = str_replace('],[""','',$data);
                $nombre = substr_count($extrait,'"],');
                if (!$entete_colonne){
                    $nombre = $nombre + 1;
                }
            }
        }
        
        for ($i = 1; $i <= $nombre; $i++){
            $nom = $nom_serie.$i;
            $hexa = '';
            if (isset($valeurs[$nom]) AND $valeurs[$nom]){
                $option_series[$nom] = $valeurs[$nom];
            } else {
                if (isset($valeurs[$nom_defaut]) AND $valeurs[$nom_defaut]){
                    $option_series[$nom] = $valeurs[$nom_defaut];
                } else {
                    $option_series[$nom] = $valeur_par_defaut;                
                }
            }
        }
        
    }
    
    return $option_series;
}

function ciwidget_graphique_couleurs_series($id_widget,$tmp=false){
    $couleurs_series = array();
    $data = '';
    $serie_colonne = true;
    $entete_colonne = false;
    $entete_ligne = false;
    $nombre = 0;
    $nombre_colonnes = 0;
    $nombre_lignes = 0;
            
    $couleurs_par_defaut = array();
    $valeurs_defaut = ciwidget_lire_meta_widget('graphique');
    for ($n = 1; $n <= 12; $n++){
        $nom_defaut = 'couleur_serie'.strval($n);
        if (isset($valeurs_defaut[$nom_defaut]) AND $valeurs_defaut[$nom_defaut]){
            $couleurs_par_defaut[$nom_defaut] = $valeurs_defaut[$nom_defaut];
        } else {
            $couleurs_par_defaut[$nom_defaut] = '';
        }
    } 
    
    if ($tmp){
        $valeurs = ciwidget_valeurs_tmp(0,$id_widget,'graphique');
    } else {
        $valeurs = ciwidget_valeurs_lues_en_base($id_widget,'graphique');
    }
    
    if (isset($valeurs['donnees']) AND $valeurs['donnees']){
        $data = $valeurs['donnees'];
    }
    if (isset($valeurs['serie_colonne']) AND $valeurs['serie_colonne']!='oui'){
        $serie_colonne = false;
    }
    if (isset($valeurs['entete_colonne']) AND $valeurs['entete_colonne']=='oui'){    
        $entete_colonne = true;
    }
    if (isset($valeurs['entete_ligne']) AND $valeurs['entete_ligne']=='oui'){    
        $entete_ligne = true;
    }

    if (in_array($valeurs['type'],array('pie','doughnut'))){
            $pos = strpos($data,'],[');
            $extrait = substr($data,0,$pos);
            $extrait = str_replace(',""','',$extrait);
            $nombre_colonnes = substr_count($extrait,',');
            if (!$entete_ligne){
                $nombre_colonnes = $nombre_colonnes + 1;
            }

            $extrait = str_replace('],[""','',$data);
            $nombre_lignes = substr_count($extrait,'"],');
            if (!$entete_colonne){
                $nombre_lignes = $nombre_lignes + 1;
            }
            $nombre = max($nombre_colonnes,$nombre_lignes);

    } else {
        if ($serie_colonne){
            $pos = strpos($data,'],[');
            $extrait = substr($data,0,$pos);
            $extrait = str_replace(',""','',$extrait);
            $nombre = substr_count($extrait,',');
            if (!$entete_ligne){
                $nombre = $nombre + 1;
            }
        } else {
            $extrait = str_replace('],[""','',$data);
            $nombre = substr_count($extrait,'"],');
            if (!$entete_colonne){
                $nombre = $nombre + 1;
            }
        }
    }

    if (isset($valeurs['moyenne_active']) AND $valeurs['moyenne_active']=='oui'){
        $nombre = $nombre + 1;
    }
    
    for ($i = 1; $i <= $nombre; $i++){
        $nom = "couleur_serie".$i;
        $hexa = '';
        if (isset($valeurs[$nom]) AND $valeurs[$nom]){
            $couleurs_series[$nom] = $valeurs[$nom];
        } else {
            if (isset($couleurs_par_defaut[$nom])){
                $couleurs_series[$nom] = $couleurs_par_defaut[$nom];
            } else {
                $couleurs_series[$nom] = "#".str_pad(dechex(mt_rand(0,16777215)),6,'0');                
            }
        }
    }
    
    return $couleurs_series;
}

function ciwidget_graphique_points_series($id_widget,$tmp=false,$callback=false){
    $nom_option = 'points';
    $nom_defaut = 'point_style';
    $nom_serie = 'point_serie';
    return ciwidget_graphique_option_series($id_widget,$nom_option,$nom_defaut,$nom_serie,$tmp);    
}

function ciwidget_graphique_showline_series($id_widget,$tmp=false,$callback=false){
    $nom_option = 'showline';
    $nom_defaut = 'showline_defaut';
    $nom_serie = 'showline_serie';
    return ciwidget_graphique_option_series($id_widget,$nom_option,$nom_defaut,$nom_serie,$tmp);    
}

function ciwidget_graphique_radius_series($id_widget,$tmp=false,$callback=false){
    $nom_option = 'radius';
    $nom_defaut = 'radius_serie_defaut';
    $nom_serie = 'radius_serie';
    $tableau = ciwidget_graphique_option_series($id_widget,$nom_option,$nom_defaut,$nom_serie,$tmp);
    if ($callback){
        $tableau = ciwidget_graphique_conversion_du_pourcentage_multiple_par_valeur_defaut($tableau,'point_radius');
    }
    return $tableau;
}

function ciwidget_graphique_lineborderwidth_series($id_widget,$tmp=false,$callback=false){
    $nom_option = 'lineborderwidth';
    $nom_defaut = 'lineborderwidth_serie_defaut';
    $nom_serie = 'lineborderwidth_serie';        
    $tableau = ciwidget_graphique_option_series($id_widget,$nom_option,$nom_defaut,$nom_serie,$tmp);
    if ($callback){
        $tableau = ciwidget_graphique_conversion_du_pourcentage_multiple_par_valeur_defaut($tableau,'lineborderwidth_defaut');
    }
    return $tableau;
}

function ciwidget_graphique_lineborderdash_series($id_widget,$tmp=false,$callback=false){
    $nom_option = 'lineborderdash';
    $nom_defaut = 'lineborderdash_serie_defaut';
    $nom_serie = 'lineborderdash_serie';        
    return ciwidget_graphique_option_series($id_widget,$nom_option,$nom_defaut,$nom_serie,$tmp);    
}

function ciwidget_graphique_conversion_du_pourcentage_multiple_par_valeur_defaut($tableau,$nom_defaut){
    $return = array();
    $valeur_par_defaut = 1;
    $valeurs_defaut = ciwidget_lire_meta_widget('graphique');
    $entier = '';

    if (isset($valeurs_defaut[$nom_defaut]) AND intval($valeurs_defaut[$nom_defaut])>0){
        $valeur_par_defaut = intval($valeurs_defaut[$nom_defaut]);
    }
    
    foreach ($tableau AS $cle=>$valeur){
        $return[$cle] = round((floatval($valeur) * floatval($valeur_par_defaut)) / 100);
    }
    
    return $return;
}

function ciwidget_graphique_script($arg=''){
    static $done = false;
    static $firstarg = 0;
    $return = '';
    
    // compatibilite avec un squelette qui contient plusieurs fois la balise #TEXTE du meme objet
    if (!$done OR $firstarg==$arg){
        $done = true;
        $firstarg = $arg;
        $return = '<script src="'.find_in_path("lib/chartjs/Chart_ci1_min.js").'"></script>';
        $return .= '<script src="'.find_in_path("_js/ciwidget_graphique_v29.js").'"></script>';
    }
    
    return $return;
}

function ciwidget_graphique_script_widget($id_widget){
    $return = '';
    $id_widget = intval($id_widget);

    if ($id_widget>0){
        $valeurs = ciwidget_valeurs_lues_en_base($id_widget,'graphique');

        if (isset($valeurs['arrondi']) AND $valeurs['arrondi']){    
            $arrondi = intval($valeurs['arrondi']);
        } else {
            $arrondi = 100;
        }
        
        if (isset($valeurs['opacite'])){    
            $opacite = intval($valeurs['opacite'])/100;
        } else {
            $opacite = 0.3;
        }

        if (isset($valeurs['point_radius'])){    
            $radius = intval($valeurs['point_radius']);
        } else {
            $radius = 0;
        }
        
        if (isset($valeurs['moyenne_active']) AND $valeurs['moyenne_active']=='oui'){    
            $moyenne_active = 'oui';
        } else {
            $moyenne_active = 'non';
        }
        
        if (isset($valeurs['moyenne_ordre']) AND $valeurs['moyenne_ordre']){    
            $moyenne_ordre = intval($valeurs['moyenne_ordre']);
        } else {
            $moyenne_ordre = 3;
        }

        if (isset($valeurs['serie_colonne']) AND $valeurs['serie_colonne']=='oui'){    
            $serie_colonne = 'oui';
        } else {
            $serie_colonne = 'non';
        }
        
        if (isset($valeurs['entete_colonne']) AND $valeurs['entete_colonne']=='oui'){    
            $entete_colonne = 'oui';
        } else {
            $entete_colonne = 'non';
        }

        if (isset($valeurs['entete_ligne']) AND $valeurs['entete_ligne']=='oui'){    
            $entete_ligne = 'oui';
        } else {
            $entete_ligne = 'non';
        }
        
        $legende_html = '';
        if (!isset($valeurs['legend_position']) OR $valeurs['legend_position']=='bottom'){
            $legende_html = "$('#graphique_".$id_widget."_legend').prepend(ci_".$id_widget."_graphique.generateLegend());";
        }
        
$return = "<script>
    
var ci_".$id_widget."_type = '".$valeurs['type']."';
".ciwidget_graphique_options_series_javascript($id_widget,$valeurs['type'])."    
var ci_".$id_widget."_yAxes_unite = '".texte_script($valeurs['yAxes_unite'])."';

var ci_".$id_widget."_arrondi = ".$arrondi.";

var ci_".$id_widget."_opacite = ".$opacite.";
var ci_".$id_widget."_radius = ".$radius.";

var ci_".$id_widget."_moyenne_active = '".$moyenne_active."';
var ci_".$id_widget."_moyenne_ordre = ".$moyenne_ordre.";


var ci_".$id_widget."_canvas = document.getElementById('graphique_".$id_widget."').getContext('2d');
var ci_".$id_widget."_graphique_options = ".ciwidget_graphique_config_json($id_widget)."; 

".ciwidget_chart_defaut_font()." 

var ci_".$id_widget."_graphique = new Chart(ci_".$id_widget."_canvas, ci_".$id_widget."_graphique_options);

var ci_".$id_widget."_donnees = ".ciwidget_graphique_data($id_widget).";
var ci_".$id_widget."_serie_colonne = '".$serie_colonne."';
var ci_".$id_widget."_entete_colonne = '".$entete_colonne."';
var ci_".$id_widget."_entete_ligne = '".$entete_ligne."';

ciwidget_graphique_affiche_donnees(ci_".$id_widget."_graphique,ci_".$id_widget."_donnees,ci_".$id_widget."_type,ci_".$id_widget."_serie_colonne,ci_".$id_widget."_entete_colonne,ci_".$id_widget."_entete_ligne,ci_".$id_widget."_tableau_options_des_series,ci_".$id_widget."_opacite,ci_".$id_widget."_radius,ci_".$id_widget."_moyenne_active,ci_".$id_widget."_moyenne_ordre);

".$legende_html."    

</script>";    
    }
    return $return;
}

function ciwidget_chart_defaut_font($arg=''){
    $chart_defaut_font = '';
    if ($defaultFontColor = ciwidget_lire_meta_cle('graphique','defaultfontcolor')){
        $chart_defaut_font .= 'Chart.defaults.global.defaultFontColor = "'.$defaultFontColor.'";';
    }
    if ($defaultFontFamily = ciwidget_lire_meta_cle('graphique','defaultfontfamily')){
        $chart_defaut_font .= 'Chart.defaults.global.defaultFontFamily = "'.ciwidget_fontfamily_to_js($defaultFontFamily).'";';
    }
    return $chart_defaut_font;
}

function ciwidget_enregistrer_image($id_widget=0){
    $id_document = 0;
    $id_document_actuel = 0;
    $id_widget = intval($id_widget);
    $objet = '';
    $id_objet = 0;
    $mode = 'image';
    $contenu = array();
    
    if ($id_widget>0){
        if(isset($_POST['graphique_image']) AND $_POST['graphique_image']){
            $data = explode(',', $_POST['graphique_image']);
            $image = "graphique_image_".$id_widget.".png";
            $path = sous_repertoire(_DIR_CACHE, 'export');
            file_put_contents($path.$image, base64_decode($data[1]));

            // Est-ce que l'image existe ?
            $result = sql_select("*", "spip_ciwidget", "id_widget=".$id_widget);
            while ($row = sql_fetch($result)) { 
                $objet = $row['objet'];
                $id_objet = $row['id_objet'];
                
                if (isset($row['contenu'])){
                    $contenu = unserialize($row['contenu']);
                    if (isset($contenu['id_document_image']) AND $contenu['id_document_image']){
                        $id_document = $contenu['id_document_image'];
                        $id_document_actuel = $contenu['id_document_image'];
                    }
                }
            }

            $count_img = sql_countsel("spip_documents", "id_document=".$id_document);
            if (!$count_img){
                $id_document = 0;
                $id_document_actuel = 0;
            }
            
            $file = array('tmp_name' => $path.$image, 'name' => $image);
            $files = array($file);

            $ajouter_documents = charger_fonction('ajouter_documents', 'action');
            $nouveaux_doc = $ajouter_documents($id_document, $files, $objet, $id_objet, $mode);

            foreach ($nouveaux_doc as $doc) {
                if (is_numeric($doc)) {
                    $id_document = $doc;
                    $contenu['id_document_image'] = $id_document;
                    if (!$id_document_actuel){
                        sql_updateq("spip_ciwidget", array('contenu'=>serialize($contenu)), "id_widget=$id_widget");
                    }
                    
                    // IMPORTANT : ne pas lier le document à l'objet
                    sql_delete("spip_documents_liens", "id_document=".$id_document." AND objet='".$objet."' AND id_objet=".$id_objet);
                    
                    // lier le document au widget
                    if (!$id_document_actuel){
                        sql_insertq('spip_documents_liens', array('id_document'=>$id_document,'objet'=>'ciwidget','id_objet'=>$id_widget,'vu'=>'oui'));
                    }    
                }
            }        
            
            unlink($path.$image);
        }
    }
}

function ciwidget_graphique_tmp_options_series_json($id_widget,$nom_option){
    $return = '';
    $tableau_nom_options_series = ciwidget_graphique_tableau_nom_options_series();
    
    if (in_array($nom_option,$tableau_nom_options_series)){
        $f = 'ciwidget_graphique_tmp_'.$nom_option.'_series';
        $serie_options = $f($id_widget,true); // callback=true

        foreach ($serie_options AS $nom=>$valeur){
            $return .= '"'.$valeur.'",';
        }

        if ($return){
            $return = substr($return,0,-1);
        }
        $return = '['.$return.']';
    }
    
    return $return;
}


function ciwidget_graphique_tmp_couleurs_series($id_widget_tmp,$callback=false){
    $prerenseigner = ciwidget_graphique_id_prerenseigner($id_widget_tmp);    
    
    if ($prerenseigner>0) {
        return ciwidget_graphique_couleurs_series($prerenseigner);
    } else {
        return ciwidget_graphique_couleurs_series($id_widget_tmp,true);
    }
}

function ciwidget_graphique_tmp_choix_couleurs_series($id_widget_tmp,$moyenne_active=''){
    $return = '';
    $prefixe = _T('ciwidget:serie');
    $couleurs_series = ciwidget_graphique_tmp_couleurs_series($id_widget_tmp);
    $nombre = count($couleurs_series);
    $i = 0;
    $libelle = '';
    
    foreach ($couleurs_series AS $nom=>$hexa){
        $i++;
        $libelle = $prefixe.' '.str_replace('couleur_serie','',$nom);
        if ($moyenne_active=='oui' AND $i==$nombre){
            $libelle = _T('ciwidget:moyenne_mobile');
        }
        
        $return .= '<div class="ci_wrapper_color">
                    <label for="'.$nom.'">'.$libelle.'</label>
                    <input type="text" class="color" name="'.$nom.'" id="'.$nom.'" value="'.$hexa.'" style="width:110px;height:22px;" onchange="ci_change_couleur_serie('.str_replace('couleur_serie','',$nom).',this.value);" />
                    </div>';
    }
    
    return $return;
}

function ciwidget_graphique_tmp_points_series($id_widget_tmp,$callback=false){
    $prerenseigner = ciwidget_graphique_id_prerenseigner($id_widget_tmp);    
    
    if ($prerenseigner>0) {
        return ciwidget_graphique_points_series($prerenseigner);
    } else {
        return ciwidget_graphique_points_series($id_widget_tmp,true,$callback);
    }
}

function ciwidget_graphique_tmp_choix_points_series($id_widget_tmp,$prerenseigner=''){
    $return = '';
    $prefixe = _T('ciwidget:serie');
    
    $points_series = ciwidget_graphique_tmp_points_series($id_widget_tmp);

    $tableau_valeurs = array();
    foreach (array('aucun_point','circle','triangle','rect','rectRounded','rectRot','cross','crossRot','star','line','dash') AS $valeur){
        $tableau_valeurs[$valeur] = _T('ciwidget:'.$valeur);
    }
    
    foreach ($points_series AS $nom_element=>$valeur_element){
        $selected = '';
        
        $return .= '<div class="ci_wrapper_color">';
        $return .= '<label for="'.$nom_element.'">'.$prefixe.' '.str_replace('point_serie','',$nom_element).'</label>';
        $return .= '<select name="'.$nom_element.'" id="'.$nom_element.'" onchange="ci_change_point_serie('.str_replace('point_serie','',$nom_element).',this.value);"  style="width:110px;margin:0px 10px;">'."\n";

        // Parcours du tableau
        foreach($tableau_valeurs as $valeur=>$libelle){
            if($valeur == $valeur_element){
                $selected = ' selected="selected"';
            } else {
                $selected = '';
            }

            // Affichage de la ligne
            $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'.$libelle.'</option>'."\n";
        }
        
        $return .= '</select>'."\n";
        $return .= '</div>';
    }
    
    return $return;
}

function ciwidget_graphique_tmp_showline_series($id_widget_tmp,$callback=false){
    $prerenseigner = ciwidget_graphique_id_prerenseigner($id_widget_tmp);    
    
    if ($prerenseigner>0) {
        return ciwidget_graphique_showline_series($prerenseigner);
    } else {
        return ciwidget_graphique_showline_series($id_widget_tmp,true,$callback);
    }
}

function ciwidget_graphique_tmp_choix_showline_series($id_widget_tmp,$prerenseigner=''){
    $return = '';
    $prefixe = _T('ciwidget:serie');
    
    $showline_series = ciwidget_graphique_tmp_showline_series($id_widget_tmp);

    $tableau_valeurs = array();
    foreach (array('oui','non') AS $valeur){
        $tableau_valeurs[$valeur] = _T('ciwidget:'.$valeur);
    }
    
    foreach ($showline_series AS $nom_element=>$valeur_element){
        $selected = '';
        
        $return .= '<div class="ci_wrapper_color">';
        $return .= '<label for="'.$nom_element.'">'.$prefixe.' '.str_replace('showline_serie','',$nom_element).'</label>';
        $return .= '<select name="'.$nom_element.'" id="'.$nom_element.'" onchange="ci_change_showline_serie('.str_replace('showline_serie','',$nom_element).',this.value);"  style="width:110px;margin:0px 10px;">'."\n";

        // Parcours du tableau
        foreach($tableau_valeurs as $valeur=>$libelle){
            if($valeur == $valeur_element){
                $selected = ' selected="selected"';
            } else {
                $selected = '';
            }

            // Affichage de la ligne
            $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'.$libelle.'</option>'."\n";
        }
        
        $return .= '</select>'."\n";
        $return .= '</div>';
    }
    
    return $return;
}

function ciwidget_graphique_tmp_radius_series($id_widget_tmp,$callback=false){
    $prerenseigner = ciwidget_graphique_id_prerenseigner($id_widget_tmp);    
    
    if ($prerenseigner>0) {
        return ciwidget_graphique_radius_series($prerenseigner,false,$callback);
    } else {
        return ciwidget_graphique_radius_series($id_widget_tmp,true,$callback);
    }
}

function ciwidget_graphique_tmp_choix_radius_series($id_widget_tmp,$prerenseigner=''){
    $return = '';
    $prefixe = _T('ciwidget:serie');
    
    $radius_series = ciwidget_graphique_tmp_radius_series($id_widget_tmp);

    $tableau_valeurs = array();
    $tableau_pourcentage = array(0, 25, 50, 75, 100, 125, 150, 175, 200, 225, 250, 300, 350, 400, 450, 500, 600, 700, 800);
    foreach ($tableau_pourcentage AS $pourcentage) {
        $tableau_valeurs[$pourcentage] = strval($pourcentage).'%';;
    }
    
    foreach ($radius_series AS $nom_element=>$valeur_element){
        $selected = '';
        
        $return .= '<div class="ci_wrapper_color">';
        $return .= '<label for="'.$nom_element.'">'.$prefixe.' '.str_replace('radius_serie','',$nom_element).'</label>';
        $return .= '<select name="'.$nom_element.'" id="'.$nom_element.'" onchange="ci_change_radius_serie('.str_replace('radius_serie','',$nom_element).',this.value);"  style="width:110px;margin:0px 10px;">'."\n";

        // Parcours du tableau
        foreach($tableau_valeurs as $valeur=>$libelle){
            if($valeur == $valeur_element){
                $selected = ' selected="selected"';
            } else {
                $selected = '';
            }

            // Affichage de la ligne
            $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'.$libelle.'</option>'."\n";
        }
        
        $return .= '</select>'."\n";
        $return .= '</div>';
    }
    
    return $return;
}

function ciwidget_graphique_tmp_lineborderwidth_series($id_widget_tmp,$callback=false){
    $prerenseigner = ciwidget_graphique_id_prerenseigner($id_widget_tmp);    
    
    if ($prerenseigner>0) {
        return ciwidget_graphique_lineborderwidth_series($prerenseigner,false,$callback);
    } else {
        return ciwidget_graphique_lineborderwidth_series($id_widget_tmp,true,$callback);
    }
}

function ciwidget_graphique_tmp_choix_lineborderwidth_series($id_widget_tmp,$prerenseigner=''){
    $return = '';
    $prefixe = _T('ciwidget:serie');
    
    $lineborderwidth_series = ciwidget_graphique_tmp_lineborderwidth_series($id_widget_tmp);

    $tableau_valeurs = array();
    $tableau_pourcentage = array(0, 25, 50, 75, 100, 125, 150, 175, 200, 225, 250, 300, 350, 400, 450, 500, 600, 700, 800);
    foreach ($tableau_pourcentage AS $pourcentage) {
        $tableau_valeurs[$pourcentage] = strval($pourcentage).'%';;
    }
    
    foreach ($lineborderwidth_series AS $nom_element=>$valeur_element){
        $selected = '';
        
        $return .= '<div class="ci_wrapper_color">';
        $return .= '<label for="'.$nom_element.'">'.$prefixe.' '.str_replace('lineborderwidth_serie','',$nom_element).'</label>';
        $return .= '<select name="'.$nom_element.'" id="'.$nom_element.'" onchange="ci_change_lineborderwidth_serie('.str_replace('lineborderwidth_serie','',$nom_element).',this.value);"  style="width:110px;margin:0px 10px;">'."\n";

        // Parcours du tableau
        foreach($tableau_valeurs as $valeur=>$libelle){
            if($valeur == $valeur_element){
                $selected = ' selected="selected"';
            } else {
                $selected = '';
            }

            // Affichage de la ligne
            $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'.$libelle.'</option>'."\n";
        }
        
        $return .= '</select>'."\n";
        $return .= '</div>';
    }
    
    return $return;
}

function ciwidget_graphique_tmp_lineborderdash_series($id_widget_tmp,$callback=false){
    $prerenseigner = ciwidget_graphique_id_prerenseigner($id_widget_tmp);    
    
    if ($prerenseigner>0) {
        return ciwidget_graphique_lineborderdash_series($prerenseigner);
    } else {
        return ciwidget_graphique_lineborderdash_series($id_widget_tmp,true,$callback);
    }
}

function ciwidget_graphique_tmp_choix_lineborderdash_series($id_widget_tmp,$prerenseigner=''){
    $return = '';
    $prefixe = _T('ciwidget:serie');
    
    $lineborderdash_series = ciwidget_graphique_tmp_lineborderdash_series($id_widget_tmp);

    $tableau_valeurs = array();
    for ($i = 0; $i < 11; $i++) {
        $tableau_valeurs[$i] = _T('ciwidget:largeur_pointille').' '.strval($i);
    }
    $tableau_valeurs[0] = _T('ciwidget:aucun_pointille');
    
    foreach ($lineborderdash_series AS $nom_element=>$valeur_element){
        $selected = '';
        
        $return .= '<div class="ci_wrapper_color">';
        $return .= '<label for="'.$nom_element.'">'.$prefixe.' '.str_replace('lineborderdash_serie','',$nom_element).'</label>';
        $return .= '<select name="'.$nom_element.'" id="'.$nom_element.'" onchange="ci_change_lineborderdash_serie('.str_replace('lineborderdash_serie','',$nom_element).',this.value);"  style="width:110px;margin:0px 10px;">'."\n";

        // Parcours du tableau
        foreach($tableau_valeurs as $valeur=>$libelle){
            if($valeur == $valeur_element){
                $selected = ' selected="selected"';
            } else {
                $selected = '';
            }

            // Affichage de la ligne
            $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'.$libelle.'</option>'."\n";
        }
        
        $return .= '</select>'."\n";
        $return .= '</div>';
    }
    
    return $return;
}

// Pour les options
// Eviter les simples quotes. Les echapper le cas echeant.
function ciwidget_graphique_tmp_config_json($id_widget_tmp){
    $prerenseigner = ciwidget_graphique_id_prerenseigner($id_widget_tmp);    
    
    if ($prerenseigner>0) {
        return ciwidget_graphique_config_json($prerenseigner);
    } else {
        return ciwidget_graphique_config_json($id_widget_tmp,true);
    }
}

function ciwidget_graphique_id_prerenseigner($id_widget_tmp){
    $prerenseigner = intval(_request('prerenseigner')); 
    $id_widget_tmp = intval($id_widget_tmp);
    $return = '';
    
    if ($prerenseigner>0 AND test_espace_prive() AND $id_widget_tmp>0) {
        $valeurs_actuelles = ciwidget_valeurs_tmp(0,$id_widget_tmp,'graphique');
        $type_actuel = ciwidget_graphique_type($valeurs_actuelles);
        
        $valeurs_prerenseigner = ciwidget_valeurs_lues_en_base($prerenseigner,'graphique');
        
        // anti hack
        if (ciwidget_graphique_type($valeurs_prerenseigner)==$type_actuel){
            $return = $prerenseigner;
        }
    }
    
    return $return;
}

function ciwidget_graphique_type($contenu=array()){
    $type = '';
    
    if ($contenu AND is_array($contenu)){
        
        if (isset($contenu['type'])){
            $type = $contenu['type'];
        }
        
        // stacked ?
        if (isset($contenu['type']) AND in_array($contenu['type'],array('bar','horizontalBar')) 
                AND isset($contenu['yAxes_stacked']) AND $contenu['yAxes_stacked']=='true'){
            $type .= '_stacked';
        }

        // moyenne ?
        if (isset($contenu['type']) AND in_array($contenu['type'],array('bar','bar_stacked')) 
                AND isset($contenu['moyenne_active']) AND $contenu['moyenne_active']=='oui'){
            $type .= '_moyenne';
        }
    }
    
    return $type;
}

function ciwidget_graphique_tableau_json_optimise($id_widget=0,$mettre_en_colonne=true,$tmp=false,$optimise=true){
    $return = '';
    $donnees_vide = false;
    
    $id_widget = intval($id_widget);
    if ($id_widget>0){
        $data = '';
        $serie_colonne = true;

        if ($tmp){
            $valeurs = ciwidget_valeurs_tmp(0,$id_widget,'graphique');
        } else {
            $valeurs = ciwidget_valeurs_lues_en_base($id_widget,'graphique');
        }

        if (isset($valeurs['donnees']) AND $valeurs['donnees']){
            $data = $valeurs['donnees'];
        } else {
            if ($tmp AND _request('donnees')){
                $data = ciwidget_graphique_extraire_data(_request('donnees'));
            } else {
                $donnees_vide = true;
            }
        }

        if (!$donnees_vide){
            if (isset($valeurs['serie_colonne']) AND $valeurs['serie_colonne']!='oui'){
                $serie_colonne = false;
            }
        
        
            if ($mettre_en_colonne AND !$serie_colonne){
                // mettre les series en colonne
                $data = json_encode(ciwidget_transpose_tableau(json_decode($data, true)),JSON_UNESCAPED_UNICODE);
            }

            if ($optimise){
                // enlever les colonnes vides
                $data_extrait = '';
                $pos = strpos($data,'],[');
                $extrait = substr($data,0,$pos);
                $nombre_total_de_colonnes = substr_count($extrait,',')+1;
                $extrait = str_replace(',""','',$extrait);
                $nombre_colonnes = substr_count($extrait,',')+1;
                $nombre_colonnes_vides = $nombre_total_de_colonnes - $nombre_colonnes;
                $cherche = ',""]';
                for ($i = 2; $i <= $nombre_colonnes_vides; $i++) {
                    $cherche = ',""'.$cherche;
                }
                
                if ($nombre_colonnes_vides>=1){
                    $data_extrait = str_replace($cherche,']',$data);
                } else {
                    $data_extrait = $data;
                }
                
                // enlever les lignes vides
                $cherche = ',[""';
                for ($i = 2; $i <= $nombre_colonnes; $i++) {
                    $cherche .= ',""';
                }
                $cherche .= ']';
                $return = str_replace($cherche,'',$data_extrait);
            } else {
                $return = $data;
            }    
        } else {
            $return = "[]";
        }
    }
    
    return $return;
}

// tableau html identique a celui genere par SPIP
function ciwidget_graphique_tableau_html($id_widget=0,$titre=''){
    $tableau_json = ciwidget_graphique_tableau_json_optimise($id_widget);

    return ciwidget_graphique_traiter_tableau($id_widget,$tableau_json,$titre);    
}

function ciwidget_transpose_tableau($tableau){
  $return = array();

    foreach ($tableau as $row => $columns) {
      foreach ($columns as $row2 => $column2) {
          $return[$row2][$row] = $column2;
      }
    }
  return $return;
}

function ciwidget_graphique_traiter_tableau($id_widget,$tableau_json,$titre='',$descriptif='') {
    
        $id_widget = intval($id_widget);
        $entete_colonne = 'non';
        $entete_ligne = 'non';

        if ($id_widget>0){
            $valeurs = ciwidget_valeurs_lues_en_base($id_widget,'graphique');
            if (isset($valeurs['entete_colonne']) AND $valeurs['entete_colonne']=='oui'){    
                $entete_colonne = 'oui';
            }
            if (isset($valeurs['entete_ligne']) AND $valeurs['entete_ligne']=='oui'){    
                $entete_ligne = 'oui';
            }
        }
    
	// id "unique" pour les id du tableau
        $tabid = substr(md5($id_widget."widget"), 0, 4);
        
        $tableau_php = json_decode($tableau_json, true);
        
	$lignes = array();
	$debut_table = $summary = '';
	$l = 0;
	$numeric = true;
	$hc = $hl = array();

        $premiere_ligne = array();
        if ($entete_colonne=='oui'){
            $premiere_ligne = array_shift($tableau_php);
//            $nombre_colonnes = count($premiere_ligne);
        }
        
        // <caption> et summary
        $debut_table .= "<caption>" . $titre . "</caption>\n";
        // summary est deprecated en HTML5
//        $summary = ' summary="' . entites_html(trim($descriptif)) . '"';

        // <thead>
        $thead = '';
        if ($entete_colonne=='oui'){
            for ($c = count($premiere_ligne) - 1; $c >= 0; $c--) {
                    $attr = "";
                    $thead = "<th id='id{$tabid}_c$c'$attr>$premiere_ligne[$c]</th>$thead";
                    $hc[$c] = "id{$tabid}_c$c"; // pour mettre dans les headers des td
            }

            $debut_table .= "<thead class='ciwidget_graphique_thead'><tr class='row_first'>" .
                    $thead . "</tr></thead>\n";
        }
        
	// maintenant qu'on a toutes les cellules
	// on prepare une liste de rowspan par defaut, a partir
	// du nombre de colonnes dans la premiere ligne.
	// Reperer egalement les colonnes numeriques pour les cadrer a droite
        $lignes = $tableau_php;
	$numeric = array();
	$n = count($lignes[0]);
	$k = count($lignes);
	// distinguer les colonnes numeriques a point ou a virgule,
	// pour les alignements eventuels sur "," ou "."
	$numeric_class = array(
		'.' => 'point',
		',' => 'virgule',
		true => ''
	);
	for ($i = 0; $i < $n; $i++) {
		$align = true;
		for ($j = 0; $j < $k; $j++) {
			if ($align and preg_match('/^[{+-]*(?:\s|\d)*([.,]?)\d*[}]*$/', trim($lignes[$j][$i]), $r)) {
				if ($r[1]) {
					$align = $r[1];
				}
			} else {
				$align = '';
			}
		}
		$numeric[$i] = $align ? (" class='numeric " . $numeric_class[$align] . "'") : '';
	}
        if ($entete_ligne=='oui'){
            for ($j = 0; $j < $k; $j++) {
                    $hl[$j] = "id{$tabid}_l$j"; // pour mettre dans les headers des td
            }
        } else {
		$hl = array();
	} // toute la colonne ou rien

	// et on parcourt le tableau a l'envers
	$html = '';

	for ($l = count($lignes) - 1; $l >= 0; $l--) {
		$cols = $lignes[$l];
		$colspan = 1;
		$ligne = '';

		for ($c = count($cols) - 1; $c >= 0; $c--) {
			$attr = $numeric[$c];
			$cell = trim($cols[$c]);
        		$b = ($c == 0 and isset($hl[$l])) ? 'th' : 'td';
                        $h = (isset($hc[$c]) ? $hc[$c] : '') . ' ' . (($b == 'td' and isset($hl[$l])) ? $hl[$l] : '');
                        if ($h = trim($h)) {
                                $attr .= " headers='$h'";
                        }
                        if ($b == 'th') {
                                $attr .= " id='" . $hl[$l] . "'";
                        }
                        
                        if ($c>0 AND $numeric[$c]){
                            $ligne = "\n<$b" . $attr . '>' . ciwidget_millier($cols[$c]) . "</$b>" . $ligne;
                        } else {
                            $ligne = "\n<$b" . $attr . '>' . $cols[$c] . "</$b>" . $ligne;
                        }
		}

		// ligne complete
		$class = alterner($l + 1, 'odd', 'even');
		$html = "<tr class='row_$class $class'>$ligne</tr>\n$html";
	}

	return "\n\n<table " . str_replace('spip','spip ciwidget_graphique_table',$GLOBALS['class_spip_plus']) . $summary . ">\n"
	. $debut_table
	. "<tbody class='ciwidget_graphique_tbody'>\n"
	. $html
	. "</tbody>\n"
	. "</table>\n\n";
}

function ciwidget_millier($valeur) {
    if (is_null($valeur)){
        return '';
    }
    $valeur = strval($valeur);
    if (strpos($valeur,".")===false){
        $texte_int = $valeur;
        $texte_float = '';
    } else {
        list($texte_int, $texte_float) = explode(".", $valeur);
    }
    if ($texte_float){
        $texte_float = '.'.$texte_float;
    } else {
        $texte_float = '';
    }
    $texte_int_millier = strval(number_format(intval($texte_int), 0, '.', ' '));
    return  $texte_int_millier.$texte_float;
}
        
function ciwidget_enregistrer_csv($id_widget=0){
    $id_document_csv = 0;
    $id_document_xls = 0;
    $id_document_csv_actuel = 0;
    $id_document_xls_actuel = 0;
    $id_widget = intval($id_widget);
    $objet = '';
    $id_objet = 0;
    $mode = 'document';
    $contenu = array();
    
    if ($id_widget>0){
        $tableau_json = ciwidget_graphique_tableau_json_optimise($id_widget);

        if($tableau_json){
            $json_decode = json_decode($tableau_json, true);
            $tableau_php = array_map('ciwidget_remplacer_point_par_virgule', $json_decode);
            $nomdufichier = "graphique_".$id_widget;
    
            include_spip('inc/ciwidget_exporter_csv');
            $delim_csv = ','; // format CSV
            $delim_xls = 'TAB'; // format XLS
            if (spip_version()>=4){
                $options_csv = array(
                    'delim' => $delim_csv,
                    'entetes' => null,
                    'envoyer' => false,
                    'charset' => null,
                    'callback' => null,
                );
                $options_xls = array(
                    'delim' => $delim_xls,
                    'entetes' => null,
                    'envoyer' => false,
                    'charset' => null,
                    'callback' => null,
                );
                $fichier_tmp_csv = inc_exporter_csv_dist($nomdufichier, $tableau_php, $options_csv);
                $fichier_tmp_xls = inc_exporter_csv_dist($nomdufichier, $tableau_php, $options_xls);
            } else {
                $fichier_tmp_csv = inc_exporter_csv_dist($nomdufichier, $tableau_php, $delim_csv, null, false);
                $fichier_tmp_xls = inc_exporter_csv_dist($nomdufichier, $tableau_php, $delim_xls, null, false);
            }
            $csv = $nomdufichier.".csv";
            $xls = $nomdufichier.".xls";
            
            // Est-ce que le document existe ?
            $result = sql_select("*", "spip_ciwidget", "id_widget=".$id_widget);
            while ($row = sql_fetch($result)) { 
                $objet = $row['objet'];
                $id_objet = $row['id_objet'];
                
                if (isset($row['contenu'])){
                    $contenu = unserialize($row['contenu']);
                    if (isset($contenu['id_document_csv']) AND $contenu['id_document_csv']){
                        $id_document_csv = $contenu['id_document_csv'];
                        $id_document_csv_actuel = $contenu['id_document_csv'];
                    }
                    if (isset($contenu['id_document_xls']) AND $contenu['id_document_xls']){
                        $id_document_xls = $contenu['id_document_xls'];
                        $id_document_xls_actuel = $contenu['id_document_xls'];
                    }
                }
            }

            $count_csv = sql_countsel("spip_documents", "id_document=".$id_document_csv);
            if (!$count_csv){
                $id_document_csv = 0;
                $id_document_csv_actuel = 0;
            }
            $count_xls = sql_countsel("spip_documents", "id_document=".$id_document_xls);
            if (!$count_xls){
                $id_document_xls = 0;
                $id_document_xls_actuel = 0;
            }
            
            $ajouter_documents = charger_fonction('ajouter_documents', 'action');
            
            $file_csv = array('tmp_name' => $fichier_tmp_csv, 'name' => $csv);
            $nouveaux_csv = $ajouter_documents($id_document_csv, array($file_csv), $objet, $id_objet, $mode);
            foreach ($nouveaux_csv as $doc) {
                if (is_numeric($doc)) {
                    $id_document = $doc;
                    $contenu['id_document_csv'] = $id_document;
                    if (!$id_document_csv_actuel){
                        sql_updateq("spip_ciwidget", array('contenu'=>serialize($contenu)), "id_widget=$id_widget");
                    }
                    
                    // IMPORTANT : ne pas lier le document à l'objet
                    sql_delete("spip_documents_liens", "id_document=".$id_document." AND objet='".$objet."' AND id_objet=".$id_objet);
                    
                    // lier le document au widget
                    if (!$id_document_csv_actuel OR !sql_countsel('spip_documents_liens', "id_document=".$id_document." AND objet='ciwidget' AND id_objet=".$id_widget)){
                        sql_insertq('spip_documents_liens', array('id_document'=>$id_document,'objet'=>'ciwidget','id_objet'=>$id_widget,'vu'=>'oui'));
                    }    
                }
            }        
            unlink($fichier_tmp_csv);

            $file_xls = array('tmp_name' => $fichier_tmp_xls, 'name' => $xls);
            $nouveaux_xls = $ajouter_documents($id_document_xls, array($file_xls), $objet, $id_objet, $mode);
            foreach ($nouveaux_xls as $doc) {
                if (is_numeric($doc)) {
                    $id_document = $doc;
                    $contenu['id_document_xls'] = $id_document;
                    if (!$id_document_xls_actuel){
                        sql_updateq("spip_ciwidget", array('contenu'=>serialize($contenu)), "id_widget=$id_widget");
                    }
                    
                    // IMPORTANT : ne pas lier le document à l'objet
                    sql_delete("spip_documents_liens", "id_document=".$id_document." AND objet='".$objet."' AND id_objet=".$id_objet);
                    
                    // lier le document au widget
                    if (!$id_document_xls_actuel OR !sql_countsel('spip_documents_liens', "id_document=".$id_document." AND objet='ciwidget' AND id_objet=".$id_widget)){
                        sql_insertq('spip_documents_liens', array('id_document'=>$id_document,'objet'=>'ciwidget','id_objet'=>$id_widget,'vu'=>'oui'));
                    }    
                }
            }        
            unlink($fichier_tmp_xls);
        }
    }
}

function ciwidget_remplacer_point_par_virgule($texte){
    if ($texte){
        $texte = str_replace('.',',',$texte);
    }
    return $texte;        
}

function ciwidget_graphique_choix($nom_element='',$valeur_element='',$tableau_valeurs=array(),$onchange=true,$options='',$disabled=false){
    include_spip('inc/ciwidget_inc_meta');

    $return = '';
    $selected = '';
    $html_disabled = '';
    if ($disabled){
        $html_disabled = 'disabled="disabled"';
    }
    
    if ($onchange){
        $return .= '<select name="'.$nom_element.'" id="'.$nom_element.'" onchange="ci_change_'.$nom_element.'(this.value);" '.$options.' '.$html_disabled.'>'."\n";
    } else {
        $return .= '<select name="'.$nom_element.'" id="'.$nom_element.'" '.$options.' '.$html_disabled.'>'."\n";
    }
    
    // Parcours du tableau
    foreach($tableau_valeurs as $valeur=>$libelle){
        if($valeur == $valeur_element){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $libelle .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function ciwidget_graphique_choix_type($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    foreach (array('bar','bar_moyenne','bar_stacked','bar_stacked_moyenne','horizontalBar','horizontalBar_stacked','pie','doughnut','line','radar') AS $valeur){
        $tableau_valeurs[$valeur] = _T('ciwidget:widget_graphique_'.$valeur);
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}

function ciwidget_graphique_choix_arrondi($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    foreach (array('1','10','100','1000','10000') AS $valeur){
        $tableau_valeurs[$valeur] = strval(strlen($valeur)-1);
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}

function ciwidget_graphique_choix_moyenne_ordre($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    for ($i = 1; $i < 11; $i++) {
        $valeur = ($i * 2) + 1;
        $tableau_valeurs[$valeur] = $valeur;
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}

function ciwidget_graphique_choix_largeur($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    $disabled = false;
    $ci_non_modifiable = ciwidget_lire_meta_cle('graphique','largeur_non_modifiable');
    if ($ci_non_modifiable == 'oui'){
        $disabled = true;
    }
    
    // compatibilite ascendante
    if ($valeur_element > 100){
        $valeur_element = 100;
    }
    
    $tableau_pourcentage = array(100,95,90,85,80,75,70,65,60,55,50);
    foreach ($tableau_pourcentage AS $pourcentage) {
        $tableau_valeurs[$pourcentage] = strval($pourcentage).'%';;
    }
   
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange,'',$disabled);
}

function ciwidget_graphique_choix_ratio($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    $fin = 21;
    
    $ci_imposer_ratio_comme_maximum = ciwidget_lire_meta_cle('graphique','imposer_ratio_comme_maximum');
    $ci_defaut = floatval(ciwidget_lire_meta_cle('graphique','aspect_ratio'));

    if ($ci_imposer_ratio_comme_maximum=='oui' AND $ci_defaut){
        $fin = ($ci_defaut*10) + 1;
    }
    
    for ($i = 3; $i < $fin; $i++) {
        $valeur = number_format($i/10,1);
        $tableau_valeurs[$valeur] = $valeur;
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}

function ciwidget_graphique_choix_ratio_maximum($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    for ($i = 3; $i < 21; $i++) {
        $valeur = number_format($i/10,1);
        $tableau_valeurs[$valeur] = $valeur;
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}

function ciwidget_graphique_choix_position($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    foreach (array('top','bottom','left','right') AS $valeur){
        $tableau_valeurs[$valeur] = _T('ciwidget:'.$valeur);
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}

function ciwidget_graphique_choix_align($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    foreach (array('start','center','end') AS $valeur){
        $tableau_valeurs[$valeur] = _T('ciwidget:'.$valeur);
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}

function ciwidget_graphique_choix_point_style($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    foreach (array('aucun_point','circle','triangle','rect','rectRounded','rectRot','cross','crossRot','star','line','dash') AS $valeur){
        $tableau_valeurs[$valeur] = _T('ciwidget:'.$valeur);
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}

function ciwidget_graphique_choix_point_radius($nom_element='',$valeur_element='',$onchange=true){
    $tableau_valeurs = array();
    for ($i = 0; $i < 11; $i++) {
        $tableau_valeurs[$i] = $i;
    }
    return ciwidget_graphique_choix($nom_element,$valeur_element,$tableau_valeurs,$onchange);
}


function ciwidget_verifier_type($texte=''){
    $return = false;
    if (in_array($texte,array('bar','bar_moyenne','bar_stacked','bar_stacked_moyenne','horizontalBar','horizontalBar_stacked','pie','doughnut','line','radar'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_largeur($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_aspect_ratio($texte=''){
    $return = false;
    $resultat = 10 * floatval($texte);
    if ($resultat>=3 AND $resultat<=20){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_legend_display($texte=''){
    return ciwidget_verifier_true_false($texte);
}

function ciwidget_verifier_legend_position($texte=''){
    $return = false;
    if (in_array($texte,array('top','bottom','left','right'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_legend_align($texte=''){
    $return = false;
    if (in_array($texte,array('start','center','end'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_legend_reverse($texte=''){
    return ciwidget_verifier_true_false($texte);
}

function ciwidget_verifier_xAxes_rotation($texte=''){
    return ciwidget_verifier_true_false($texte);
}

function ciwidget_verifier_xAxes_gridLines_display($texte=''){
    return ciwidget_verifier_true_false($texte);
}

function ciwidget_verifier_xAxes_labelString($texte=''){
    return ciwidget_verifier_caracteres_speciaux_texte($texte);
}

function ciwidget_verifier_xAxes_maxTicksLimit($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_xAxes_suggestedMin($texte=''){
    return ciwidget_verifier_float($texte);
}

function ciwidget_verifier_xAxes_suggestedMax($texte=''){
    return ciwidget_verifier_float($texte);
}

function ciwidget_verifier_yAxes_gridLines_display($texte=''){
    return ciwidget_verifier_true_false($texte);
}

function ciwidget_verifier_yAxes_labelString($texte=''){
    return ciwidget_verifier_caracteres_speciaux_texte($texte);
}

function ciwidget_verifier_yAxes_maxTicksLimit($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_yAxes_suggestedMin($texte=''){
    return ciwidget_verifier_float($texte);
}

function ciwidget_verifier_yAxes_suggestedMax($texte=''){
    return ciwidget_verifier_float($texte);
}

function ciwidget_verifier_yAxes_unite($texte=''){
    return ciwidget_verifier_caracteres_speciaux_texte($texte);
}

function ciwidget_verifier_arrondi($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_moyenne_ordre($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_yAxes_stacked($texte=''){
    return ciwidget_verifier_true_false($texte);
}

function ciwidget_verifier_axe_suggestedMin($texte=''){
    return ciwidget_verifier_float($texte);
}

function ciwidget_verifier_axe_suggestedMax($texte=''){
    return ciwidget_verifier_float($texte);
}

function ciwidget_verifier_axe_maxTicksLimit($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_axe_ticks_display($texte=''){
    return ciwidget_verifier_true_false($texte);
}

function ciwidget_verifier_opacite($texte=''){
    return ciwidget_verifier_pourcentage($texte);
}

function ciwidget_verifier_point_style($texte=''){
    $return = false;
    if (in_array($texte,array('aucun_point','circle','triangle','rect','rectRounded','rectRot','cross','crossRot','star','line','dash'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_showline_style($texte=''){
    $return = false;
    if (in_array($texte,array('oui','non'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_radius_style($texte=''){
    $return = false;
    $resultat = intval($texte);
    if ($resultat>=1 AND $resultat<=10){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_point_radius($texte=''){
    $return = false;
    $resultat = intval($texte);
    if ($resultat>=1 AND $resultat<=9){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_lineborderwidth_defaut($texte=''){
    $return = false;
    $resultat = intval($texte);
    if ($resultat>=1 AND $resultat<=9){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_lineborderwidth($texte=''){
    return ciwidget_verifier_lineborderwidth_defaut($texte);
}

function ciwidget_verifier_couleur_serie($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}


function ciwidget_verifier_couleur_serie1($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie2($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie3($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie4($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie5($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie6($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie7($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie8($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie9($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie10($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie11($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}
function ciwidget_verifier_couleur_serie12($texte=''){
    return ciwidget_verifier_couleur_hexa($texte);
}

function ciwidget_verifier_download_csv($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_serie_colonne($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_categoryPercentage($texte=''){
    return ciwidget_verifier_pourcentage($texte);
}

function ciwidget_verifier_barPercentage($texte=''){
    return ciwidget_verifier_pourcentage($texte);
}

function ciwidget_verifier_rotation($texte=''){
    $return = false;
    $resultat = intval($texte);
    if ($resultat>=0 AND $resultat<=360){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_circumference($texte=''){
    $return = false;
    $resultat = intval($texte);
    if ($resultat==1 OR $resultat==2){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_defaultfontfamily($texte=''){
    return ciwidget_verifier_fontfamily($texte);
}
function ciwidget_verifier_title_fontfamily($texte=''){
    return ciwidget_verifier_fontfamily($texte);
}
function ciwidget_verifier_legend_fontfamily($texte=''){
    return ciwidget_verifier_fontfamily($texte);
}

function ciwidget_verifier_fontfamily($texte=''){
    $return = false;
    if (ctype_alnum(str_replace(array(',','-',' ','"',"'"),'',$texte))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_defautfontweight($texte=''){
    return ciwidget_verifier_fontweight($texte);
}
function ciwidget_verifier_title_fontweight($texte=''){
    return ciwidget_verifier_fontweight($texte);
}
function ciwidget_verifier_legend_fontweight($texte=''){
    return ciwidget_verifier_fontweight($texte);
}

function ciwidget_verifier_fontweight($texte=''){
    $return = false;
    if (in_array($texte,array('normal','bold','bolder','lighter','100','200','300','400','500','600','700','800','900','inherit','initial','unset'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_defaultfontcolor($texte=''){
    $return = false;
    if (preg_match(',^#[a-f0-9]{6}$,i', $texte)){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_xAxes_gridLines_color($texte=''){
    $return = false;
    if (preg_match(',^#[a-f0-9]{6}$,i', $texte)){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_yAxes_gridLines_color($texte=''){
    $return = false;
    if (preg_match(',^#[a-f0-9]{6}$,i', $texte)){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_title_fontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}
function ciwidget_verifier_legend_fontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}
function ciwidget_verifier_xaxeslabel_fontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}
function ciwidget_verifier_xaxesticks_fontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}
function ciwidget_verifier_yaxeslabel_fontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}
function ciwidget_verifier_yaxesticks_fontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}
function ciwidget_verifier_tooltips_titlefontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}
function ciwidget_verifier_tooltips_bodyfontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}
function ciwidget_verifier_ci_xaxes_lastlabelfontsize($texte=''){
    return ciwidget_verifier_font_size_px_sans_unite($texte);
}

function ciwidget_verifier_font_size_px_sans_unite($texte=''){
    $return = false;
    $resultat = intval($texte);
    if ($resultat>=8 AND $resultat<=30){
        $return = true;
    }    
    return $return;
}

function ciwidget_verifier_ci_xaxes_showlastlabel($texte=''){
    return ciwidget_verifier_true_false($texte);
}

function ciwidget_verifier_caracteres_speciaux_texte($t) {
    // limiter aux a-zA-Z0-9, aux (, ), espaces, virgule, underscores, quote, double quote, tirets, points, deux points, slash, arobase
    $caracteres_autorises = array("(",")"," ",",","_","'",'"','-','.',':','/','@','$','%');
    return ciwidget_verifier_caracteres_speciaux($t,$caracteres_autorises);
}

function ciwidget_verifier_caracteres_speciaux_data($t) {
    // limiter aux a-zA-Z0-9, aux [, ], espaces, virgule, underscores, quote, double quote, tirets, points, deux points, slash, arobase
    $caracteres_autorises = array("[","]"," ",",","_","'",'"','-','.',':','/','@',"(",")");
    return ciwidget_verifier_caracteres_speciaux($t,$caracteres_autorises);
}

function ciwidget_verifier_caracteres_speciaux($t,$caracteres_autorises=array()) {
    $verif = true;

    if ($t) {
            // supprimer les accents
            include_spip('inc/charsets');
            $tsa = translitteration($t);
            
            $tscs = str_replace($caracteres_autorises,'',$tsa);		
            if ($tscs AND !ctype_alnum($tscs)) {
                    $verif = false;
            }
    }

    return $verif;
}

// inspiré d'une fonction de SPIP
function ciwidget_graphique_importer_asynchrone($id_widget='') {
	$texte = "";

	if (!intval($id_widget)) {
		return $texte;
	}
        
	// si c'est un bot, inutile de faire un appel
	if ((defined('_IS_BOT') and _IS_BOT)) {
		return $texte;
	}
        
	// ne pas relancer si on vient de lancer dans la meme seconde par un hit concurent
	if (file_exists($lock = _DIR_TMP . "ciwidget_graphique.lock") and !(@filemtime($lock) < $_SERVER['REQUEST_TIME'])) {
		return $texte;
	}

	@touch($lock);

	$urgent = false;

	$url_cron = generer_url_action('ciwidget_importer', 'type_widget=graphique&id_widget='.intval($id_widget), false, true);

	if (true) {

		// methode la plus rapide :
		// Si fsockopen est possible, on lance le cron via un socket en asynchrone
		// si fsockopen echoue (disponibilite serveur, firewall) on essaye pas cURL
		// car on a toutes les chances d'echouer pareil mais sans moyen de le savoir
		if (function_exists('fsockopen')) {
			$parts = parse_url($url_cron);

			switch ($parts['scheme']) {
				case 'https':
					$scheme = 'ssl://';
					$port = 443;
					break;
				case 'http':
				default:
					$scheme = '';
					$port = 80;
			}
			$fp = @fsockopen($scheme . $parts['host'],
				isset($parts['port']) ? $parts['port'] : $port,
				$errno, $errstr, 1);

			if ($fp) {
				$host_sent = $parts['host'];
				if (isset($parts['port']) and $parts['port'] !== $port) {
					$host_sent .= ':' . $parts['port'];
				}
				$timeout = 200; // ms
				stream_set_timeout($fp, 0, $timeout * 1000);
				$query = $parts['path'] . ($parts['query'] ? "?" . $parts['query'] : "");
				$out = "GET " . $query . " HTTP/1.1\r\n";
				$out .= "Host: " . $host_sent . "\r\n";
				$out .= "Connection: Close\r\n\r\n";
				fwrite($fp, $out);
				spip_timer('read');
				$t = 0;
				// on lit la reponse si possible pour fermer proprement la connexion
				// avec un timeout total de 200ms pour ne pas se bloquer
				while (!feof($fp) and $t < $timeout) {
					@fgets($fp, 1024);
					$t += spip_timer('read', true);
					spip_timer('read');
				}
				fclose($fp);
				if (!$urgent) {
					return $texte;
				}
			}
		}
		// si fsockopen n'est pas dispo on essaye cURL :
		// lancer le cron par un cURL asynchrone si cURL est present
		elseif (function_exists("curl_init")) {
			//setting the curl parameters.
			$ch = curl_init($url_cron);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			// cf bug : http://www.php.net/manual/en/function.curl-setopt.php#104597
			curl_setopt($ch, CURLOPT_NOSIGNAL, 1);
			// valeur mini pour que la requete soit lancee
			curl_setopt($ch, CURLOPT_TIMEOUT_MS, 200);
			// lancer
			curl_exec($ch);
			// fermer
			curl_close($ch);
			if (!$urgent) {
				return $texte;
			}
		}
	}

	return $texte;
}

function ciwidget_fontfamily_to_js($texte=''){
    $texte = str_replace('"','',$texte);
    $texte = str_replace("'",'',$texte);
    $tableau = explode(',',$texte);
    $tableau = array_map('trim', $tableau);
    $texte = implode("', '",$tableau);
    return "'".$texte."'";
}

function ciwidget_style_titre_du_graphique($type_graphique='',$align='center'){
    $return = '';
    
    $title_fontfamily = ciwidget_lire_meta_cle('graphique','title_fontfamily');
    $title_fontweight = ciwidget_lire_meta_cle('graphique','title_fontweight');
    $title_fontsize = ciwidget_lire_meta_cle('graphique','title_fontsize');
    $title_color = ciwidget_lire_meta_cle('graphique','defaultfontcolor');
    
    $decalage_gauche = '3.5rem';
    if (in_array($type_graphique,array('pie','doughnut','radar'))){
        $decalage_gauche = '0';
    }
    
    $return = 'style="margin: 1rem 0 0 '.$decalage_gauche.';padding:0;text-align:center;font-family:'.$title_fontfamily.';color:'.$title_color.';font-weight:'.$title_fontweight.';font-size:'.$title_fontsize.'px;line-height:'.$title_fontsize.'px;"';
    
    return $return;
}

?>