<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_commun');
include_spip('inc/ciwidget_inc_meta');

function ciwidget_affiche_types_widget($objet='',$id_objet=0){
    $return = '';
    $nb_type_widget = 0;
    $compteur = 0;
    
    $types_widget_objet = ciwidget_types_widget_objet($objet);

    foreach ($types_widget_objet AS $type_widget_tableau) {
        if (ciwidget_lire_meta_cle($type_widget_tableau['id'],'statut')=='active'
                OR !ciwidget_lire_meta_cle($type_widget_tableau['id'],'statut')){
            if (!isset($type_widget_tableau['autorise']) OR ciwidget_verifier_autorise($type_widget_tableau['autorise'])){
                  $nb_type_widget++;
            }
        }
    }

    $seuil = round($nb_type_widget/3, 0, PHP_ROUND_HALF_DOWN);
    $seuils = array($seuil,2*$seuil);
    
    reset($types_widget_objet);
    foreach ($types_widget_objet AS $type_widget_tableau) {
        if ($compteur==0){
            $return .= '<ul>';
        }
        
        if (ciwidget_lire_meta_cle($type_widget_tableau['id'],'statut')=='active'
                OR !ciwidget_lire_meta_cle($type_widget_tableau['id'],'statut')){
            if (!isset($type_widget_tableau['autorise']) OR ciwidget_verifier_autorise($type_widget_tableau['autorise'])){
                $img = '';
                if (isset($type_widget_tableau['vignette']) AND $type_widget_tableau['vignette']){
                    $img = '<img src="'.find_in_path('_vignettes/'.$type_widget_tableau['vignette']).'" alt="" class="ciwidget_type_widget_vignette">';

                }
                if (isset($type_widget_tableau['popin']) AND $type_widget_tableau['popin']=='oui'){
                    $params = "'".$type_widget_tableau['id']."','".$objet."',".$id_objet;
                    $return .= '<li><a href="#" onclick="ciwidget_callback_type_widget('.$params.');" class="ciwidget_type_widget_lien">'.$img.'<div class="ciwidget_type_widget_titre">'. $type_widget_tableau['titre'] .'</div><div class="ciwidget_type_widget_descriptif">'. $type_widget_tableau['descriptif'] .'</div></a></li>';
                } else {
                    $href = ciwidget_url_widget_edit($objet,$id_objet,$type_widget_tableau['id']);
                    $return .= '<li><a href="'.$href.'" class="ciwidget_type_widget_lien">'.$img.'<div class="ciwidget_type_widget_titre">'. $type_widget_tableau['titre'] .'</div><div class="ciwidget_type_widget_descriptif">'. $type_widget_tableau['descriptif'] .'</div></a></li>';
                }
                
                $compteur++;
                
                if (in_array($compteur,$seuils)){
                    $return .= '</ul>';
                    $return .= '<ul>';
                }
                
                if ($compteur==$nb_type_widget){
                    $return .= '</ul>';
                }
            }
        }
    }

    return $return;
}


function ciwidget_affiche_types_widget_pour_cisf($objet='',$id_objet=0,$id_rubrique=0){
    $return = '';
    $nb_type_widget = 0;
    $compteur = 0;
    
    $types_widget_objet = ciwidget_types_widget_objet($objet);

    foreach ($types_widget_objet AS $type_widget_tableau) {
        if (ciwidget_lire_meta_cle($type_widget_tableau['id'],'statut')=='active'
                OR !ciwidget_lire_meta_cle($type_widget_tableau['id'],'statut')){
            if (!isset($type_widget_tableau['autorise']) OR ciwidget_verifier_autorise($type_widget_tableau['autorise'])){
                  $nb_type_widget++;
            }
        }
    }

    $seuil = round($nb_type_widget/3, 0, PHP_ROUND_HALF_DOWN);
    $seuils = array($seuil,2*$seuil);
    
    reset($types_widget_objet);
    foreach ($types_widget_objet AS $type_widget_tableau) {
        if ($compteur==0){
            $return .= '<ul>';
        }
        
        if (ciwidget_lire_meta_cle($type_widget_tableau['id'],'statut')=='active'
                OR !ciwidget_lire_meta_cle($type_widget_tableau['id'],'statut')){
            if (!isset($type_widget_tableau['autorise']) OR ciwidget_verifier_autorise($type_widget_tableau['autorise'])){
                $img = '';
                if (isset($type_widget_tableau['vignette']) AND $type_widget_tableau['vignette']){
                    $img = '<img src="'.find_in_path('_vignettes/'.$type_widget_tableau['vignette']).'" alt="" class="ciwidget_type_widget_vignette">';

                }
                $params = 'type_widget='.$type_widget_tableau['id'].'&id_article='.$id_objet.'&id_rubrique='.$id_rubrique;
                $return .= '<li><a href="'.generer_url_public("cisf_widget",$params).'" class="ciwidget_type_widget_lien">'.$img.'<div class="ciwidget_type_widget_titre">'. $type_widget_tableau['titre'] .'</div><div class="ciwidget_type_widget_descriptif">'. $type_widget_tableau['descriptif'] .'</div></a></li>';
                
                $compteur++;
                
                if (in_array($compteur,$seuils)){
                    $return .= '</ul>';
                    $return .= '<ul>';
                }
                
                if ($compteur==$nb_type_widget){
                    $return .= '</ul>';
                }
            }
        }
    }

    return $return;
}

function ciwidget_widget_sans_alignement($mon_type_widget){
    $return = false;
    $types_widget = ciwidget_types_widget();

    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['id']) AND $type_widget['id']==$mon_type_widget){
            if (isset($type_widget['sans_alignement']) AND $type_widget['sans_alignement']=='oui'){
                $return = true;
                break;
            }
        }
    };
    
    return $return;
}


function ciwidget_raccourcis_widget($id_widget, $type_widget) {
	$return = '';
        $raccourci = '';
        // Ajout d'un prefixe
        // pour eviter les confusions lorsqu'un widget est lié à un document
	$doc = 'widget_'.$type_widget;

        $sans_alignement = ciwidget_widget_sans_alignement($type_widget);        
        $config_align = ciwidget_lire_meta_cle($type_widget,'imposer_alignement_widget');        
        
        if ($sans_alignement){
            // sans alignement => ne pas proposer left/center/right
            $raccourci = ciwidget_affiche_raccourci_doc($doc, $id_widget, '');
        } elseif ($config_align AND in_array($config_align,array('left','center','right'))){
            // alignement imposé du widget => ne pas proposer left/center/right
            $raccourci = ciwidget_affiche_raccourci_doc($doc, $id_widget, '');
        } else {
            // Affichage du raccourci <type_widget...> correspondant
            $raccourci =
                    ciwidget_affiche_raccourci_doc($doc, $id_widget, 'left', true)
                    . ciwidget_affiche_raccourci_doc($doc, $id_widget, 'center', true)
                    . ciwidget_affiche_raccourci_doc($doc, $id_widget, 'right', true);

/*
// mis en commentaire car probleme d'accessibilite sous SPIP 4            
            if ($GLOBALS['spip_version_branche']>=4) {
                $raccourci = ciwidget_affiche_raccourci_doc($doc, $id_widget, '') . $raccourci;
            }
*/            
        }


/*
// mis en commentaire car probleme d'accessibilite sous SPIP 4            
        if ($GLOBALS['spip_version_branche']>=4) {
            $return = "<div class='groupe-btns'>$raccourci</div>";
        } else {
*/        

            $return = "<div class='raccourcis'>" . $raccourci . '</div>';
//        }
            
        return $return;
}

function ciwidget_affiche_raccourci_doc($doc, $id, $align='', $short = false) {

/*
// mis en commentaire car probleme d'accessibilite sous SPIP 4            
         if ($GLOBALS['spip_version_branche']>=4) {
            $pipe = '';
            if ($align) {
                    $pipe = "|$align";
            } 

            $model = "&lt;$doc$id$pipe&gt;";
            $text = $model;
            if ($short) {
                    $text = $align ? $align : $model;
            }

            $classes = "btn btn_link btn_mini";
            $classes = " class=\"$classes\"";

            $styles = '';

            $js = "barre_inserer('$model'); return false;";
            $js = " onmousedown=\"$js\"";

            $title = attribut_html(_T('medias:inserer_raccourci'));
            $title = " title=\"$title\"";

            $return = "\n<button{$classes}{$styles}{$js}{$title}>$text</button>\n";
            
        } else {    
*/    
            $pipe = $onclick = '';

            if ($align) {
                    $pipe = "|$align";
            }

            $onclick = "\nondblclick=\"barre_inserer('\\x3C$doc$id$pipe&gt;', $('textarea[name=texte]')[0]);\"\ntitle=\"" .
                    str_replace(
                            '&amp;',
                            '&',
                            entites_html(_T('medias:double_clic_inserer_doc'))
                    ) . '"';

            if (!$align) {
                    $align = "center";
            }

            $return = "\n<div style='text-align: $align'$onclick>&lt;$doc$id$pipe&gt;</div>\n";
//        }    
        return $return;
}

?>