<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('base/objets');
include_spip('base/abstract_sql');

if (!defined('_PREG_MODELE')){
    define(
            '_PREG_MODELE',
            '(<([a-z_-]{3,})' # <modele
            . '\s*([0-9]*)\s*' # id
            . '([|](?:<[^<>]*>|[^>])*?)?' # |arguments (y compris des tags <...>)
            . '\s*/?' . '>)' # fin du modele >
    );
}

if (!defined('_RACCOURCI_MODELE')){
    define(
            '_RACCOURCI_MODELE',
            _PREG_MODELE
            . '\s*(<\/a>)?' # eventuel </a>
    );
}

if (!defined('_RACCOURCI_MODELE_DEBUT')){
    define('_RACCOURCI_MODELE_DEBUT', '@^' . _RACCOURCI_MODELE . '@isS');
}


function ciwidget_doc_dans_texte($objet='',$id_objet=0,$champs=array()){
    $id_doc_dans_texte = array();
    $contenu_champs = array();
    
    $id_objet = intval($id_objet);
    if (!$champs){
        $champs = array('texte');
    }
    
    if ($champs AND $objet AND $id_objet){
        $table_objet_sql = table_objet_sql($objet);
        $id_table_objet = id_table_objet($objet);
        
        $row = sql_fetsel($champs, $table_objet_sql, "$id_table_objet=".$id_objet);
        if ($row) {
            $contenu_champs = $row;
        }

	// récupérer la liste des modèles qui considèrent un document comme vu s'ils sont utilisés dans un texte
	$modeles = lister_tables_objets_sql('spip_documents');
	$modeles = $modeles['modeles'];
        
       	// detecter les modeles (rapide)
        $texte = implode(' ', $contenu_champs);
	if (strpos($texte, "<") !== false 
		and preg_match_all('/<[a-z_-]{3,}\s*[0-9|]+/iS', $texte, $matches, PREG_SET_ORDER)
	) {
		foreach ($matches as $match) {
			// Recuperer l'appel complet (y compris un eventuel lien)
			$a = strpos($texte, $match[0]);
			preg_match(_RACCOURCI_MODELE_DEBUT, substr($texte, $a), $regs);
                        if (isset($regs[2]) AND in_array($regs[2],$modeles)){
                            $id_doc_dans_texte[] = $regs[3]; 
                        }
                }
        }
    }
    
    return $id_doc_dans_texte;
}

?>